#include <bits/stdc++.h>

using namespace std;

const int N = 6 * 1e5 + 10;

struct Edge{
	int u, v, nxt;
}edges[2 * N];

int n, Head[N], top, f[N], Stack[N], fa[N];
char c[N];
long long tot, ans[N]; 
bool flag = 1;

inline int _read() {
	   int w = 1, s = 0;
	   char ch = getchar();
	   while (ch < '0' || ch > '9') {if (ch == '-') w = -1; ch = getchar();}
	   while (ch >= '0' && ch <= '9') {s = s * 10 + ch - '0'; ch = getchar();}
	   return w * s;
}

void adde(int x, int y) {
	edges[++ tot].u = x;
	edges[tot].v = y;
	edges[tot].nxt = Head[x];
	
	Head[x] = tot;
}

void dfs(int x, int lst) {
	if (c[x] == '(') {
		if (c[fa[x]] == ')') f[x] = f[fa[x]];
		else f[x] = 0;
		Stack[++ top] = x;
		ans[x] = ans[fa[x]];
		
		for (int i = Head[x]; i; i = edges[i].nxt) {
			int y = edges[i].v;
		
			if (y != lst) dfs(y, x);
		}
		
		top --;
	}
	else {
		if (c[Stack[top]] == '(') {
			int tmp = Stack[top];
			f[x] = f[Stack[top]] + 1;
			ans[x] = ans[fa[x]] + f[x];
			top --;
			
			for (int i = Head[x]; i; i = edges[i].nxt) {
				int y = edges[i].v;
				
				if (y != lst) dfs(y, x);
			}
			
			Stack[++ top] = tmp;
		}
		else {
			f[x] = 0;
			ans[x] = ans[fa[x]];
			
			for (int i = Head[x]; i; i = edges[i].nxt) {
				int y = edges[i].v;
				
				if (y != lst) dfs(y, x);
			}
		}
	}
}

int main() {
	
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	
	n = _read();
	
	for (int i = 1; i <= n; i ++)
		c[i] = getchar();
	
	for (int i = 2; i <= n; i ++) {
		int x;
		
		x = _read();
		adde(i, x);
		adde(x, i);
		fa[i] = x;
		if (x != i - 1) flag = 0;
	}
	
	c[0] = ')';
	
	if (!flag) dfs(1, 0);
	
	else {
		for (int i = 1; i <= n; i ++) {
			if (c[i] == '(') {
				if (c[i - 1] == ')') f[i] = f[i - 1];
				else f[i] = 0;
				Stack[++ top] = i;
				ans[i] = ans[i - 1];
			}
			else {
				if (c[Stack[top]] == '(') {
					f[i] = f[Stack[top]] + 1;
					ans[i] = ans[i - 1] + f[i];
					top --;
				}
				else {
					f[i] = 0;
					ans[i] = ans[i - 1];
				}
			}
		}
	}
	
	tot = 0;
	
	for (int i = 1; i <= n; i ++)
		tot = tot ^ (i * ans[i]);
	cout << tot << endl;

	return 0;
}

