#include<bits/stdc++.h>
using namespace std;
const int N = 5e5+100;
typedef long long ll;
#define fr(i,a,b) for(int i = a;i <= b; ++i)
#define nfr(i,a,b) for(int i = a;i >= b; --i)
#define pb push_back

int a[N],n;
struct edge{
	int head[N],nxt[N*2],to[N*2],tot;
	inline void add_edge(int x,int y){
		to[++tot] = y; nxt[tot] = head[x]; head[x] = tot;
	}
}e;

inline int read(){
	int out = 0; char ch;
	for(ch = getchar();ch > '9' || ch < '0';ch = getchar());
	for(;ch >= '0' && ch <= '9'; ch = getchar())
		out = (out<<3)+(out<<1)+(ch&15);
	return out;
}

struct segment_tree{
	int mnv[N*4],sum[N*4],tag[N*4];
	#define lc x<<1
	#define rc x<<1|1
	#define mid (l+r)/2
	
	inline void push_up(int x){
		if(mnv[lc] < mnv[rc]){
			mnv[x] = mnv[lc]; sum[x] = sum[lc];
		} else if(mnv[rc] < mnv[lc]){
			mnv[x] = mnv[rc]; sum[x] = sum[rc];
		} else {
			mnv[x] = mnv[lc]; sum[x] = sum[lc]+sum[rc];
		}
	}
	inline void push_down(int x){
		if(!tag[x])return ;
		tag[lc] += tag[x]; tag[rc] += tag[x];
		mnv[lc] += tag[x]; mnv[rc] += tag[x];
		tag[x] = 0;
	}
	void build(int x,int l,int r){
		if(l == r){
			mnv[x] = 0; sum[x] = 1;
			if(l == 0)mnv[x] = -1;
			return ;
		}
		build(lc,l,mid); build(rc,mid+1,r);
		push_up(x);
	}
	void upd(int x,int l,int r,int ql,int qr,int v){
		if(ql > r || l > qr)return ;
		if(ql <= l && r <= qr){
			tag[x] += v; mnv[x] += v;
			return ;
		}
		push_down(x); upd(lc,l,mid,ql,qr,v); upd(rc,mid+1,r,ql,qr,v); push_up(x);
	}
	int sch(int x,int l,int r){
		if(l == r)return l;
		push_down(x);
		if(mnv[rc] < 0)sch(rc,mid+1,r);
		else return sch(lc,l,mid);
	}
	int query(int x,int l,int r,int ql,int qr){
		if(ql > r || l > qr)return 0;
		if(ql <= l && r <= qr){
			if(mnv[x] == 0)return sum[x];
			else return 0;
		}
		push_down(x);
		return query(lc,l,mid,ql,qr)+query(rc,mid+1,r,ql,qr);
	}
}s;

// right 1 left -1
ll ans,res;
int dep[N];
void dfs(int x){
	s.upd(1,0,n,1,dep[x],a[x]);
	int w = s.query(1,0,n,s.sch(1,0,n)+1,dep[x]);
	res += w;
//	cerr << x <<' ' << w <<' ' << pos << endl;
	ans ^= 1LL*x*res;
	for(register int i = e.head[x];i;i = e.nxt[i]){
		int y = e.to[i];
		dep[y] = dep[x]+1; dfs(y);
	}
	res -= w;
	s.upd(1,0,n,1,dep[x],-a[x]);
}

int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	n = read();
	fr(i,1,n){
		char ch;
		for(ch = getchar();ch != '(' && ch != ')';ch = getchar());
		if(ch == ')')a[i] = 1;
		else a[i] = -1;
	}
	fr(i,2,n){
		int u; u = read();
		e.add_edge(u,i);
	}
	dep[1] = 1; s.build(1,0,n); dfs(1);
	printf("%lld\n",ans);
	return 0;
}
