#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for(int i = 0; i < (n); i ++)
#define rep1(i, n) for(int i = 1; i <= (n); i ++)
 
typedef long long LL;
typedef pair<int, int> PII;

int n;
char dat[500005];
int par[500005];
vector<int> chi[500005];
int psum[500005];
int sta[500005], ssz;
LL ans[500005];

void dfs(int v)
{
	psum[v] += dat[v] == '(' ? 1 : -1;
	int osz = ssz, opos = upper_bound(sta, sta + ssz, psum[v]) - sta, odat = sta[opos];
	ans[v] += sta + opos - lower_bound(sta, sta + ssz, psum[v]);
	ssz = opos + 1;
	sta[opos] = psum[v];
	rep(i, chi[v].size()) {
		int u = chi[v][i];
		psum[u] = psum[v];
		ans[u] = ans[v];
		dfs(u);
	}
	ssz = osz;
	sta[opos] = odat;
}

int main()
{
#ifndef NON_FILE_IO
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
#endif
	
	scanf("%d%s", &n, dat + 1);
	for(int i = 2; i <= n; i ++) {
		scanf("%d", &par[i]);
		chi[par[i]].push_back(i);
	}
	
	ssz = 1;
	sta[0] = 0;
	dfs(1);
	
	LL cans = 0;
	rep1(i, n) cans ^= ans[i] * i;
	printf("%lld\n", cans);
	return 0;
}
