#include<bits/stdc++.h>
using namespace std;

#define rep(i,n) for(int i=0;i<(n);i++)
#define REP(i,n) for(int i=1;i<=(n);i++)
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
typedef long long ll;
typedef pair<int,int> pii;

const int maxn=2005;
int test,n,tot,res;
int pos[maxn],u[maxn],v[maxn],a[maxn],b[maxn],p[maxn],cur[maxn];
int head[maxn],nxt[maxn*2],to[maxn*2],id[maxn*2],par[maxn],pare[maxn];
int go[maxn],ans[maxn],deg[maxn];
bool lim[maxn][maxn],vis[maxn]; 
void addedge(int u,int v,int i){
	tot++;
	nxt[tot]=head[u];
	to[tot]=v;
	id[tot]=i;
	head[u]=tot;
}

namespace Dsu{
	int f[maxn];
	void init(){
		REP(i,n)f[i]=i;
	}
	int find(int x){
		return f[x]==x?x:f[x]=find(f[x]);
	}
	void merge(int x,int y){
		f[find(x)]=find(y);
	}
}

void dfs(int x,int p,int pe){
	par[x]=p;
	pare[x]=pe;
	bool ok=true;
	for(int i=head[x];i;i=nxt[i])
		if(lim[pe][id[i]])ok=false;
	if(p&&ok&&!vis[x])res=min(res,x);
	for(int i=head[x];i;i=nxt[i]){
		if(to[i]==p)continue;
		if(lim[id[i]][pe])continue;
		if(!p){
			bool ok=true;
			for(int j=head[x];j;j=nxt[j])
				if(id[j]!=id[i]&&lim[id[j]][id[i]])ok=false;
			if(!ok)continue;
		}
		dfs(to[i],x,id[i]);
	}
}

void solve_chain(){
	REP(i,n){
		REP(j,n)lim[i][j]=false;
		vis[i]=false;
	}
	REP(i,n){
		res=n+1;
		dfs(pos[i],0,0);
		ans[i]=res;
		int j=par[res],e=pare[res];
		while(j!=pos[i]){
			lim[pare[j]][e]=true;
			e=pare[j];
			j=par[j];
		}
		for(int j=head[pos[i]];j;j=nxt[j])
			if(id[j]!=e)lim[e][id[j]]=true;
		for(int j=head[res];j;j=nxt[j])
			if(id[j]!=pare[res])lim[id[j]][pare[res]]=true;
		vis[res]=true;
	}
}

void solve_star(){
	REP(i,n){
		vis[i]=false;
		go[i]=0;
	}
	Dsu::init();
	int rt,fir=0,last=0,cnt=n-1;
	REP(i,n)if(deg[i]==n-1)rt=i;
	REP(i,n-1){
		if(u[i]==rt)pare[v[i]]=i;
		else pare[u[i]]=i;
	}
	REP(i,n)REP(j,n)if(!vis[j]&&j!=pos[i]){
		if(pos[i]!=rt&&j!=rt){
			if(pare[j]!=fir&&Dsu::find(pare[pos[i]])!=Dsu::find(pare[j])){
				if(fir&&last&&i!=n){
					int uu=Dsu::find(fir),vv=Dsu::find(last);
					if(uu==Dsu::find(pare[pos[i]])&&vv==Dsu::find(pare[j]))continue;
					if(vv==Dsu::find(pare[pos[i]])&&uu==Dsu::find(pare[j]))continue;
				}
				ans[i]=j;
				go[pare[pos[i]]]=pare[j];
				Dsu::merge(pare[pos[i]],pare[j]);
				cnt--;
				vis[j]=true;
				break;
			}
		}
		else if(pos[i]==rt&&j!=rt){
			if(pare[j]!=last){
				if(last&&i!=n&&Dsu::find(pare[j])==Dsu::find(last))continue;
				fir=pare[j];
				ans[i]=j;
				vis[j]=true;
				break;
			}
		}
		else{
			if(pare[pos[i]]!=fir&&!go[pare[pos[i]]]){
				if(fir&&i!=n&&Dsu::find(pare[j])==Dsu::find(fir))continue;
				last=pare[pos[i]];
				ans[i]=j;
				vis[j]=true;
				break;
			}
		}
	}
}

int main(){
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	scanf("%d",&test);
	while(test--){
		scanf("%d",&n);
		tot=0;
		REP(i,n)head[i]=deg[i]=0;
		REP(i,n){
			scanf("%d",&pos[i]);
			a[pos[i]]=i;
		}
		REP(i,n-1){
			scanf("%d%d",&u[i],&v[i]);
			addedge(u[i],v[i],i);
			addedge(v[i],u[i],i);
			deg[u[i]]++;
			deg[v[i]]++;
			p[i]=i;
		}
		if(n<=10){
			ans[1]=n+1;
			do{
				REP(i,n)b[i]=a[i];
				REP(i,n-1)swap(b[u[p[i]]],b[v[p[i]]]);
				REP(i,n)cur[b[i]]=i;
				bool ok=false;
				REP(i,n)if(cur[i]!=ans[i]){
					ok=(cur[i]<ans[i]);
					break;
				}
				if(ok)REP(i,n)ans[i]=cur[i];
			}while(next_permutation(p+1,p+n));
		}
		else{
			int mx=0;
			REP(i,n)mx=max(mx,deg[i]);
			if(mx<=2)solve_chain();
			else if(mx==n-1)solve_star();
		}
		REP(i,n)printf("%d%c",ans[i],i==n?'\n':' ');
	}
	return 0;
}
