#include <bits/stdc++.h>
#define _rep(i, x, y) for(int i = x; i <= y; i++)
#define _per(i, x, y) for(int i = x; i >= y; i--)
#define LL long long
#define LD long double
#define ULL unsigned long long
using namespace std;
template <typename T>
inline void read(T &x) {
	x = 0; T f = (T) 1;
	char c = getchar();
	for(; !isdigit(c); c = getchar()) {
		if(c == '-') f = -f;
	}
	for(; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	x *= f;
}
template <typename T>
inline void write(T x) {
	if(x < 0) {x = -x; putchar('-');}
	if(x > 9) write(x / 10);
	putchar(x % 10 + '0');
}
template <typename T>
inline void writesp(T x, char sp = '\n') {
	write(x); putchar(sp);
}
void file(string name) {
	freopen((name + ".in").c_str(), "r", stdin);
	freopen((name + ".out").c_str(), "w", stdout);
}
const int maxN = 2e3 + 5;
int T;
int n;
bool chain, flower;
int num[maxN], deg[maxN], c[maxN][maxN], x[maxN], y[maxN];
int perm[maxN], newnum[maxN], newnnum[maxN], ansnum[maxN];
void check() {
	int flg = 1;
	_rep(i, 1, n) {
		if(newnnum[i] > ansnum[i]) {
			flg = 0; break;
		} else if(newnnum[i] < ansnum[i]) {
			break;
		}
	} 
	if(flg) {
		_rep(i, 1, n) {
			ansnum[i] = newnnum[i];
		}
	}
}
void brute() {
	_rep(i, 1, n - 1) perm[i] = i;
	ansnum[1] = 998244353;
	do {
		_rep(i, 1, n) newnum[i] = num[i];
		_rep(i, 1, n - 1) {
			swap(newnum[x[perm[i]]], newnum[y[perm[i]]]);
		}
		_rep(i, 1, n) {
			newnnum[newnum[i]] = i; 
		}
//		if(perm[1] == 1 && perm[2] == 4 && perm[3] == 3 && perm[4] == 2 && n == 5) {
//			_rep(i, 1, n) writesp(newnum[i]);
//		}
		check();
	} while(next_permutation(perm + 1, perm + n));
	_rep(i, 1, n) {
		writesp(ansnum[i], (i == n ? '\n' : ' '));
	}
}
int vis[maxN], q[maxN], prev[maxN], h = 0, t = 0;
void move(int number, int position) {
	int initial = num[number];
	q[++t] = initial;
	prev[t] = 1;
	vis[initial] = true;
	while(h < t) {
		int u = q[++h];
		if(u == position) {
			for(int i = h; prev[i]; i = prev[i]) {
				swap(num[q[i]], num[q[prev[i]]]);
				deg[q[i]]--; deg[q[prev[i]]]--;
			}
			return;
		}
		_rep(i, 1, n) {
			if(c[u][i] && !vis[i]) {
				q[++t] = i;
				prev[t] = h;
				vis[i] = true;
			}
		}
	}
}
void chainwork() {
	_rep(i, 1, n) {
		if(num[i] == i) {
			int k = 0;
			_rep(j, i + 1, n) {
				if(deg[j]) {
					k = j; break;
				}
			}
			move(i, k);
		} else {
			int k = 0;
			_rep(j, i, n) {
				if(deg[j]) {
					k = j; break;
				}
			}
			move(i, k);
		}
	}_rep(i, 1, n) {
		writesp(num[i], (i == n ? '\n' : ' '));
	}
}
void flowerwork(int k) {
	_rep(i, 1, n) {
		int q = 0;
		_rep(j, 1, n) {
			if(i == num[j]) continue;
			if(deg[num[j]]) {
				q = num[j]; break;
			}
		}
		if(q == k) {
			deg[k]--; deg[q]--;
			swap(num[q], num[k]);
		} else {
			deg[k] -= 2; deg[i]--; deg[q]--;
	//		int q = num[k], v = num[i];
			num[i] = num[k];
			num[k] = num[q];
			num[q] = i;
		}	
	}
	_rep(i, 1, n) {
		writesp(num[i], (i == n ? '\n' : ' '));
	}
}
int main() {
	file("tree");
	read(T);
	while(T--) {
		chain = flower = true;
		memset(c, 0, sizeof(c));
		read(n);
		_rep(i, 1, n) {
			int x; read(x);
			num[x] = i;
		//	read(k[i]);
		}
		_rep(i, 1, n - 1) {
			read(x[i]); read(y[i]);
			if(abs(x[i] - y[i]) != 1) 
			c[x[i]][y[i]] = c[y[i]][x[i]] = 1;
			deg[x[i]]++; deg[y[i]]++;
		}
		int centre = 0;
		_rep(i, 1, n) {
			if(deg[i] >= 3) chain = false;
			if(deg[i] >= 2 && deg[i] != n - 1) flower = false;
			if(deg[i] == n - 1) {
				centre = i;
			}
		}
		if(n <= 10) {
			brute();
		} else if(chain) {
			chainwork();
		} else if(flower) {
			flowerwork(centre);
		}
	}
	return 0;
}

