#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int,int>
#define qi ios::sync_with_stdio(0)
template<typename T1,typename T2> ostream& operator<<(ostream& os,pair<T1,T2> p) {
	os<<"("<<p.first<<" "<<p.second<<")";
	return os;
}
template<typename T> ostream& operator<<(ostream& os,vector<T> v) {
	os<<"{";
	for(int i=0; i<v.size(); i++) {
		os<<v[i]<<",";
	}
	os<<"}";
	return os;
}

/*
Drain all the blood from your enemies, my lord!

XGN from HHS 2019
*/

int n;
string s;
vector<int> nei[500005];



namespace Subtask1 {
	ll ans[500005];

	string tmp;
	int ts;

	void dfs(int pos,int fa) {
		if(tmp.size()>ts) {
			tmp[ts]=s[pos];
		} else {
			tmp+=s[pos];
		}
		ts++;

		int delta=0,dk=0;

		//	cout<<tmp<<endl;
		for(int i=ts-1; i>=0; i--) {
			delta+=(tmp[i]=='('?1:-1);
			if(delta>0) {
				break;
			}
			if(delta==0) {
				dk++;
			}
		}

		ans[pos]=(fa==-1?0:ans[fa])+dk;

		for(int i=0; i<nei[pos].size(); i++) {
			if(nei[pos][i]==fa) {
				continue;
			}
			dfs(nei[pos][i],pos);
		}

		ts--;
	}

	void solve() {
		dfs(0,-1);

		ll t=0;
		for(int i=0; i<n; i++) {
			t^=(ans[i]*(i+1));
		}
		cout<<t<<endl;
	}
}

namespace Subtask2 {

	ll endWith[500005];

	ll deltas[500005],_[500005];

	queue<pii> q;
	
	int times;
	
	void dfs(int pos,ll delta,int fa) {
		times++;
		
//	assert(endWith[pos]==0);
		endWith[pos]=(fa==-1?0:endWith[fa]);

//		cout<<pos<<" "<<delta<<" "<<fa<<endl;

		if(s[pos]=='(') {
			//left bracket
			delta++;
			deltas[delta]++;

			for(int i=0; i<nei[pos].size(); i++) {
				if(nei[pos][i]==fa) {
					continue;
				}
				dfs(nei[pos][i],delta,pos);
			}

			deltas[delta]--;
		} else {
			//right bracket
//			cout<<"DELTA="<<delta<<" so add"<<deltas[delta]<<" and become "<<endWith[pos]<<endl;
			endWith[pos]+=deltas[delta];
			delta--;
			if(delta<0) {

				for(int i=0; i<nei[pos].size(); i++) {
					if(nei[pos][i]==fa) {
						continue;
					}
					q.push(make_pair(nei[pos][i],pos));
				}
				return;
			}

			for(int i=0; i<nei[pos].size(); i++) {
				if(nei[pos][i]==fa) {
					continue;
				}
				dfs(nei[pos][i],delta,pos);
			}
		}
	}
	
	void solve(){
		q.push(make_pair(0,-1));
		while(!q.empty()){
			pii last=q.front();
			q.pop();
			
			for(int i=0;i<times+5;i++){
				deltas[i]=0;
			}
			
			times=0;
			dfs(last.first,0,last.second);
		}
		
//		for(int i=0;i<n;i++){
//			cout<<endWith[i]<<endl;
//		}
		
		ll ans=0;
		for(int i=0;i<n;i++){
			ans^=((i+1)*endWith[i]);
		}
	//	push(0,-1);
		
		cout<<ans<<endl;
	}
}
int main() {
#ifndef XGN
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
#endif

	qi;
	cin>>n>>s;
	for(int i=0; i<n-1; i++) {
		int x;
		cin>>x;
		nei[i+1].push_back(x-1);
		nei[x-1].push_back(i+1);
	}

	if(n<=10000) {
		Subtask1::solve();
	} else {
		Subtask2::solve();
	}

	return 0;
}

