#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int,int>
#define qi ios::sync_with_stdio(0)
template<typename T1,typename T2> ostream& operator<<(ostream& os,pair<T1,T2> p){
	os<<"("<<p.first<<" "<<p.second<<")";
	return os;
}
template<typename T> ostream& operator<<(ostream& os,vector<T> v){
	os<<"{";
	for(int i=0;i<v.size();i++){
		os<<v[i]<<",";
	}
	os<<"}";
	return os;
}

/*
Drain all the blood from your enemies, my lord!

XGN from HHS 2019
*/

int n;
vector<int> nei[2005];
pii edge[2005];
int p[2005];

void init(){
	for(int i=0;i<n;i++){
		nei[i].clear();
	}
}

namespace Subtask1{
	int pe[15];
	int tmp[15];
	int ans[15];
	int tmp2[15];
	void solve(){
		for(int i=0;i<n;i++){
			pe[i]=i;
			ans[i]=1e9;
		}
		
//		for(int i=0;i<n;i++){
//				cout<<ans[i]<<" ";
//			}
//			cout<<endl;
			
		do{
			for(int i=0;i<n;i++){
				tmp[i]=p[i];
			}
			
			for(int i=0;i<n-1;i++){
				swap(tmp[edge[pe[i]].first],tmp[edge[pe[i]].second]);
			}
			
//			for(int i=0;i<n-1;i++){
//				cout<<pe[i]<<" "<<edge[pe[i]]<<endl;
//			}
//			cout<<endl;
//			for(int i=0;i<n;i++){
//				cout<<tmp[i]<<" ";
//			}
//			cout<<endl;
			
			for(int i=0;i<n;i++){
				tmp2[tmp[i]]=i;
			}
			
//			for(int i=0;i<n;i++){
//				cout<<ans[i]<<" ";
//			}
//			cout<<endl;
			bool ok=false;
			for(int i=0;i<n;i++){
				if(tmp2[i]!=ans[i]){
					if(tmp2[i]<ans[i]){
						ok=true;
					}else{
						ok=false;
					}
					break;
				}
			}
			
			if(ok){
				for(int i=0;i<n;i++){
					ans[i]=tmp2[i];	
				}
			}
		}while(next_permutation(pe,pe+n-1));
		
		for(int i=0;i<n;i++){
			cout<<ans[i]+1<<" ";
		}
		cout<<endl;
	}
}

namespace Subtask2{
	vector<int> chain;
	
	void dfs(int pos,int fa){
		chain.push_back(pos);
		for(int i=0;i<nei[pos].size();i++){
			if(nei[pos][i]==fa){
				continue;
			}
			dfs(nei[pos][i],pos);
		}
	}
	
	int locate[2005];
	int chainpos[2005];
	bool ok[2005];
	bool used[2005];
	int ans[2005];
	int col[2005];
	
	void solve(){
		
		memset(locate,0,sizeof(locate));
		memset(chainpos,0,sizeof(chainpos));
		chain.clear();
		memset(ok,true,sizeof(ok));
		memset(used,0,sizeof(used));
		memset(ans,0,sizeof(ans));
		
		for(int i=0;i<n;i++){
			if(nei[i].size()==1){
				dfs(i,-1);
				break;
			}
		}
		
		for(int i=0;i<n;i++){
			locate[p[chain[i]]]=i;
			
			chainpos[chain[i]]=i;
			col[i]=p[chain[i]];
		}
		
//		cout<<"Chain:"<<chain<<endl;
		
		for(int i=0;i<n;i++){
			
			int loc=-1;
			int mn=1e9;
			
			for(int j=0;j<n;j++){
				if(col[j]==i){
					loc=j;
					break;
				}
			}
//			cout<<"Looing at num "<<i<<" at "<<loc<<endl;
//			
//			
//			for(int j=0;j<n;j++){
//				cout<<col[j]<<" ";
//			}
//			cout<<endl;
			
			
			for(int j=loc;j<n;j++){
				if(!used[j]){
//					cout<<"Comparing "<<chain[j]<<" at"<<j<<endl;
					mn=min(mn,chain[j]);	
				}
				if(!ok[j]){
					break;
				}
			}
			
			for(int j=loc;j>=0;j--){
				if(!used[j]){
//					cout<<"Comparing "<<chain[j]<<" at"<<j<<endl;
					mn=min(mn,chain[j]);	
				}
				
				if(j==0 || !ok[j-1]){
					break;
				}
			}
			
//			cout<<"We've chosen "<<mn<<endl;
			used[chainpos[mn]]=true;
			ans[i]=mn;
			
			//remove edge
			int st=loc;
			int ed=chainpos[mn];
			
//			cout<<st<<" "<<ed<<endl;
			
			if(st>ed){
				for(int j=st;j>ed;j--){
					swap(col[j],col[j-1]);
					ok[j-1]=false;
//					cout<<"Connection from "<<j-1<<" to "<<j<<" is dead"<<endl;
				}
			}else{
				for(int j=st;j<ed;j++){
					swap(col[j],col[j+1]);
					ok[j]=false;
//					cout<<"Connection from "<<j<<" to "<<j+1<<" is dead"<<endl;
				}
			}
			
		}
		
		for(int i=0;i<n-1;i++){
			if(ok[i]){
				swap(col[i],col[i+1]);
			}
		}
		
		for(int i=0;i<n;i++){
			ans[col[i]]=chainpos[i];
		}
		for(int i=0;i<n;i++){
			cout<<ans[i]+1<<" ";
		}
		cout<<endl;
	}
}

void solve(){
	cin>>n;
	
	init();
	
	for(int i=0;i<n;i++){
		int x;
		cin>>x;
		x--;
		p[x]=i;
	}
	for(int i=0;i<n-1;i++){
		int a,b;
		cin>>a>>b;
		a--;b--;
		nei[a].push_back(b);
		nei[b].push_back(a);
		edge[i]=make_pair(a,b);
	}
	
	if(n<=10){
		Subtask1::solve();
	}else{
		Subtask2::solve();
	}
}

int main(){
	#ifndef XGN
		freopen("tree.in","r",stdin);
		freopen("tree.out","w",stdout);
	#endif
	qi;
	int T;
	cin>>T;
	while(T--){
		solve();
	}
	return 0;
}

