#include<cstdio>
#include<vector>
#include<algorithm>
using namespace std;
typedef long long ll;
const int MAXN = 500005;
short a[MAXN];
struct Edge{
	int to, next;
	Edge(int to=0, int next=0):to(to), next(next) {}
} e[MAXN];
int cnt=0, head[MAXN];
void addEdge(int u, int v){
	// printf("%d %d\n", u, v);
	e[cnt]=Edge(v, head[u]);
	head[u] = cnt++;
}
int n;
namespace Subtask1{
	vector<int> num[MAXN*2];
	int pre[MAXN], tag[MAXN];
	void solve2(){
		ll ans=0, dp=0;
		for(int i=1; i<=n; i++) {
			pre[i]=pre[i-1]+(a[i]?-1:1);
			num[pre[i]+n].push_back(i);
			if(!a[i] && !num[pre[i]+n+1].empty()) tag[i]=num[pre[i]+n+1][num[pre[i]+n+1].size()-1];
		}
		for(int i=1; i<=n; i++){
			if(a[i]) {ans^=i*dp;continue;}
			vector<int>& cur = num[pre[i]+n];
			int r = lower_bound(cur.begin(), cur.end(), i+1) - cur.begin();
			int l=0;
			if(tag[i]) l = lower_bound(cur.begin(), cur.end(), tag[i]) - cur.begin();
			dp+=(r-l);

			ans^=i*dp;
		}
		printf("%lld\n", ans);
	}
	void solve(){
		ll ans=0, dp=0;
		for(int i=1; i<=n; i++){
			int cnt=0;
			for(int j=i; j; j--) {
				if(!a[j]) cnt++;
				else cnt--;
				if(cnt==0) dp++;
				else if(cnt<0) break;
			}
			ans^=(ll)i*dp;

		}
		printf("%lld\n", ans);
	}
}
int main(){
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	int f=1;
	scanf("%d", &n);
	getchar();
	for(int i=1; i<=n; i++) {
		char ch = getchar();
		a[i]=(ch=='(');
	}
	for(int i=2; i<=n; i++) {
		int x;
		scanf("%d", &x);
		addEdge(x, i);
		if(f && x!=i-1) f=0;
	}
	if(n<=2000) Subtask1::solve(); else Subtask1::solve2();
	return 0;
}
