#include<bits/stdc++.h>
using  namespace std;
typedef long long ll;
typedef pair<int,int> pii;

const int INF = 0x3f3f3f3f;
const int MAXN = 5e5 + 5;

int n,len,top;
ll ans;
ll cnt[MAXN],res[MAXN];
int head[MAXN],val[MAXN],f[MAXN],st[MAXN],tmp[MAXN];
char str[MAXN];

struct Edge{
	int to,next;
} e[MAXN << 1];

void add(int u,int v){
	e[++len].to = v;
	e[len].next = head[u];
	head[u] = len; 
}

void dfs1(int u,stack<int> st){
	//cout << u << " " << top << endl;
	if(st.size() && val[u] == 1){
		//cout << u << " " << st[top] << " " << cnt[f[st[top]]] << endl;
		cnt[u] = cnt[f[st.top()]] + 1;
		st.pop();
	}else if(val[u] == -1)
	    st.push(u);
	for(int i = head[u];i != -1;i = e[i].next){
		int v = e[i].to;
		if(v == f[u])
		    continue;
		f[v] = u;
		dfs1(v,st);
	}
}

void dfs2(int u){
	res[u] = res[f[u]] + cnt[u];
	for(int i = head[u];i != -1;i = e[i].next){
		int v = e[i].to;
		if(v == f[u])
		    continue;
		dfs2(v);
	}
}

int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	memset(head,-1,sizeof(head));
	scanf("%d",&n);
	scanf("%s",str + 1);
	for(int i = 1;i <= n;i++)
	    val[i] = (str[i] == '(') ? -1 : 1;
	for(int i = 2;i <= n;i++){
		int x;
		scanf("%d",&x);
		add(i,x);
		add(x,i);
	}
	stack<int> st;
	dfs1(1,st);
	dfs2(1);
//	for(int i = 1;i <= n;i++)
//	    cout << cnt[i] << " ";
//	cout << endl;
//	for(int i = 1;i <= n;i++)
//	    cout << res[i] << " ";
//	cout << endl;
	for(int i = 1;i <= n;i++)
	    ans ^= (i * res[i]);
	printf("%lld\n",ans);
	return 0;
}

