#include <fstream>
using namespace std;
typedef long long LL;

ifstream fin("tree.in");
ofstream fout("tree.out");

struct edge{
	int u,v,nex;
}e[2005];
int nod[2005],head[2005],p[2005],cnt;
bool del[2005];
void add_e(int a,int b){
	cnt++;
	e[cnt].u=a;
	e[cnt].v=b;
	e[cnt].nex=head[a];
	head[a]=cnt;
}
int n;
bool has_sol;
int ans_p[2005];
void check(){
	//cout<<"!";
	if(has_sol==false){
		for(int i=1;i<=n;i++){
			ans_p[i]=p[i];
		}
		has_sol=true;
		return;
	}
	bool has_small=false;
	for(int i=1;i<=n;i++){
		if(has_small==false && p[i]>ans_p[i])
			return;
		if(p[i]<ans_p[i])has_small=true;
		ans_p[i]=p[i];
	}
	return;
}
void dfs(int c){
	if(c==n-1){
		check();
		return;
	}
	for(int i=1;i<=cnt;i++){
		if(del[i])continue;
		del[i]=true;
		swap(p[nod[e[i].u]],p[nod[e[i].v]]);
		swap(nod[e[i].u],nod[e[i].v]);
		dfs(c+1);
		swap(p[nod[e[i].u]],p[nod[e[i].v]]);
		swap(nod[e[i].u],nod[e[i].v]);
		del[i]=false;
	}
}
void try_mov(int thisnum){
	int id=p[thisnum];
	int curr_cnt=0,num=nod[id];
	bool is_mid=false;
	for(int i=head[id];i;i=e[i].nex){
		curr_cnt++;
		if(curr_cnt>5){
			is_mid=false;
		}
	}
	if(!is_mid){
		if(del[head[id]])return;
		int want=head[id];
		swap(p[nod[e[want].u]],p[nod[e[want].v]]);
		swap(nod[e[want].u],nod[e[want].v]);
		for(int i=head[e[want].v];i;i=e[i].nex){
			if(e[i].v==id){
				del[i]=true;
				break;
			}
		}
	}
	if(del[head[id]])return;
	int min_nod=n;
	for(int i=head[id];i;i=e[i].nex){
		if(del[i])continue;
		min_nod=min(min_nod,e[i].v);
	}
	del[min_nod]=true;
	for(int i=head[e[min_nod].v];i;i=e[i].nex){
		if(e[i].v==id){
			del[i]=true;
			break;
		}
	}
	swap(p[nod[e[min_nod].u]],p[nod[e[min_nod].v]]);
	swap(nod[e[min_nod].u],nod[e[min_nod].v]);
}
void mainrun(){
	has_sol=false;
	cnt=0;
	fin>>n;
	for(int i=1;i<=n;i++){
		int tmp;fin>>tmp;
		nod[tmp]=i;
		p[i]=tmp;
	}
	for(int i=1;i<n;i++){
		int a,b;
		fin>>a>>b;
		add_e(a,b);
	}
	if(n<=10){
		dfs(0);
		for(int i=1;i<=n;i++){
			fout<<ans_p[i]<<" ";
		}
		fout<<"\n";
		return;
	}
	for(int i=1;i<=n;i++){
		try_mov(i);
	}
	for(int i=1;i<=n;i++){
		fout<<p[i]<<" ";
	}
	return;
}
int main(){
	int T;
	fin>>T;
	while(T--){
		mainrun();
	}
	return 0;
}
