#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<queue>
#include<cstring>
using namespace std;
const int MAXN=5*100000+5;

struct edge
{
	int u,v;
	int next;
}E[MAXN*2];
int n,fa[MAXN],a[MAXN];
long long f[MAXN];
string s;
int header[MAXN],tot=0;
int v[MAXN];

void addEdge(int u,int v)
{
	E[++tot].u=u;E[tot].v=v;
	E[tot].next=header[u];header[u]=tot;
}

void bfs(int x)
{
	queue <int> q;
	v[x]=1;q.push(x);
	while(q.size())
	{
		int y=q.front();q.pop();
		for(int i=header[y];i;i=E[i].next)
		{
			int z=E[i].v;
			if(v[z]) continue;
			f[z]+=f[y];
			v[z]=1;q.push(z);
		}
	}
}

int main()
{
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d",&n);
	cin>>s;
	for(int i=1;i<=n-1;++i)
	{
		scanf("%d",&fa[i+1]);
		addEdge(i+1,fa[i+1]);addEdge(fa[i+1],i+1);
	}
	fa[1]=0;
	for(int i=1;i<=n;++i)
	{
		if(s[i-1]=='(') a[i]=-1;
		if(s[i-1]==')') a[i]=1;
	}
	a[0]=0;
	//Ż ֻҵһ 
	for(int i=1;i<=n;++i)
	{
		if(a[i]==-1) f[i]=0;
		else
		{
			int sum=a[i],j=i;
			while(j!=0&&sum>0)
			{
				j=fa[j];
				sum+=a[j];
				if(sum==0) f[i]=f[fa[j]]+1;
			}
		}
	}
	bfs(1);
	long long answer=0;
	for(int i=2;i<=n;++i)
	{
		answer=(1ll*i*f[i])^answer;
	}
	printf("%lld\n",answer);
	return 0;
}
