#include <bits/stdc++.h>
#define LL		long long
#define Maxn	500500
using namespace std;
template <typename tn> void read(tn &a){
	tn x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - 48;
	a = x * f;
}

const int C = 500010;

vector <int> vec[Maxn * 2];
struct Edge{ int v, next; } edge[Maxn * 2];
int first[Maxn], stk[Maxn], val[Maxn], s[Maxn];
LL ans[Maxn];
string st;
int n, Top, cstk; LL Ans;

struct Segment_tree{
	int val[Maxn * 8]; set <int> S[Maxn * 2];
	void init(){ memset(val, -1, sizeof val); }
	void modify(int pos, int P, int x, int typ, int l, int r){
		if (l == r){
			int id = l + C;
			if (typ == 1) S[id].insert(x);
			else S[id].erase(x);
			if (S[id].size()) val[pos] = (*(--S[id].end()));
			else val[pos] = -1;
			return;
		}
		int son1 = pos << 1, son2 = pos << 1 | 1, mid = (l + r) >> 1;
		if (P <= mid) modify(son1, P, x, typ, l, mid);
		else modify(son2, P, x, typ, mid + 1, r);
		val[pos] = max(val[son1], val[son2]);
	}
	void ins(int x, int y){ modify(1, x, y, 1, -n, n); }
	void del(int x, int y){ modify(1, x, y, -1, -n, n); }
	int query(int pos, int L, int R, int l, int r){
		if (L <= l && R >= r) return val[pos];
		int son1 = pos << 1, son2 = pos << 1 | 1, mid = (l + r) >> 1, ans = -1;
		if (L <= mid) ans = query(son1, L, R, l, mid);
		if (R > mid) ans = max(ans, query(son2, L, R, mid + 1, r));
		return ans;
	}
	int query(int L, int R){ return query(1, L, R, -n, n); }
} Sgt;

void addedge(int u, int v){
	edge[++Top] = (Edge) {v, first[u]};
	first[u] = Top;
}

int findcnt(int sr, int minl){
	int id = sr + C, lft = 0, rgt = vec[id].size() - 1, ans = rgt + 1;
	while (lft <= rgt){
		int mid = (lft + rgt) >> 1;
		if (vec[id][mid] < minl) lft = mid + 1;
		else rgt = mid - 1, ans = mid;
	}
	return vec[id].size() - ans; 
}
int calc(int sr){
	int minl = Sgt.query(-n, sr - 1); // zai minl de difang xiebi
	return findcnt(sr, minl);
}

void pushin(int u){
	stk[++cstk] = val[u];
	s[cstk] = s[cstk - 1] + val[u];
	Sgt.ins(s[cstk], cstk + 1);
	vec[s[cstk] + C].push_back(cstk);
}

void popout(){
	Sgt.del(s[cstk], cstk + 1);
	vec[s[cstk] + C].pop_back();
	cstk--;
}

void dfs(int u, int fa){
	ans[u] = ans[fa] + calc(s[cstk] + val[u]);
	Ans ^= (LL) u * ans[u];
	pushin(u);
	for (int i = first[u]; i; i = edge[i].next){
		int v = edge[i].v;
		if (v != fa) dfs(v, u);
	}
	popout();
}

int main(){
	freopen("brackets.in", "r", stdin), freopen("brackets.out", "w", stdout);
	read(n), cin >> st;
	for (int i = 1; i <= n; i++)
		val[i] = st[i - 1] == '(' ? 1 : -1;
	for (int i = 2, fa; i <= n; i++)
		read(fa), addedge(fa, i);
	Sgt.init(), Sgt.ins(0, 1), vec[C].push_back(0);
	dfs(1, 0);
	cout << Ans << '\n';
	return 0;
}
