#include <bits/stdc++.h>
using namespace std;
const int MAXN = 5e5 + 10;
template <class T>
inline void _read(T &x)
{
	x = 0;
	char t = getchar();
	while (!isdigit(t) && t != '-') t = getchar();
	if (t == '-')
	{
		_read(x);
		x *= -1;
		return ;
	}
	while (isdigit(t))
	{
		x = x * 10 + t - '0';
		t = getchar();
	}
}
int T;
int n;
int pos[MAXN], fa[MAXN];
bool todel[MAXN];
int deg[MAXN], on[MAXN];
vector <int> G[MAXN];
inline void del(int u, int v)
{
//	cout << "u : " << u << "v : " << v << endl;
	pos[on[u]] = v, pos[on[v]] = u;
	swap(on[u], on[v]);
	for (vector <int>::iterator i = G[u].begin(); i != G[u].end(); ++i)
		if ((*i) == v)
		{
			G[u].erase(i);
			break;
		}
//	cout << "hey!" << endl;
	for (vector <int>::iterator i = G[v].begin(); i != G[v].end(); ++i)
		if ((*i) == u)
		{
			G[v].erase(i);
			break;
		}
}
int nowmin = 0;
inline void fmin(int x, int fx)
{
	nowmin = min(x, nowmin);
	for (vector <int>::iterator i = G[x].begin(); i != G[x].end(); ++i)
	{
		int u = *i;
		if (u != fx)
			fmin(u, x);
	}
}
vector <int> DEL;
inline void tod(int x, int fx, int tar)
{
	if (x == tar)
	{
		todel[x] = 1;
		return ;
	}
	for (vector <int>::iterator i = G[x].begin(); i != G[x].end(); ++i)
	{
		int u = *i;
		if (u != fx) tod(u, x, tar);
		if (todel[u] == 1)
		{
			todel[x] = 1;
			DEL.push_back(u);
			return ;
		}
	}
}
inline void work1()
{
	for (int i = 1; i <= n; ++i)
	{
		int po = pos[i];
		nowmin = 1e9;
		fmin(po, 0);
		fill(todel, todel + 1 + n, 0);
		DEL.clear();
		tod(po, 0, nowmin);
		DEL.push_back(po);
		reverse(DEL.begin(), DEL.end());
		for (int i = 0; i < DEL.size() - 1; ++i)
			del(DEL[i], DEL[i + 1]);
	}
	for (int i = 1; i <= n; ++i)
		printf("%d ", pos[i]);
	puts("");
}
int ans[MAXN];
inline bool comp(int *a, int *b)
{
	for (int i = 1; i <= n; ++i)
	{
		if (a[i] < b[i])
			return 1;
	}
	return 0;
}
int from[MAXN], to[MAXN], p[MAXN], tpos[MAXN], ton[MAXN];
vector <int> M[MAXN];
inline void bf()
{
	for (int i = 1; i <= n; ++i) ans[i] = n - i + 1;
	for (int i = 1; i <= n; ++i) M[i] = G[i];
	for (int i = 1; i < n; ++i) p[i] = i;
	for (int i = 1; i <= n; ++i) tpos[i] = pos[i], ton[i] = on[i];
	do
	{
		for (int i = 1; i <= n; ++i) pos[i] = tpos[i], on[i] = ton[i];
		for (int i = 1; i <= n; ++i) G[i] = M[i];
		for (int i = 1; i < n; ++i) del(from[p[i]], to[p[i]]);
//		for (int i = 1; i <= n; ++i)
//			printf("%d ", pos[i]);
//		puts("");
		bool flag = 0;
		int i = 1;
		for (; i <= n && pos[i] == ans[i]; ++i);
		if (i == n) continue;
		if (pos[i] < ans[i]) flag = 1;
		if (flag == 1) 
		{
//			for (int i = 1; i <= n; ++i)
//				cout << ans[i] << " ";
//			cout << endl;
//			cout << "updated " << endl;
			for (int i = 1; i <= n; ++i) ans[i] = pos[i];
		}
	} while (next_permutation(p + 1, p + n));
	for (int i = 1; i <= n; ++i)
		printf("%d ", ans[i]);
	puts("");
}
int main()
{
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	_read(T);
	while (T--)
	{
		_read(n);
		
		fill(deg, deg + n + 1, 0);
		fill(fa, fa + n + 1, 0);
		for (int i = 1; i <= n; ++i) G[i].clear();
		for (int i = 1; i <= n; ++i) _read(pos[i]), on[pos[i]] = i; //number i is located in pos[i]
		for (int i = 1, x, y; i < n; ++i)
		{
			int x, y;
			_read(x), _read(y);
			from[i] = x, to[i] = y;
			G[x].push_back(y), G[y].push_back(x);
			++deg[x], ++deg[y];
		}
		if (n <= 10)
		{
			bf();
			continue;
		}
		bool flag1 = 1;
		for (int i = 1; i <= n; ++i)
		{
			if (deg[i] > 2) flag1 = 0;
		}
		if (flag1)
			work1();
	}
	return 0;
}
