#include<cstdio>
#include<vector>
#define N 500005
#define LL long long
char ch;
int n,i,j,k,tmp;
LL ans;
template<typename TP>
inline void read(TP&x){
	char ch;
	for(ch='\0';ch>'9'||ch<'0';ch=getchar());
	for(x=ch-'0',ch=getchar();'0'<=ch&&ch<='9';ch=getchar())x=x*10+ch-'0';
}
namespace Segment_Tree{
	int roots[N<<2],cnt,v;
	struct node{
		int l,r,tag,ch[2];
	}o[1<<23];
	int build(int l,int r){
		int x=++cnt;
		o[x].l=l;o[x].r=r;o[x].tag=0;
		if(l<=0&&0<=r)o[x].tag=-1;
		if(l==r&&r==0)o[x].tag=1;
		if(l==r)return x;
		int mid=(l+r)>>1;
		o[x].ch[0]=build(l,mid);
		o[x].ch[1]=build(mid+1,r);
		return x;
	}
	#define lc(x) (o[x].ch[0])
	#define rc(x) (o[x].ch[1])
	void change1(int x,int d,int p,int val){
		if(o[x].l==o[x].r){o[x].tag=val;return;}
		if(o[x].tag!=-1){
			o[++cnt]=o[lc(d)];
			o[cnt].tag=o[x].tag;
			lc(x)=cnt;
			o[++cnt]=o[rc(d)];
			rc(x)=cnt;
			o[cnt].tag=o[x].tag;
			o[x].tag=-1;
			if(o[lc(x)].r>=p)
				change1(lc(x),lc(d),p,val);
			else
				change1(rc(x),rc(d),p,val);
		}else{
			if(o[lc(x)].r>=p){
				lc(x)=++cnt;
				o[cnt]=o[lc(d)];
				change1(lc(x),lc(d),p,val);
			}else{
				rc(x)=++cnt;
				o[cnt]=o[rc(d)];
				change1(rc(x),rc(d),p,val);
			}
		}
	}
	inline int change1(int f,int p,int val){
		roots[++v]=++cnt;
		o[cnt]=o[roots[f]];
		change1(cnt,roots[f],p,val);
		return v;
	}
	void change2(int x,int d,int p){
		if(o[d].l==o[d].r){o[x].tag=0;return;}
		if(o[lc(d)].r<p){
			o[++cnt]=o[rc(d)];
			rc(x)=cnt;
//			printf("%d\n",cnt);
			change2(cnt,rc(d),p);
		}else{
			o[++cnt]=o[rc(d)];
			rc(x)=cnt;
			o[cnt].tag=0;
			o[++cnt]=o[lc(d)];
			lc(x)=cnt;
			change2(cnt,lc(d),p);
		}
	}
	inline int change2(int f,int p){
		roots[++v]=++cnt;
		o[cnt]=o[roots[f]];
		change2(cnt,roots[f],p);
		return v;
	}
	int query(int x,int p){
		if(o[x].tag!=-1)return o[x].tag;
		if(o[lc(x)].r<p)return query(rc(x),p);
		else return query(lc(x),p);
	}
	inline int Query(int f,int p){
		return query(roots[f],p);
	}
	#undef lc
	#undef rc
}
namespace Tree{
	bool cov[N];int r[N];
	std::vector<int>son[N];
	inline void _(int x,int f){
		son[f].push_back(x);
	}
	void dfs(int x,int fa,int c,LL pre){
		c+=cov[x]?1:-1;
		tmp=Segment_Tree::Query(r[fa],c);
//		if(tmp==-1)tmp=0;
//		printf("%d %d\n",x,tmp);
		pre+=(LL)tmp;
		ans^=(((LL)x)*((LL)pre));
		r[x]=Segment_Tree::change1(r[fa],c,tmp+1);
		r[x]=Segment_Tree::change2(r[x],c+1);
		for(int i=0;i<son[x].size();i++)
			dfs(son[x][i],x,c,pre);
	}
}
//int cov[N],r[N];LL sum=0;
int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d",&n);
	
//	for(i=1;i<=n;i++){
//		for(ch=getchar();ch!='('&&ch!=')';ch=getchar());
//		cov[i]=cov[i-1]+(ch=='('?1:-1);
//	}

	Segment_Tree::build(-n-1,n+1);
	Segment_Tree::roots[0]=1;
	
//	for(i=1;i<=n;i++){
//		tmp=Segment_Tree::Query(r[i-1],cov[i]);
////		printf("%d\n",tmp);
//		if(i&1){
//			if(tmp!=0)printf("%d %d\n",i,tmp);
//		}
//		else{
//			if(tmp!=(i>>1))printf("%d %d\n",i,tmp);
//		}
////		if(i%1000==0)printf("%lld ",(LL)tmp*(LL)i);
//		sum+=tmp;
//		if(tmp!=-1)ans^=(LL)sum*(LL)i;
////		if(tmp)printf("%lld ",(LL)tmp*(LL)i);
////		if(tmp!=-1)ans+=(LL)tmp;
//		else tmp=0;
//		r[i]=Segment_Tree::change1(r[i-1],cov[i],tmp+1);
//		r[i]=Segment_Tree::change2(r[i],cov[i]+1);
//	}

	for(i=1;i<=n;i++){
		for(ch=getchar();ch!='('&&ch!=')';ch=getchar());
		Tree::cov[i]=ch=='(';
	}
	for(i=2;i<=n;i++){
		scanf("%d",&tmp);
		Tree::_(i,tmp);
	}
	Tree::dfs(1,0,0,0);
	printf("%lld\n",ans);
//	printf("%lf\n",sizeof(Segment_Tree::o)/1024./1024);
	fclose(stdin);
	fclose(stdout);
}
