#include<bits/stdc++.h>
using namespace std;

#define LL long long
#define debug(x) cerr<<#x<<": "<<x<<endl;
#define fgx cerr<<"--------------"<<endl;
#define dgx cerr<<"=============="<<endl;

inline int read(){
	int x=0,f=1; char c=getchar();
	for (;!isdigit(c);c=getchar()) if (c=='-') f=-1;
	for (;isdigit(c);c=getchar()) x=x*10+c-'0';
	return x*f;
}

const int MAXN = 500010;

int to[MAXN],nxt[MAXN],head[MAXN],fa[MAXN],val[MAXN],sgn[MAXN];
int N,cnte;
char s[MAXN];

void add(int x,int y){
	to[++cnte]=y; nxt[cnte]=head[x]; head[x]=cnte;
}

namespace BF{
	LL Ans[MAXN]; int ans[MAXN];
	int calc(int x){
		int cur=fa[x],ret=0;
		while (cur!=-1&&val[cur]<=val[x]){
			if (val[cur]==val[x]) ++ret;
			cur=fa[cur];
		} return ret;
	}
	void dfs(int x){
		if (fa[x]!=-1) val[x]=val[fa[x]]+sgn[x]; else val[x]=sgn[x];
		ans[x]=calc(x);
		for (int i=head[x];i;i=nxt[i]){
			int y=to[i];
			fa[y]=x; dfs(y);
			//top[y]=top[x]; memcpy(stk[y],stk[x],sizeof(stk[x]));
		}
	}
	void Dfs(int x){
		//printf("%d %d\n",x,ans[x]);
		if (fa[x]!=-1) Ans[x]=Ans[fa[x]]+ans[x];
		for (int i=head[x];i;i=nxt[i]) Dfs(to[i]);
	}
	void Main(){
		fa[0]=-1; dfs(1); Dfs(1);
		LL Ret=0; for (int i=1;i<=N;++i) Ret^=(1LL*i*Ans[i]);
		cout<<Ret<<endl;
	}
}

namespace Subtask1{
	struct Query{int v,Id,sgn;};
	vector<Query> Q[MAXN];
	int Fa[MAXN][21],Mx[MAXN][21],M[MAXN],ans[MAXN],Cnt[MAXN<<2];
	LL Ans[MAXN];
	void dfs(int x){
		val[x]=val[Fa[x][0]]+sgn[x];
		for (int i=1;i<=20;++i) Fa[x][i]=Fa[Fa[x][i-1]][i-1];
		for (int i=head[x];i;i=nxt[i]){
			int y=to[i]; Fa[y][0]=x; dfs(y);
		}
	}
	void dfs2(int x){
		Mx[x][0]=val[Fa[x][0]]; M[x]=max(M[Fa[x][0]],val[x]);
		for (int i=1;i<=20;++i) Mx[x][i]=max(Mx[x][i-1],Mx[Fa[x][i-1]][i-1]);
		for (int i=head[x];i;i=nxt[i]) dfs2(to[i]);
	}
	void dfs3(int x){
		int Len=Q[x].size();
		for (int i=0;i<Len;++i) ans[Q[x][i].Id]+=Cnt[Q[x][i].v]*Q[x][i].sgn;
		++Cnt[val[x]];
		for (int i=head[x];i;i=nxt[i]) dfs3(to[i]); 
		--Cnt[val[x]];
	}
	void dfs4(int x){
		Ans[x]=Ans[Fa[x][0]]+ans[x];
		for (int i=head[x];i;i=nxt[i]) dfs4(to[i]);
	}
	void Main(){
		memset(Mx,0x3f,sizeof(Mx));
		val[0]=N+5; dfs(1); dfs2(1);
		for (int i=1;i<=N;++i){
			int x=i; Q[i].push_back((Query){val[i],i,1});
			if (M[i]<=val[i]) continue;
			for (int j=20;~j;--j) if (Mx[x][j]<=val[i]) x=Fa[x][j];
			x=Fa[x][0]; Q[x].push_back((Query){val[i],i,-1});
		} Cnt[val[0]]=1;
		int Len=Q[0].size(); for (int i=0;i<Len;++i) ans[Q[0][i].Id]+=Cnt[Q[0][i].v]*Q[0][i].sgn;
		dfs3(1); dfs4(1);
		//for (int i=1;i<=N;++i) printf("%d %d\n",i,ans[i]);
		LL Ret=0; for (int i=1;i<=N;++i) Ret^=(1LL*i*Ans[i]);
		cout<<Ret<<endl;
	}
}

int main(){
	freopen("brackets.in","r",stdin); freopen("brackets.out","w",stdout);
	N=read(); scanf("%s",s+1);
	for (int i=1;i<=N;++i) if (s[i]=='(') sgn[i]=-1; else sgn[i]=1;
	for (int i=2;i<=N;++i){
		int x=read(); add(x,i);
	} if (N<=2000){
		BF::Main(); return 0;
	} Subtask1::Main();
	return 0;
}

