#include <bits/stdc++.h>

using namespace std;

namespace LZZio {
	template <class T> inline void read(T &x) {
		T flg = 1; x = 0; char ch = getchar();
		for (; !isdigit(ch); ch = getchar()) if (ch == '-') flg = -1;
		for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
		x *= flg; return;
	}

	template <class T> inline void write(T x) {
		if (x < 0) putchar('-'), x = -x;
		if (x > 9) write(x / 10);
		putchar(x % 10 + '0');
	}

	template <class T> inline void writeln(T x, char c = '\n') { write(x), putchar(c); }
	template <class T> inline void chkmax(T &x, const T y) { x = x > y ? x : y; }
	template <class T> inline void chkmin(T &x, const T y) { x = x < y ? x : y; }

	#define Ms(arr, opt) memset(arr, opt, sizeof(arr))
	typedef long long ll;
	typedef unsigned long long ull;
} using namespace LZZio;

const int Maxn = 5e5 + 5; 
int n, fa[Maxn], cnt = 0; ll ans[Maxn]; char str[Maxn], s[Maxn];
vector <int> vec[Maxn]; stack <char> sta;

inline void dfs(int u) {
	s[++cnt] = str[u];
	for (int i = 1; i < cnt; i++) { while (sta.size()) sta.pop(); sta.push(s[i]);
		for (int j = i + 1; j <= cnt; j++) { if (!sta.size()) sta.push(s[j]);
			else if (sta.top() == ')') break;
			else if (s[j] == ')' && sta.top() == '(') { sta.pop(); if (sta.size() == 0) ans[u]++; }
			else sta.push(s[j]);
		}
	}
	
	for (int i = 0; i < vec[u].size(); i++) dfs(vec[u][i]); cnt--;
}

int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	scanf("%d", &n); scanf("%s", str + 1); bool ff = true; Ms(ans, 0);
	for (int i = 2; i <= n; i++) {
		scanf("%d", &fa[i]); if (fa[i] != i - 1) ff = false;
		vec[fa[i]].push_back(i);
	}ll ret = 0;
	dfs(1); for (ll i = 2; i <= n; i++) ret = ret ^ (ans[i] * i); writeln(ret);
	
	return 0;
}

