#define TASKNAME "code"

#include <bits/stdc++.h>
using namespace std;

typedef long long LL;

namespace _buff {

const size_t BUFF = 1 << 19;
char ibuf[BUFF], *ib = ibuf, *ie = ibuf + BUFF;

char getc() {
    if (ib == ie) {
        ib = ibuf;
        ie = ibuf + fread(ibuf, 1, BUFF, stdin);
    }
    return ib == ie ? EOF : *ib++;
}

}

LL read() {
    using namespace _buff;
    LL ret = 0;
    bool pos = true;
    char c = getc();
    for (; (c < '0' || c > '9') && c != '-'; c = getc()) {
        assert(~c);
    }
    if (c == '-') {
        pos = false;
        c = getc();
    }
    for (; c >= '0' && c <= '9'; c = getc()) {
        ret = (ret << 3) + (ret << 1) + (c ^ 48);
    }
    return pos ? ret : -ret;
}

string solve(int n, unsigned long long k) {
    if (n == 1) {
        return k == 0 ? "0" : "1";
    }
    if (k < (1ULL << (n - 1))) {
        return "0" + solve(n - 1, k);
    } else {
        return "1" + solve(n - 1, (1ULL << (n - 1)) - (k - (1ULL << (n - 1))) - 1);
    }
}

int main() {
    freopen(TASKNAME ".in",  "r", stdin);
    freopen(TASKNAME ".out", "w", stdout);

    int n;
    unsigned long long k;
    cin >> n >> k;
    cout << solve(n, k) << endl;

    return 0;
}
