
#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <utility>
#include <memory>
#include <iostream>
using namespace std;

int n;
unsigned long long k;

string GrayCode(int nn,unsigned long long kk)
{
	if(nn==1)
	{
		if(kk==0uLL)
		{
			return "0";
		}
		else
		{
			return "1";
		}
	}
	string tmp;
	if(kk<(1uLL<<(nn-1)))
	{
		tmp="0"+GrayCode(nn-1,kk);
	}
	else
	{
		if(nn==64)
		{
			tmp="1"+GrayCode(nn-1,18446744073709551615uLL-kk);
		}
		else
		{
			tmp="1"+GrayCode(nn-1,(1uLL<<nn)-1uLL-kk);
		}
	}
	return tmp;
}

int main()
{
	freopen("code.in","r",stdin);
	freopen("code.out","w",stdout);
	cin>>n>>k;
//	cout<<n<<endl<<k<<endl;
	cout<<GrayCode(n,k)<<endl;
	return 0;
}

