#include <bits/stdc++.h>
using namespace std;
const int MAXN = 5e5 + 10;
typedef long long ll;
int N;
int head[MAXN],cnt = 0;
int val[MAXN];
int tp[MAXN],sum[MAXN],tot[MAXN],from[MAXN];
int f[MAXN];
ll ans;

struct G{
	int w;
	int to;
	int nxt;
} edge[2 * MAXN];

inline void putin(int u,int v) {
	edge[++cnt].to = v;
	edge[cnt].nxt = head[u];
	head[u] = cnt;
}

void dfs1(int u,int fa,int tops) {
	from[u] = fa;
//	tp[u] = tops;
//	for (register int i = u; i != tp[u]; i = from[i]) {
//		if (sum[from[u]] - sum[i] == 1) tot[u]++;
//	}
//	if (sum[from[u]] - sum[tp[u]] == 1) tot[u]++; 
	for (register int i = head[u]; i; i = edge[i].nxt) {
		int v = edge[i].to;
		if (v == fa) continue;
		sum[v] = sum[u] + val[v];
		tp[v] = tops;
		if (sum[v] < 0 && val[v] == -1) {
			dfs1(v,u,v);
		}
		else {
			dfs1(v,u,tops);
		}
	}
}

void dfs2(int u,int fa) {
	if (val[u] == 1) {
		f[u] = f[fa];
	}
	if (val[u] == -1) {
		f[u] = f[fa];
		for (register int i = from[u]; i != from[tp[u]]; i = from[i]) {
//			cout << i <<endl;
			if (val[i] == 1 && sum[u] - sum[from[i]] == 0) {
//				cout << "check" << i << " " << u <<endl;
				f[u]++;
			}
		}
	}
//	cout << u << " " << f[u] << endl;
	for (register int i = head[u]; i; i = edge[i].nxt) {
		int v = edge[i].to;
		if (v == fa) continue;
		dfs2(v,u);
	}
}

int main() {
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d",&N);
	for (register int i = 1; i <= N; i++) {
		char c;
		cin >> c;
		if (c == '(') {
			val[i] = 1;
		}
		if (c == ')') {
			val[i] =  -1;
		}
	}
	for (register int i = 2; i <= N; i++) {
		int v;
		scanf("%d",&v);
		putin(i,v);
		putin(v,i);
	}
	sum[1] = val[1];
	tp[1] = 1;
	dfs1(1,0,1);
/*	
	for (register int i = 1; i <= N; i++) {
		cout << tot[i]<< " ";
	}
	cout << endl;
*/ 
	
	dfs2(1,0);
//	cout << tp[10] <<endl;
	for (register int i = 1; i <= N; i++) {
		ans ^= (ll) (f[i] * i);
	}
	printf("%lld",ans);
	return 0;
}

/*
5
(()()
1 1 2 2

6
()((()
1 2 3 4 5

10
()(()(()))
1 2 3 4 5 6 7 8 9

10
()))))))()
1 2 3 4 5 6 7 8 9

6
())(()
1 2 3 4 5

5
())))
1 2 3 4
*/

