//This amazing code is written by Primo.Jay.Pan
//CSP-S 2019 Day1 T2 brackets.cpp
#include <iostream>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <stack>
#include <queue>
#include <string>
#define maxn 500010
#define ll long long
using namespace std;

int fa[maxn];
char s[maxn];
int f[maxn];//以当前节点为终点的合法子序列个数
int isend[maxn];
int n;
bool flag=true;
ll t[maxn];
stack<int> S;
struct Edge{
	int next,to;
}edges[maxn*2];
int head[maxn];

struct LNE{
	inline void work()
	{
		for (int i=1;i<=n;i++)
		{
			if (s[i]=='(')
			{
				S.push(i);
				continue;
			}
			if (s[i]==')')
			{
				if (S.empty()) 
					continue;
				int fr=S.top();
				S.pop();
				isend[i]=1;
				f[i]=1;
				if (isend[fr-1]==1)
					f[i]+=f[fr-1];	
			}
		}
		ll cur=0;
		for (int i=1;i<=n;i++)
		{
			cur+=f[i];
			t[i]=(ll)cur*i;;
		}
		ll ans=t[1];
		for (int i=2;i<=n;i++)
			ans=ans^t[i];
		cout<<ans<<endl;
	}
}subtask_1;//链


int instack[maxn];

int b_cnt=0;
struct NorMal{
	inline void addedge(int u,int v)
	{
		edges[++b_cnt].next=head[u];
		edges[b_cnt].to=v;
		head[u]=b_cnt;
	}
	inline void dfs1(int u,int FAA)
	{
		if (s[u]=='(')
		{
			S.push(u);
			instack[u]=1;
			for (int i=head[u];i;i=edges[i].next)
			{
				int v=edges[i].to;	
				if (!instack[u]) 
					S.push(u);
				if (v!=FAA)
					dfs1(v,u);
			}
			if (instack[u])
			{
				S.pop();
				instack[u]=0;
			}
		}
		else if (s[u]==')')
		{
			if (!S.empty())
			{
				int fr=S.top();
				S.pop();
				instack[fr]=0;
				isend[u]=1;
				f[u]=1;
				if (isend[fa[fr]])
					f[u]+=f[fa[fr]];
				for (int i=head[u];i;i=edges[i].next)
				{
					int v=edges[i].to;
					if (v!=FAA)
						dfs1(v,u);
				}
				S.push(fr);
				instack[fr]=1;
			}
			else{
				for (int i=head[u];i;i=edges[i].next)
				{
					int v=edges[i].to;
					if (v!=FAA)
						dfs1(v,u);
				}
			}
		}
	}
	inline void dfs2(int u,int faa,int cur)
	{
		cur+=f[u];
		t[u]=(ll)cur*u;
		for (int i=head[u];i;i=edges[i].next)
		{
			int v=edges[i].to;
			if (v!=faa)
				dfs2(v,u,cur);
		}
	}
	inline void work()
	{
		for (int i=2;i<=n;i++)
		{
			addedge(fa[i],i);
			addedge(i,fa[i]);
		}
		dfs1(1,0);
		dfs2(1,0,0);
		ll ans=t[1];
		for (int i=2;i<=n;i++)
			ans=ans^t[i];
		cout<<ans<<endl;
	}
}subtask_2;


int main()
{
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d",&n);
	scanf("%s",s+1);
	for (int i=2;i<=n;i++)
	{
		scanf("%d",&fa[i]);
		if (fa[i]!=i-1)
		{
			flag=false;
		}
	}
	if (flag) {
		subtask_1.work();
		return 0;
	}
	subtask_2.work();
	return 0;
}
