#include <cstdio>
#include <cstring>
#define REP(i,a,b) for(register int i = a; i <= b; ++i)

inline int read() {
	int x = 0 , f = 1; char c; while((c=  getchar()) < '0' || c > '9') if(c == '-') f = 0; x = c - 48;
	while((c = getchar()) <= '9' && c >= '0') x = (x << 1) + (x << 3) + c - 48; return f ? x : ~x + 1;
}

inline int max(int a, int b) {return a > b ? a : b;}
inline int min(int a, int b) {return a > b ? b : a;}
const int MAXN = 500050;
int cnt = 1, head[MAXN], dir[MAXN];
struct edge{
	int to, next;
}E[MAXN];

inline void add(int u, int v) {
	E[cnt].to = v; E[cnt].next = head[u];
	head[u] = cnt++;
}
int tmp = 0;
int f[MAXN];
inline void search(int u) {
	int t = tmp;
	if(dir[u]==0) tmp++;
	for(register int i = head[u]; i; i = E[i].next) {
		int v = E[i].to;
		if(dir[v]==1&&tmp>0) {
			f[v] = f[u] + 1;
			tmp--;
		}
		search(v);
	}
	tmp = t;
	return;
}

int main() {
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	int n = read();
	f[1] = 0;
	REP(i,1,n) {
		char c = getchar();
		if (c == '(') dir[i] = 0;
		else dir[i] = 1;
	}
	REP(i,2,n) {
		int u = read();
		add(u,i);
	}
	search(1);
	int ans = 0;
	REP(i,2,n) ans = ans^(i*f[i]);
	printf("%d",ans);
	return 0;
}
