#include<bits/stdc++.h>
#define fox(i,a,b) for(int i=a;i<=b;++i)
#define LL long long
#define Set(a,b) memset(a, b, sizeof a)
#define Cpy(a,b) memcpy(a, b, sizeof a)
#define Debug(x) cout << "------------- " << x << " --------------------\n"
using namespace std;

template <typename T> inline void chkmin(T&x, T y) {x < y ? 0 : x = y;}
template <typename T> inline void chkmax(T&x, T y) {x > y ? 0 : x = y;}
int _x; bool _f; char _c;
inline int rd() {
	_x = 0, _f = 1, _c = getchar();
	for (; !isdigit(_c); _c = getchar()) if (_c == '-') _f = 0;
	for (; isdigit(_c); _c = getchar()) _x = _x * 10 + _c - '0';
	return _f ? _x : -_x;
}

const int N = 2e3 + 10;
int n, h[N], tot, Maxdeg, deg[N], jd[N], num[N], bj[N];
bool ud[N << 1];
struct edge {int nxt, v;} e[N << 1];
struct Edge {int x, y;} E[N];

int p[N], ans[N], a[N];

void check() {
	fox (i, 1, n) a[i] = jd[i];
	
	fox (i, 1, n - 1) swap(a[E[p[i]].x], a[E[p[i]].y]);
	
	if (ans[1] == 0) fox (i, 1, n) ans[i] = a[i];
	else {
		fox (i, 1, n) {
			if (ans[i] < a[i]) return;
			if (ans[i] == a[i]) continue;
			if (ans[i] > a[i]) break;
		}
		fox (i, 1, n) ans[i] = a[i];
	}
}

void Dfs(int x) {
	if (x == n) {check(); return;}
	fox (i, 1, n - 1) {
		if (ud[i]) continue;
		ud[i] = 1;
		p[x] = i;
		Dfs(x + 1);
		ud[i] = 0;
	}
}

int nt[N];

int _find(int x, int b, int pre) {
	int i, v, res = n + 1, g;
	for (i = h[x]; i; i = e[i].nxt) {
		if (ud[i]) continue;
		if (b && bj[i] == b) continue;
		if ((v = e[i].v) == pre) continue;
		g = _find(v, bj[i], x);
		if (!p[v]) chkmin(g, v);
		if (g < res) res = g, nt[x] = i;
	}
	return res;
}

void clr(int x, int y) {
	for (int i = x; i != y; i = e[nt[i]].v) {
		ud[nt[i]] = 1;
		bj[nt[i] ^ 1] = x;
	}
}

void solve() {
	int k;
	fox (i, 1, n) {
		k = _find(jd[i], 0, 0);
		if (k == n + 1) {
			k = e[h[jd[i]]].v;
			ans[i] = k;
			fox (j, 1, n) if (ans[j] == k) {ans[j] = jd[i]; break;}
			p[jd[i]] = 1;
			continue;
		}
		p[k] = 1;
		clr(jd[i], k);
		ans[i] = k;
	}          
}

inline void add(int x, int y) {
	e[++tot] = (edge) {h[x], y};
	h[x] = tot;
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	for (int T = rd(); T--; ) {
		n = rd(), tot = 1;
		Set(h, 0), Set(deg, 0), Set(ans, 0), Maxdeg = 0;
		Set(bj, 0), Set(ud, 0), Set(p, 0);
		fox (i, 1, n) num[jd[i] = rd()] = i;
		int u, v;
		fox (i, 2, n) {
			u = rd(), v = rd();         
			add(u, v), add(v, u);
			E[i - 1] = (Edge) {num[u], num[v]};
			++deg[u], ++deg[v];
			chkmax(Maxdeg, deg[v]);
			chkmax(Maxdeg, deg[u]);
		}
		
		if (n <= 10) {
			Dfs(1);
			fox (i, 1, n) {
				cout << ans[i];
				if (i == n) cout << endl;
				else cout << ' ';
			}
		}
		else {
			solve();
			fox (i, 1, n) {
				printf("%d", ans[i]);
				if (i == n) cout << endl;
				else putchar(' ');
			}
		}
	}
	return 0;
}

