#include <bits/stdc++.h>
using namespace std;
#define MAXN 520005
typedef long long ll;

inline ll read(){
	ll res=0,f=1;
	char c=getchar();
	while(c<'0'||c>'9'){
		if(c=='-') f=-1;
		c=getchar();
	}
	while(c>='0'&&c<='9'){
		res=res*10+c-'0';
		c=getchar();
	}
	return f*res;
}

struct node{
	int v;
	int next;
}edge[MAXN*4];

int head[MAXN*4];
int cnt;

void add(int u,int v){
	edge[++cnt].v=v;
	edge[cnt].next=head[u];
	head[u]=cnt;
}


int s[MAXN];
int c[MAXN];
ll n,tot,ans;
bool flag=1;

bool check(ll l,ll r){
	ll cm=0;
	for(ll i=l;i<=r;i++){
		if(c[i]==1) cm++;
		else cm--;
		if(cm<0) return false;
	}
	if(cm==0) return true;
	else return false;
}

int count(){
	ll sum=0;
	for(int l=1;l<=tot;l++){
		for(int r=l+1;r<=tot;r++){
			if(check(l,r)) sum++;
		}
	}
	return sum;
}

void dfs(ll u,ll fa){
	c[++tot]=s[u];
	ans^=count()*u;
	for(int i=head[u];~i;i=edge[i].next){
		int v=edge[i].v;
		if(v==fa) continue;
		dfs(v,u);
	}
	c[tot--]=(ll)0;
	return;
}

int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	memset(head,-1,sizeof(head));
	n=read();
	for(int i=1;i<=n;i++){
		char inp;
		cin>>inp;
		if(inp=='(') s[i]=1;
		else s[i]=2;
	}
	for(int i=2;i<=n;i++){
		ll u=read();
		if(u!=i-1) flag=0;
		add(u,i),add(i,u);
	}
	dfs(1,0);
	printf("%lld\n",ans);
	return 0;
}
