#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <utility>
#include <queue>
#include <set>
#define maxn 500005
#define mp make_pair

using namespace std;
typedef long long ll;
typedef pair<int,int> P;
typedef set<P>::iterator Ite;

int n;
char a[maxn];
ll s[maxn];
ll delta[maxn];
vector <int> chi[maxn];
set <P> cur;// sum, dep.
int depu[maxn];
void dfs(int u,int f,int dep,int sum){
  s[u] = s[f];
  depu[dep] = u;
  if(a[u] == ')'){
    sum--;
    Ite it = cur.lower_bound(mp(sum,dep));
    if(it != cur.begin()) it--;
    if(it -> first == sum){
      int pre = depu[it -> second];
      delta[u] = delta[pre] + 1;
      s[u] += delta[u];
    }
  }else{
    sum++;
  }
  cur.insert(mp(sum,dep));
  for(int i = 0;i < (int)chi[u].size();i++) dfs(chi[u][i],u,dep + 1,sum);
  cur.erase(mp(sum,dep));
  depu[dep] = 0;
}
int main(){
  freopen("brackets.in","r",stdin);
  freopen("brackets.out","w",stdout);
  scanf("%d",&n);
  scanf("%s",a + 1);
  for(int i = 2;i <= n;i++){
    int f;
    scanf("%d",&f);
    chi[f].push_back(i);
  }
  depu[0] = 0;
  cur.insert(mp(0,0));
  dfs(1,0,1,0);
  ll ans = 0;
  for(int i = 1;i <= n;i++){
    ans ^= ((ll)i * s[i]);
  }
  printf("%lld\n",ans);
  return 0;
}

