#include<cstdio>
#include<cctype>
#include<string>
#include<cstring>
#include<iostream>
#include<algorithm>
#define MaxN 500010
#define MaxM 500010

typedef long long LL;

struct edge {int v, nxt;} e[MaxM];

LL Ans;
int n, tot, head[MaxN], ans[MaxN], cntl, cntr, ret;
std::string str;

inline int read() {
	int x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	return x * f;
}

void addedge(int x, int y) {
	e[++tot] = (edge) {y, head[x]};
	head[x] = tot;
}

void dfs(int x, std::string s) {
	for (int i = head[x]; i; i = e[i].nxt) {
		int y = e[i].v;
		if (str[y - 1] == '(') ans[y] = ans[x], dfs(y, s + str[y - 1]);
		else {
			cntr = 1; cntl = 0; ret = 0;
			for (int i = s.length() - 1; i >= 0; --i) {
				if (s[i] == '(') ++cntl; else ++cntr;
				if (cntl > cntr) break;
				if (cntl == cntr) ++ret;
			}
			ans[y] = ans[x] + ret;
			dfs(y, s + str[y - 1]);
		}
	}
}

int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	n = read();
	getline(std::cin, str);
	for (int i = 2; i <= n; ++i) {
		int fa_x = read();
		addedge(fa_x, i);
	}
	dfs(1, str.substr(0, 1));
 	for (int i = 1; i <= n; ++i) Ans = Ans ^ (i * ans[i]);
	printf("%lld\n", Ans);
	return 0;
}
