#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>
using namespace std;
typedef long long ll;
typedef double dbl;
typedef pair<int,int> pii;
const int MAXN = 2000 + 11;
const int INF = 0x3f3f3f3f;
#define fi first
#define se second
#define For(a,b,c)	for (int (a) = (b);(a) < (c);(a) ++)
#define mp make_pair
#define pb push_back
int N,W[MAXN * 100];
struct edge{
	int x,y,nxt;
	edge(){}
	edge(int nx,int ny,int nnxt){
		x = nx;y = ny;nxt = nnxt;
	}
}E[(MAXN * 100) << 1];
int head[MAXN * 100],cnt,p[MAXN * 100],sta[MAXN][MAXN],now[MAXN * 100],top[MAXN * 100];
ll S[MAXN * 100];
inline void link(int x,int y){
	E[++cnt] = edge(x,y,head[x]);
	head[x] = cnt;
}
void dfs(int u,int fa){
	top[u] = top[fa];
	For(i,1,top[u] + 1)	sta[u][i] = sta[fa][i];
	now[u] = now[fa];
	if (W[u] == -1){
		p[u] = p[fa] - 1;
		sta[u][++top[u]] = now[fa];now[u] = 0;
		S[u] = S[fa];
	}else{
		if (p[fa] < 0){
			S[u] = S[fa] + 1 + sta[u][top[u]];
			now[u] = sta[u][top[u]] + 1;
			top[u]--;
			p[u] = p[fa] + 1;
		}else{
			now[u] = 0;
			top[u] = 0;
			S[u] = S[fa];
			p[u] = 0;
		}
	}
	for (int i = head[u];i;i = E[i].nxt)	if (E[i].y != fa)	dfs(E[i].y,u);
}
int STA[MAXN * 100],TOP;
int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d",&N);
	char tp[MAXN * 100];scanf("%s",tp);
	For(i,1,N + 1)	if (tp[i - 1] == '(')	W[i] = -1;	else W[i] = 1;
	cnt = 0;memset(head,0,sizeof(head));
	bool subtask1;subtask1 = 1;
	For(i,2,N + 1){
		int fa;scanf("%d",&fa);
		link(fa,i);
		if (fa != i - 1)	subtask1 = 0;
	}
	if (subtask1){
		For(u,1,N + 1){
			now[u] = now[u - 1];
			if (W[u] == -1){
				p[u] = p[u - 1] - 1;
				STA[++TOP] = now[u - 1];now[u] = 0;
				S[u] = S[u - 1];
			}else{
				if (p[u - 1] < 0){
					S[u] = S[u - 1] + 1 + STA[TOP];
					now[u] = STA[TOP] + 1;
					if (TOP > 0)	TOP--;
					p[u] = p[u - 1] + 1;
				}else{
					now[u] = 0;
					TOP = 0;
					S[u] = S[u - 1];
					p[u] = 0;
				}
			}
		}
	}else	dfs(1,0);
	ll ans = 0;
	For(i,1,N + 1)	ans ^= (ll)i * S[i];
	printf("%lld\n",ans);
	return 0;
}
