#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>
using namespace std;
typedef long long ll;
typedef double dbl;
typedef pair<int,int> pii;
const int MAXN = 2e3 + 11;
const int INF = 0x3f3f3f3f;
#define fi first
#define se second
#define For(a,b,c)	for (int (a) = (b);(a) < (c);(a) ++)
#define mp make_pair
#define pb push_back
int T,N,LOC[MAXN],deg[MAXN];
struct edge{
	int x,y,nxt,bj;
	edge(){}
	edge(int nx,int ny,int nnxt){
		x = nx;y = ny;nxt = nnxt;bj = 0;
	}
}E[MAXN << 1];
int head[MAXN],cnt;
inline void link(int x,int y){
	E[++cnt] = edge(x,y,head[x]);
	head[x] = cnt;
	E[++cnt] = edge(y,x,head[y]);
	head[y] = cnt;
}
struct subtask1_{
	int W[11],ans,TP[11];
	void dfs(int u){
		if (u >= N){
			bool pd = 0;
			For(i,1,N + 1)	TP[LOC[i]] = i;
			For(i,1,N + 1)	if (TP[i] < W[i]){
				pd = 1;break;
			}else	if (TP[i] > W[i])	break;
			ans ++;
			if (pd)	For(i,1,N + 1)	W[i] = TP[i];
			return;
		}
		for (int i = 1;i <= cnt;i += 2)if (E[i].bj == 0){
			E[i].bj = 1;
			swap(LOC[E[i].x],LOC[E[i].y]);
			dfs(u + 1);
			swap(LOC[E[i].x],LOC[E[i].y]);
			E[i].bj = 0;
		}
	}
	void solve(){
		For(i,1,N + 1)	W[i] = N;
		dfs(1);
		For(i,1,N + 1)	printf("%d%c",W[i],i == N ? '\n' : ' ');
	}
}SUBTASK1;
struct subtask2_{
	pii nE[MAXN << 1];
	int CNT,W[MAXN],TP[MAXN];
	void init(int u,int fa){
		for (int i = head[u];i;i = E[i].nxt)	if (E[i].y != fa){
			nE[++CNT] = mp(u,E[i].y);
			init(E[i].y,u);
		}
	}
	vector<int> dfs(int l,int r){
		vector<int> res;
		For(i,l,r + 1)	res.pb(nE[i].fi);
		if (l <= r)		res.pb(nE[r].se);
		if (l > r)	return	res;
		For(i,0,res.size())	W[LOC[res[i]]] = res[i];
		For(i,l,r + 1){
			swap(LOC[nE[i].fi],LOC[nE[i].se]);
			vector<int> lft,rit;
			lft = dfs(l,i - 1);
			rit = dfs(i + 1,r);
			For(j,1,N + 1)	TP[j] = N + 1;
			For(j,0,lft.size())	TP[LOC[lft[i]]] = lft[i];
			For(j,0,rit.size())	TP[LOC[rit[i]]] = rit[i];
			bool pd = 1;
			For(j,1,N + 1)	if (TP[j] != N + 1){
				if (TP[j] < W[j])	continue;
				if (TP[j] > W[j]){
					pd = 0;break;
				}
			}
			if (pd){
				For(j,1,N + 1)	W[j] = TP[j];
				res.clear();For(j,0,lft.size())	res.pb(lft[j]);
				For(j,0,rit.size())	res.pb(rit[j]);
			}
			swap(LOC[nE[i].fi],LOC[nE[i].se]);
		}
		return res;
	}
	void solve(){
		CNT = 0;
		For(i,1,N + 1)	W[i] = N;
		For(i,1,N + 1)	if (deg[i] == 1){
			init(i,0);break;
		}
		vector<int> ans = dfs(1,CNT);
		For(i,0,ans.size())	W[LOC[ans[i]]] = ans[i];
		For(i,1,N + 1)	printf("%d%c",W[i],i == N ? '\n' : ' ');
	}
}SUBTASK2;
int main(){
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	scanf("%d",&T);
	int a = 1;
	while(T--){
		memset(head,0,sizeof(head));cnt = 0;
		scanf("%d",&N);
		For(i,1,N + 1){
			int a;scanf("%d",&a);
			LOC[a] = i;
		}
		bool subtask2;subtask2 = 1;
		For(i,1,N){
			int a,b;scanf("%d%d",&a,&b);
			link(a,b);
			deg[a]++;deg[b]++;
			if (deg[a] > 2 || deg[b] > 2)	subtask2 = 0;
		}
		if (N <= 10)	SUBTASK1.solve();
		else
		if (subtask2)	SUBTASK2.solve();
		else
		For(i,1,N + 1)	printf("%d%c",i,i == N ? '\n' : ' ');
	}
	return 0;
}
