#include <stdio.h>
#include <ctype.h>
using namespace std;

typedef long long int64;
typedef unsigned long long uint64;

uint64 n, k, ans;

void work(uint64 cn, uint64 ck);

template<typename T> void qread_unsigned(T& t) {
	t = 0;
	char c;
	while(!isdigit(c = getchar()));
	while(isdigit(c)) {
		t = t * 10 + c - '0';
		c = getchar();
	}
}

uint64 power2(uint64 k) {
	return 1ull << k;
}

int main() {
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);
	qread_unsigned(n); qread_unsigned(k);
	work(n, k);
	bool flag = false;
	for(int64 i = n - 1; i >= 0; --i) {
		printf("%llu", ans >> i);
		ans &= ~(1ull << i);
	}
	return 0;
}

void work(uint64 cn, uint64 ck) {
	if(cn > 1ull) {
		if(ck < power2(cn - 1)) {
			work(cn - 1, ck);
		}
		else {
			ans |= 1ull << (cn - 1);
			work(cn - 1, 2 * power2(cn - 1) - ck - 1);
		}
	}
	else {
		if(ck == 1) {
			ans |= 1ull;
		}
	}
}
