#include<bits/stdc++.h>

using namespace std;

#define FOR(i, x, y) for(int i = (x); i < (y); ++i)
#define REP(i, x, y) for(int i = (x); i <= (y); ++i)
#define MP make_pair
#define PB push_back
#define PH push
#define fst first
#define snd second
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;

const int INF = 1e9 + 7;
const int maxn = 2005;

int n;
int a[maxn], c[maxn], ans[maxn];
vector<int> g[maxn];

namespace Solve1{
	const int myMaxn = 12;
	int p[myMaxn], b[myMaxn], tmp[myMaxn];
	int ed[myMaxn][2];
	inline void work(){
		FOR(i, 1, n){
			int u, v; scanf("%d%d", &u, &v); --u; --v;
			ed[i][0] = u, ed[i][1] = v;
			p[i] = i;
		}
		FOR(i, 0, n) ans[i] = INF;
		do{
			FOR(i, 0, n) b[i] = c[i];
			FOR(i, 1, n){
				int id = p[i];
				swap(b[ed[id][0]], b[ed[id][1]]);
			}
			//FOR(i, 0, n) printf("%d ", b[i]); puts("");
			FOR(i, 0, n) tmp[b[i]] = i;
			FOR(i, 0, n){
				if(tmp[i] < ans[i]){
					FOR(j, 0, n) ans[j] = tmp[j];
					break;
				}
				else if(tmp[i] > ans[i]) break;
			}
		}while(next_permutation(p + 1, p + n));
		FOR(i, 0, n) printf("%d ", ans[i] + 1);
		puts("");
		return;
	}
}

namespace Solve2{
	vector<int> seq;
	inline void dfs(int u, int p){
		seq.PB(u);
		FOR(i, 0, (int)g[u].size()){
			int v = g[u][i];
			if(v == p) continue;
			dfs(v, u);
		}
		return;
	}
	inline void build(int l, int r){
		int mnNode = INF, mnVal = -1;
		if(l == r) return;
		if(r == l + r){
			swap(c[seq[l]], c[seq[r]]);
			return;
		}
		REP(i, l, r){	
			if(mnNode == -1 || seq[i] < mnNode) mnNode = i;
			if(mnVal == -1 || c[seq[i]] < c[seq[mnVal]])
				mnVal = seq[i];
		}
		if(mnNode == seq[mnVal]){
			REP(i, l, r) if(mnNode != seq[i]){
				mnNode = min(mnNode, seq[i]);
			}
		}
		else if(mnVal < mnNode){
			build(mnNode, r);
			FOR(i, mnNode, mnVal) swap(a[i], a[i + 1]);
			build(l, mnVal);
		}		
		else{
			build(l, mnNode);
			for(int i = mnVal; i > mnNode; --i) swap(a[i], a[i - 1]);
			build(mnVal, r);
		}
		return;
	}
	inline void work(){
		seq.clear();
		FOR(u, 0, n) if(g[u].size() == 1){
			dfs(u, -1);
		}
		build(0, n - 1);
		FOR(i, 0, n) ans[a[i]] = i;
		FOR(i, 0, n) printf("%d ", ans[i] + 1); puts("");
		return;
	}
}

namespace Solve3{
	int vis[maxn], to[maxn], tmp[maxn];
	class Dsu{
	public:
		int fa[maxn];
		inline int find(int x){
			return ((fa[x] == x) ? x : (fa[x] = find(fa[x])));
		}
		inline void init(){
			FOR(i, 0, maxn) fa[i] = i;
			return;
		}
		inline void combine(int u, int v){
			u = find(u), v = find(v);
			fa[u] = v;
			return;
		}
		inline bool same(int u, int v){
			u = find(u); v = find(v);
			if(u == v) return true;
			return false;
		}
	}dsu;
	inline void work(){
		memset(vis, 0, sizeof(vis));
		dsu.init();
		memset(to, -1, sizeof(to));
		FOR(i, 0, n){
			int v = a[i];
			int mn = INF;
			if(i == n - 1){
				FOR(u, 0, n) if(!vis[u]){
					mn = u;
					break;
				}
				to[v] = mn;
				//printf("u = %d v = %d\n", v, mn);
				break;
			}
			FOR(u, 0, n) if(!vis[u] && u != v && !dsu.same(u, v)) mn = min(mn, u);
			vis[mn] = 1;
			dsu.combine(mn, v);
			to[v] = mn;
			//printf("u = %d v = %d\n", v, mn);
		}
		memset(tmp, -1, sizeof(tmp));
		FOR(i, 0, n){
			//printf("%d ", to[i]);
			if(to[i] != -1)
				tmp[to[i]] = c[i];
		}
		//puts("");
		//FOR(i, 0, n) printf("%d ", tmp[i]);
		//puts("");
		FOR(i, 0, n) if(!~tmp[i]){
			tmp[i] = n - 1;
			break;
		}
		FOR(i, 0, n) ans[tmp[i]] = i;
		FOR(i, 0, n) printf("%d ", ans[i] + 1);
		puts("");
		return;
	}
}

inline void solve(){
	scanf("%d", &n);
	FOR(i, 0, n){
		scanf("%d", a + i);
		--a[i];
		c[a[i]] = i;
	}
	if(n <= 10){
	  Solve1::work();
	  return;
	}
	FOR(i, 0, n) g[i].clear();
	FOR(i, 1, n){
		int u, v; scanf("%d%d", &u, &v);
		--u; --v;
		g[u].PB(v);
		g[v].PB(u);
	}
	bool flag2 = true, flag3 = false;
	FOR(i, 0, n){
		flag2 &= (g[i].size() <= 2 && g[i].size() > 0);
		flag3 |= (g[i].size() == n - 1);
	}
	if(flag2) Solve2::work();
	else if(flag3) Solve3::work();
	return;
}

int main(){
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int T;
	for(scanf("%d", &T); T--; solve());
	return 0;
}
