#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxn = 5e5 + 10;

int n;
char s[maxn];
int to[maxn], nxt[maxn], head[maxn], tot;
ll f[maxn], val[maxn];
int pnxt[maxn];

void addedge(int u, int v){
	to[++tot] = v;
	nxt[tot] = head[u];
	head[u] = tot;
}

void dfs(int x, int fa, int dep){
	f[x] = f[fa];
	if (s[x] == ')'){
		pnxt[dep] = pnxt[dep - 1];
		if (pnxt[dep]){
			val[dep] = val[pnxt[dep] - 1] + 1;
			pnxt[dep] = pnxt[pnxt[dep] - 1];
		}
		f[x] += val[dep];
	} else pnxt[dep] = dep;
	for (int i = head[x], p; i; i = nxt[i]){
		p = to[i];
		if (p != fa) dfs(p, x, dep + 1);
	}
	pnxt[dep] = val[dep] = 0;
}

int main(){
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	scanf("%d", &n);
	scanf("%s", s + 1);
	for (int i = 2, fa; i <= n; i++){
		scanf("%d", &fa);
		addedge(fa, i);
	}
	dfs(1, 0, 1);
	ll ans = 0;
	for (int i = 1; i <= n; i++) ans ^= f[i] * i;
	printf("%lld\n", ans);
	return 0;
}
