#include<iostream>
#include<cstdio>
#include<algorithm>
#include<queue>
#include<set>
#include<map>
#include<cmath>
#include<cstdlib>
using namespace std;

typedef long long ll;

const int MAXINT=2147483647;
const int INF=0x3f3f3f3f;
const ll INFLL=0x3f3f3f3f3f3f3f3f;
const double EPS=1e-6;
const int MAXN=500005;

int read(){
	int s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

int readu(){
	int s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

ll readll(){
	ll s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

ll readull(){
	ll s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

void reads(char ch[]){
	int len=-1;
	char c=getchar();
	while (c!='(' && c!=')') c=getchar();
	while (c=='(' || c==')'){ch[++len]=c;c=getchar();}
}

struct Edge{
	int v,nxt;
}e[MAXN];

struct Node{
	int dep,id;
	bool f;
}stk[MAXN];

int n,top,fa[MAXN],frt[MAXN],tot=0,dep[MAXN],lst[MAXN];
ll s[MAXN],sbefore[MAXN],ans;
bool f[MAXN];
char ch[MAXN];

void addedge(int u,int v){
	e[++tot].v=v;
	e[tot].nxt=frt[u];
	frt[u]=tot;
}

void dfs(int now){
	if (now==1){
		top++;
		stk[top].dep=1;
		stk[top].id=1;
		stk[top].f=f[now];
		sbefore[now]=0;
	}
	else{
		if (!f[now]){
			top++;
			stk[top].dep=dep[now];
			stk[top].id=now;
			stk[top].f=f[now];
			sbefore[now]=0;
		}
		else{
			if (top>0 && !stk[top].f){
				sbefore[now]=sbefore[fa[stk[top].id]]+1;
				ans+=sbefore[now];
				lst[now]=stk[top].id;
				top--;
			}
			else{
				top++;
				stk[top].dep=dep[now];
				stk[top].id=now;
				stk[top].f=f[now];
				sbefore[now]=0;
			}
		}
	}
	s[now]=ans;
	for (register int i=frt[now];i;i=e[i].nxt){
		dfs(e[i].v);
	}
	if (!sbefore[now]){
		top--;
	}
	else{
		ans-=sbefore[now];
		top++;
		stk[top].dep=dep[lst[now]];
		stk[top].id=lst[now];
		stk[top].f=f[lst[now]];
		sbefore[now]=0;
	}
}

int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	n=readu();
	reads(ch);
//	printf("%s\n",ch);
	for (register int i=1;i<=n;++i){
		if (ch[i-1]=='(') f[i]=0;
		else f[i]=1;
	}
	fa[1]=0;
	dep[1]=1;
	bool ok=1;
	for (register int i=2;i<=n;++i){
		fa[i]=readu();
		if (fa[i]!=i-1) ok=0;
		addedge(fa[i],i);
		dep[i]=dep[fa[i]]+1;
	}
//	printf("%d",ok);
	top=0;
	sbefore[0]=0;
	ans=0;
//	printf("?");
	if (ok){
		for (register int now=1;now<=n;++now){
			if (now==1){
				top++;
				stk[top].dep=1;
				stk[top].id=1;
				stk[top].f=f[now];
				sbefore[now]=0;
			}
			else{
				if (!f[now]){
					top++;
					stk[top].dep=dep[now];
					stk[top].id=now;
					stk[top].f=f[now];
					sbefore[now]=0;
				}
				else{
					if (top>0 && !stk[top].f){
						sbefore[now]=sbefore[fa[stk[top].id]]+1;
						ans+=sbefore[now];
						lst[now]=stk[top].id;
						top--;
					}
					else{
						top++;
						stk[top].dep=dep[now];
						stk[top].id=now;
						stk[top].f=f[now];
						sbefore[now]=0;
					}
				}
			}
			s[now]=ans;
			
		}
	}
	else{
		dfs(1);
	}
	ans=0;
	for (register int i=1;i<=n;++i){
		ans=ans^(i*s[i]);
	}
	cout<<ans;
	return 0;
}

