#include<iostream>
#include<cstdio>
#include<algorithm>
#include<queue>
#include<set>
#include<map>
#include<cmath>
#include<cstring>
#include<cstdlib>
using namespace std;

typedef long long ll;

const int MAXINT=2147483647;
const int INF=0x3f3f3f3f;
const ll INFLL=0x3f3f3f3f3f3f3f3f;
const double EPS=1e-6;
const int MAXN=2005;
const int MAXLOG=11;

int read(){
	int s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

int readu(){
	int s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

ll readll(){
	ll s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

ll readull(){
	ll s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

int n,pos[MAXN],val[MAXN];
int ans[MAXN];
int u[MAXN],v[MAXN],a[MAXN],b[MAXN];

/*
void dfs1(int now){
	for (register int i=frt[now];i;i=e[i].nxt){
		if (e[i].v==anc[now][0]) continue;
		anc[e[i].v][0]=now;
		dep[e[i].v]=dep[now]+1;
		dfs1(e[i].v);
	}
}

int lca(int u,int v){
	if (dep[u]>dep[v]) swap(u,v);
	int kk=MAXLOG;
	while (dep[u]<dep[v]){
		if (dep[anc[v][kk]]>=dep[u]) v=anc[v][kk];
		kk--;
	}
	if (u==v) return u;
	for (register int i=MAXLOG;i>=0;--i){
		if (anc[u][i]!=anc[v][i]){
			u=anc[u][i];
			v=anc[v][i];
		}
	}
	return anc[u][0];
}

void dfs2(int v,int now){
//	printf("(%d,%d)",v,now);
	pre[0][v][now]=pre[0][v][anc[now][0]]+f[0][now];
	pre[1][v][now]=pre[1][v][anc[now][0]]+f[1][now];
	for (register int i=frt[now];i;i=e[i].nxt){
		if (e[i].v==anc[now][0]) continue;
		dfs2(v,e[i].v);
	}
}

bool ok(int v,int p){
	int p0=pos[v];
	int lcap=lca(p0,p);
	int x=p0,y=p;
//	printf("(%d,%d:%d)",p0,p,lcap);
	if (p0!=lcap && p!=lcap){
		while (anc[x][0]!=lcap) x=anc[x][0];
		while (anc[y][0]!=lcap) y=anc[y][0];
	}
//	printf("?");
	for (register int i=1;i<v;++i){
		if (pre[0][i][p0]-pre[0][i][lcap] || pre[1][i][p]-pre[1][i][lcap]){
			return false;
		}
		if (pre[1][i][p0]-pre[1][i][lcap]>1 || pre[0][i][p]-pre[0][i][lcap]>1){
			return false;
		}
		if (p0!=lcap && p!=lcap && pre[1][i][x]-pre[1][i][lcap]==1 && pre[1][i][y]-pre[1][i][lcap]==1){
			return false;
		}
	}
	memset(f,0,sizeof(f));
	int t=v;
	while (p0!=lcap){
		f[0][p0]=1;
		p0=anc[p0][0];
	}
	while (p!=lcap){
		f[1][p]=1;
		p=anc[p][0];
	}
//	printf("!");
	dfs2(t,1);
	
	printf("{");
	for (register int i=1;i<=n;++i){
		printf("%d,%d:%d,%d  ",f[0][i],f[1][i],pre[0][t][i],pre[1][t][i]);
	}
	printf("}");
	
	return true;
}

void solve1(){
//	printf(">");
	memset(dep,0,sizeof(dep));
	memset(anc,0,sizeof(anc));
	memset(pre,0,sizeof(pre));
	dfs1(1);
//	printf("?>");
	anc[1][0]=1;
	for (register int j=1;j<=MAXLOG;++j){
		for (register int i=1;i<=n;++i){
			anc[i][j]=anc[anc[i][j-1]][j-1];
		}
	}
	memset(mark,0,sizeof(mark));
	for (register int i=1;i<=n;++i){
		printf("%d:\n",i);
		for (register int j=1;j<=n;++j){
			if (mark[j]) continue;
			printf("%d ",j);
			if (j==pos[i]) continue;
			if (ok(i,j)){
				mark[j]=true;
				ans[i]=j;
				break;
			}
		}
		printf("\n");
	}
	for (register int i=1;i<=n;++i){
		printf("%d ",ans[i]);
	}
	printf("\n");
}
*/

void solve0(){
	int order[MAXN];
	for (register int i=1;i<=n;++i){
		order[i]=i;
		ans[i]=n;
	}
	do{
		for (register int i=1;i<=n;++i){
			a[i]=val[i];
		}
		for (register int i=1;i<=n;++i){
			swap(a[u[order[i]]],a[v[order[i]]]);
		}
		for (register int i=1;i<=n;++i){
			b[a[i]]=i;
		}
		bool f=0;
		for (register int i=1;i<=n;++i){
			if (b[i]<ans[i]){
				f=1;
				break;
			}
			if (b[i]>ans[i]){
				f=0;
				break;
			}
		}
		if (f){
			for (register int i=1;i<=n;++i){
				ans[i]=b[i];
			}
		}
	}while(next_permutation(order+1,order+n+1));
	for (register int i=1;i<=n;++i){
		printf("%d ",ans[i]);
	}
	printf("\n");
}

int main(){
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	int T=readu();
	while (T--){
		n=read();
		for (register int i=1;i<=n;++i){
			pos[i]=readu();
			val[pos[i]]=i;
		}
		for (register int i=1;i<n;++i){
			u[i]=readu();v[i]=readu();
		}
		if (n<=10){
			solve0();
		}
	}
	return 0;
}

