#include<bits/stdc++.h>
#define ll long long
#define MAXN 2010

using namespace std;

int T , n;
int a[MAXN << 1];
bool vis[MAXN];
int ans[MAXN];
int c[MAXN];
int d[MAXN];

struct xtq{
	int t , nxt , f;
} edge[MAXN << 1];
int Head[MAXN] , cnt;

template <typename T> inline void read(T &x) {
	x = 0; T f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}

template <typename T> inline void chkmax(T &x , T y) {x = x > y ? x : y; }
template <typename T> inline void chkmin(T &x , T y) {x = x < y ? x : y; }

template <typename T> inline void print(T x) {
	if (x > 9) print(x / 10);
	putchar(x % 10 + '0');
}
template <typename T> inline void write(T x) {
	if (x < 0) {x = -x; putchar('-'); }
	print(x);
	putchar('\n');
}

inline void file() {
	freopen("tree.in" , "r" , stdin);
	freopen("tree.out" , "w" , stdout);
}

void Pre() {
	memset(a , 0 , sizeof(a));
	memset(c , 0 , sizeof(c));
	memset(d , 0 , sizeof(d));
	memset(ans , 0 , sizeof(ans));
	memset(vis , 0 , sizeof(vis));
}

inline void Addedge(int u , int v) {
	edge[++cnt].nxt = Head[u];
	edge[cnt].t = v;
	edge[cnt].f = u;
	Head[u] = cnt;
}

inline bool chck() {
	for (int i = 1; i <= n; i++) {
		d[i] = c[i];
	}
	for (int i = 1; i < n; i++) {
		swap(d[edge[a[i]].f] , d[edge[a[i]].t]);
	}
	if (!ans[1]) return 1;
	for (int i = 1; i <= n; i++) {
		if (d[i] < ans[i]) return 1;
		if (ans[i] < d[i]) return 0;
	}
	return 0;
}

inline void dfs1(int dep) {
	if (dep == n) {
		if (chck()) for (int i = 1; i <= n; i++) ans[i] = d[i];
	}
	for (int i = 1; i < n; i++) {
		if (!vis[i]) {
			a[i] = dep; 
			vis[i] = 1;
			dfs1(dep + 1);
			vis[i] = 0;
			a[i] = 0;
		}
	}
}

void Subtask1() {
	for (int i = 1; i <= n; i++) {
		read(c[i]);
	}
	for (int i = 1; i < n; i++) {
		int u , v;
		read(u); read(v);
		Addedge(u , v);
	}
	dfs1(1);
}

int main() {

	file();
	
	read(T);
	
	while(T--) {
		read(n);
		Pre();
		if (n <= 10) {
			Subtask1();
			for (int i = 1; i < n; i++) {
				print(ans[i]);
				putchar(' ');
			} 
			print(ans[n]); putchar('\n');
		}
	}

	return 0;

}

