#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
const int N=100010,M=1000010,P=1e9+7;
const int inf=0x3f3f3f3f;
const int INF=0xcfcfcfcf;
const db eps=1e-9,pi=asin(1)*2;
inline ll read();
#define mem(a,b) memset(a,b,sizeof(a))

int head[N],ver[M],nxt[M],through[M],du[N];
int n,m,tot=1;
int num[N];
inline void add(int x,int y)
{
	ver[++tot]=y,nxt[tot]=head[x],head[x]=tot,du[y]++;
}

int ans[N];
int p[N];
int tmp[N];
int id[N];
bool choose[N];
inline void check()
{
	for(int i=1;i<=n;i++) tmp[i]=num[i];
	for(int i=1;i<n;i++) swap(tmp[ver[id[i]<<1]],tmp[ver[id[i]<<1|1]]);
	for(int i=1;i<=n;i++) p[tmp[i]]=i;
	for(int i=1;i<=n;i++)
	{
		if(p[i]==ans[i]) continue;
		if(p[i]<ans[i]) for(int j=1;j<=n;j++) ans[j]=p[j];
		break;
	}
}
inline void solve(int x)
{
	if(x>=n)
	{
		check();
		return ;
	}
	for(int i=1;i<n;i++)
	{
		if(choose[i]) continue;
		id[x]=i,choose[i]=true;
		solve(x+1);
		choose[i]=false;
	}
}

#define FILE "tree"
#ifdef FILE
const int READ_SIZE=1<<20;
char buf[READ_SIZE],*p1=buf,*p2=buf;
#define getchar() p1==p2&&(p2=(p1=buf)+fread(buf,1,READ_SIZE,stdin),p1==p2)?EOF:*p1++
#endif
inline ll read()
{
	ll s=0;
	bool flag=false;
	char ch=getchar();
	for(;ch<'0'||ch>'9';ch=getchar()) if(ch=='-') flag=true;
	for(;'0'<=ch&&ch<='9';ch=getchar()) s=(s<<3)+(s<<1)+(ch^'0');
	if(flag) return -s;
	return s;
}

inline void subtask1()
{
	solve(1);
	for(int i=1;i<=n;i++) printf("%d ",ans[i]);
	putchar('\n');
}

int pos[N];
int f[N],son[N],in_edge[N];
inline void dfs(int x,int fa)
{
	f[x]=fa;
	for(int i=head[x];i;i=nxt[i])
	{
		int y=ver[i];
		if(y==fa) continue;
		in_edge[y]=i;
		dfs(y,x);
	}
}
bool visit[N];
inline bool can(int i,int j)
{
//	cerr<<i<<" "<<j<<"\n";
	int x=j,lst=0;
	while(x!=pos[i])
	{
//		cerr<<lst<<" ";
		if(through[in_edge[x]]||lst&&through[in_edge[x]^1]==lst) return false;
		lst=through[in_edge[x]^1];
		x=f[x];
	}
//	cerr<<"\n";
	x=j;
	while(x!=pos[i])
	{
		through[in_edge[x]]=j;
		x=f[x];
	}
	return true;
}
inline void subtask2()
{
//	for(int i=1;i<=n;i++) cerr<<pos[i]<<" ";
//	cerr<<"\n\n";
	for(int i=1;i<=n;i++)
	{
		in_edge[pos[i]]=0;
		dfs(pos[i],0);
//		for(int j=1;j<=n;j++) cerr<<f[j]<<" ";
//		cerr<<"\n";
//		for(int j=1;j<=n;j++) cerr<<in_edge[j]<<" ";
//		cerr<<"\n";
		for(int j=1;j<=n;j++)
		{
			if(visit[j]||pos[i]==j) continue;
			if(can(i,j))
			{
				visit[j]=true;
				ans[i]=j;
				break;
			}
//			cerr<<"\n";
		}
//		for(int j=0;j<=tot;j++) cerr<<through[j]<<" ";
//		cerr<<"\n";
	}
//	cerr<<"\n\n";
	
	for(int i=1;i<=n;i++) printf("%d ",ans[i]);
	putchar('\n');
}

int NUM=0,rk[N];
inline void dfs3(int x,int fa)
{
	id[x]=++NUM,rk[NUM]=x;
	for(int i=head[x];i;i=nxt[i])
	{
		int y=ver[i];
		if(y==fa) continue;
		dfs3(y,x);
	}
}
inline void subtask3()
{
	NUM=0;
	int root=0;
	for(int i=1;i<=n;i++) if(du[i]==1) root=i;
	dfs3(root,0);
	
}


inline void subtask4()
{
	int lst=1;
	for(int i=1;i<=n;i++)
	{
		if(pos[i]==i) ans[i]=i+1;
		else ans[i]=lst,lst=i+1;
	}
	for(int i=1;i<=n;i++) printf("%d ",ans[i]);
	putchar('\n');
}

inline void init()
{
	mem(du,0);
	mem(visit,false);
	mem(through,0);
	mem(choose,false);
	for(int i=1;i<=n;i++) ans[i]=n-i+1;
	mem(head,0);
	tot=1;
}

int main()
{
#ifdef FILE
	freopen(FILE ".in","r",stdin);
	freopen(FILE ".out","w",stdout);
#endif
	int T=read();
	while(T--)
	{
		n=read();
		init();
		for(int i=1;i<=n;i++) num[pos[i]=read()]=i;
		for(int i=1;i<n;i++)
		{
			int x=read(),y=read();
			add(x,y),add(y,x);
		}
//*
		if(n<=10)
		{
			subtask1();
			continue;
		}
//*/
		bool yes1=true,yes2=true;
		for(int i=1;i<=n;i++)
		{
			if(du[i]>2) yes1=false;
			if(1<du[i]&&du[i]<n-1) yes2=false;
		}
/*
		if(yes1)
		{
			subtask3();
			continue;
		}
//*/
		if(yes2)
		{
			subtask4();
			continue;
		}
		if(n<=2000)
		{
			subtask2();
			continue;
		}
	}
	return 0;
}
/*
4
5
2 1 3 5 4
1 3
1 4
2 4
4 5
5
3 4 2 1 5
1 2
2 3
3 4
4 5
5
1 2 5 3 4
1 2
1 3
1 4
1 5
10
1 2 3 4 5 7 8 9 10 6
1 2
1 3
1 4
1 5
5 6
6 7
7 8
8 9
9 10
*/
