#include<bits/stdc++.h>
#define ll long long
#define mod 100000007
#define inf 1e9
using namespace std;
const ll size=1000009;
int head[size],ver[size],Next[size];
struct node
{
	char c;
	int l,r,data;
}tree[size];
ll n,m,tot;
ll fa[size];
ll read()
{
	ll ans=0,sign=1;
	char c=getchar();
	while (c>'9' || c<'0')
	{
		if (c=='-') sign=-1;
		c=getchar(); 
	}
	while (c<='9' && c>='0')
	{
		ans=ans*10+c-'0';
		c=getchar();		
	}
	return ans*sign;
}

void add(int x,int y)
{
	ver[++tot]=y;
	Next[tot]=head[x];
	head[x]=tot;
}
ll get(ll x)
{
	return (fa[x]==x)?x:get(fa[x]);
}

ll get_deep(ll x)
{
	return (fa[x]==x)?1:(get_deep(fa[x])+1); 
}
ll get_data(int x,int l,int r)
{
	if (tree[x].c == '(') tree[x].l++;
	if (tree[x].c == ')') tree[x].r++;
	if (l>r) return 1;
	if (x==1) return 0;
	return get_data(fa[x],l,r);
}
void dfs(int x)
{
	tree[x].data=tree[fa[x]].data;
	if (tree[x].c == '(') tree[x].l++;
	if (tree[x].c == ')') 
		tree[x].l=max(0,tree[x].l-1);
	if (tree[x].c == ')')
		tree[x].data+=!(tree[x].l == 0);
	for (int i=head[x];i;i=Next[i])
	{
		int y=ver[i];
		dfs(y);
	}
}

int main()
{   
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	n=read();                          
	for(ll i=1;i<=n;i++)
		tree[i].c=getchar(),fa[i]=i;
	for (ll i=2;i<=n;i++)
	{
		ll x;
		x=read();
		fa[i]=x;
		add(x,i);
	}
	ll ans=0;
	dfs(1);
	for (int i=1;i<=n;i++)
		cout<<tree[i].data<<"  ";
	cout<<endl; 
	//for (int i=1;i<=n;i++)
	//	cout<<get_deep(i)<<" ";
	for (int i=1;i<=n;i++)
		ans=ans^(i*tree[i].data);//,cout<<"i="<<i<<" tree[i].data="<<tree[i].data<<"  ans="<<ans<<endl;
	cout<<endl<<ans<<endl;
}
