#include <bits/stdc++.h>
namespace IO {
	const int BUF = 100000;
	char in[BUF], out[BUF], *inb, *ine, *oute = out;
	inline char readc() {
		if (inb == ine)
			ine = (inb = in) + fread(in, 1, BUF, stdin);
		if (inb == ine) return -1;
		return *(inb++);
	}
	template<typename T> inline void read(T &x) {
		x = 0; char c;
		while ((c = readc()) < '0' || c > '9');
		x = c - '0';
		while ((c = readc()) >= '0' && c <= '9')
			x = x * 10 - '0' + c;
	}
	inline void printc(char c) {
		*(oute++) = c;
		if (oute == out + BUF)
			fwrite(oute = out, 1, BUF, stdout);
	}
	template<typename T> inline void print(T x) {
		static char sta[20];
		if (x > 0) {
			int tp = 0;
			for (; x; x /= 10) sta[++tp] = x % 10 + '0';
			while (tp) printc(sta[tp--]);
		} else printc('0');
		printc('\n');
	}
	struct Flusher {
		~Flusher() {
			fwrite(out, 1, oute - out, stdout);
		}
	} _flu;
}
using IO::read;
using IO::readc;
using namespace std;
typedef long long ll;

const int MAXN = 500005, BOUND = 500000;
struct Edge { int to, next; } edge[MAXN];
int head[MAXN], par[MAXN], n, tot;
void addedge(int u, int v) {
	edge[++tot] = (Edge) { v, head[u] };
	head[u] = tot;
}
ll f[MAXN];
int lst[MAXN];
char str[MAXN];
void dfs(int u) {
	if (str[u] == '(') {
		f[u] = 0;
		lst[u] = u;
	} else {
		int l = lst[par[u]];
		if (l > 0) {
			f[u] = f[par[l]] + 1;
			lst[u] = lst[par[l]];
		} else {
			f[u] = 0;
			lst[u] = 0;
		}
	}
	for (int i = head[u]; i; i = edge[i].next)
		dfs(edge[i].to);
}
void readstr() {
	char c;
	while ((c = readc()) != '(' && c != ')');
	str[1] = c;
	for (int i = 2; i <= n; i++)
		str[i] = readc();
}
int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	read(n);
	readstr();
	for (int i = 2; i <= n; i++) {
		read(par[i]);
		addedge(par[i], i);
	}
	dfs(1);
	for (int i = 2; i <= n; i++)
		f[i] += f[par[i]];
	ll ans = 0;
	for (int i = 1; i <= n; i++)
		ans ^= i * f[i];
	printf("%lld\n", ans);
//	for (int i = 1; i <= n; i++)
//		printf("%lld ", f[i]);
	return 0;
}
