#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2005, MAXM = 4005;
struct Edge { int to, next; } edge[MAXM];
int head[MAXN], tot;
void addedge(int u, int v) {
	edge[++tot] = (Edge) { v, head[u] };
	head[u] = tot;
}
int T, n, fr[MAXN], to[MAXN], pp[MAXN], id[MAXN], tmp[MAXN], deg[MAXN], mp[MAXN];
int pre[MAXN], ban[MAXN << 1], pree[MAXN], mn;
void dfs(int u, int fa) {
	mn = min(mn, u);
	for (int i = head[u]; i; i = edge[i].next) if (!ban[i]) {
		int v = edge[i].to;
		if (v == fa) continue;
		pre[v] = u;
		pree[v] = i;
		dfs(v, u);
	}
}
int getrev(int x) {
	return x & 1 ? x + 1 : x - 1;
}
int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	for (scanf("%d", &T); T--;) {
		memset(deg, 0, sizeof(deg));
		memset(ban, 0, sizeof(ban));
		scanf("%d", &n);
		for (int i = 1; i <= n; i++) {
			int t;
			scanf("%d", &t);
			tmp[t] = i;
			mp[i] = t;
		}
		for (int i = 1; i < n; i++) {
			scanf("%d%d", fr + i, to + i);
			id[i] = i;
			++deg[fr[i]], ++deg[to[i]];
			addedge(fr[i], to[i]);
			addedge(to[i], fr[i]);
		}
		int mx = 0;
		for (int i = 1; i <= n; i++) mx = max(mx, deg[i]);
		if (n <= 10) {
			vector<int> ans(n + 1, 1E9), mp(n + 1, 0);
			do {
				for (int i = 1; i <= n; i++) pp[i] = tmp[i];
				for (int i = 1; i < n; i++)
					swap(pp[fr[id[i]]], pp[to[id[i]]]);
				for (int i = 1; i <= n; i++)
					mp[pp[i]] = i;
				ans = min(ans, mp);
			} while (next_permutation(id + 1, id + n));
			for (int i = 1; i <= n; i++)
				printf("%d ", ans[i]);
			puts("");
		} else if (mx == 2) {
			for (int i = 1; i <= n; i++) {
				mn = 1E9;
				dfs(mp[i], 0);
				printf("%d ", mn);
				for (int j = mn; j != mp[i]; j = pre[j])
					pp[j] = tmp[j];
				for (int j = mn; j != mp[i]; j = pre[j]) {
					ban[pree[j]] = ban[getrev(pree[j])] = 1;
					tmp[pre[j]] = pp[j];
				}
				tmp[mn] = i;
				for (int j = head[mn]; j; j = edge[j].next)
					ban[j] = 1;
				for (int j = 1; j <= n; j++)
					mp[tmp[j]] = j;
			}
		}
	}
	return 0;
}
