#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cctype>
using namespace std;

const int maxn = 1e5 + 17;
int T, n, num[maxn];
int tot, to[maxn], frm[maxn], nxt[maxn], hd[maxn], used[maxn];
int per[maxn], rmb[maxn];
int P[maxn], ans[maxn];

void addedge(int u, int v) {
	tot++, to[tot] = v, frm[tot] = u, nxt[tot] = hd[u], hd[u] = tot;
}

void fileio() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
}

void read() {
	for(int i = 1; i < n; i++) {
		int u, v;
		scanf("%d%d", &u, &v);
		addedge(u, v), addedge(v, u);
	}
}

void del(int i) {
	int x = i * 2 - 1, y = i * 2;
	int u = frm[x], v = to[x];
//	cout << u << " " << v << endl;
//	cout << num[u] << num[v] << endl;
	swap(num[u], num[v]);
//	cout << num[u] << num[v] << endl;
	used[x] = 1, used[y] = 1;
}

void tsk1() {
	for(int i = 1; i < n; i++) per[i] = i;
	do {
		for(int i = 1; i <= tot; i++) used[i] = 0;
		for(int i = 1; i <= n; i++) rmb[i] = num[i];
		for(int h = 1; h < n; h++) {
			int i = per[h];
			del(i);
		}
//		for(int i = 1; i < n; i++) printf("%d%c", per[i], " \n"[i == n - 1]);
//		for(int i = 1; i <= n; i++) printf("%d%c", num[i], " \n"[i == n]);
		for(int i = 1; i <= n; i++) P[num[i]] = i;
//		for(int i = 1; i <= n; i++) printf("%d%c", P[i], " \n"[i == n]);
		for(int i = 1; i <= n; i++) {
			if(P[i] < ans[i]) {
				for(int j = 1; j <= n; j++) ans[j] = P[j];
				break;
			}
			else if(P[i] > ans[i]) {
				break;
			}
		}
		
		for(int i = 1; i <= n; i++) num[i] = rmb[i];
	} while(next_permutation(per + 1, per + n));
}

void init() {
	tot = 0;
	for(int i = 1; i <= n; i++) ans[i] = n + 1 - i;
	memset(num, 0, sizeof(num));
	memset(to, 0, sizeof(to));
	memset(frm, 0, sizeof(frm));
	memset(nxt, 0, sizeof(nxt));
	memset(hd, 0, sizeof(hd));
	memset(used, 0, sizeof(used));
}

int main() {
	fileio();
	scanf("%d", &T);
	while(T--) {
		scanf("%d", &n);
		init();
		for(int i = 1; i <= n; i++) {
			int tmp;
			scanf("%d", &tmp);
			num[tmp] = i;
		}
		read();
		if(n <= 10) tsk1();
		for(int i = 1; i <= n; i++) printf("%d%c", ans[i], " \n"[i == n]);
	}
	return 0;
}

