#include<bits/stdc++.h>
#define LL long long

using namespace std;

struct Edge {
	int v, next;
} edge[10010];

struct Node {
	int id, val;
} nod[10010];

int T, n, minn, minpos, roo, tot = 1, head[10010], deg[10010], pos[10010], num[10010], ans[10010], a[10010];
bool juhua = false, lian = true, fir = true, vis[10010], del[2010][2010];

inline int read() {
	char c = getchar(); int ret = 0, sig = 1;
	while (c < '0' || c > '9') { if (c == '-') sig = -1; c = getchar(); }
	while (c >= '0' && c <= '9') { ret = ret * 10 + c - '0'; c = getchar(); }
	return ret * sig;
}

inline void add(int x, int y) {
	edge[++tot].v = y;
	edge[tot].next = head[x]; head[x] = tot;
}

inline void find_min(int x) {
//	cout << x << endl;
	vis[x] = 1;
	if (num[x] < minn) {
		minn = num[x];
		minpos = pos[x];
	}
	for (int i = head[x]; i; i = edge[i].next) {
		int y = edge[i].v;
		if (del[x][y] || vis[y]) continue;
		find_min(y);
	}
}

inline bool cmp(Node a, Node b) {
	return a.val < b.val;
}

inline void dfs(int dep) {
	if (dep > n - 1) {
		for (int i = 1; i <= n; i++)
			nod[i].id = i, nod[i].val = num[i];
		for (int i = 1; i < n; i++) {
			int x = edge[a[i]].v, y = edge[a[i] ^ 1].v;
			swap(nod[x].val, nod[y].val);
		}
		sort(nod + 1, nod + n + 1, cmp);
		if (fir) {
			fir = 0;
			for (int i = 1; i <= n; i++)
				ans[i] = nod[i].id;
		} else {
			bool ok = 0;
			for (int i = 1; i <= n; i++) {
				if (nod[i].id == ans[i]) continue;
				if (nod[i].id < ans[i]) ok = 1;
				else ok = 0;
				break;
			}
			if (ok)
				for (int i = 1; i <= n; i++)
					ans[i] = nod[i].id;
		}
		return;
	}
	for (int i = 2; i <= tot; i += 2) {
		if (vis[i]) continue;
		vis[i] = 1, a[dep] = i;
		dfs(dep + 1);
		vis[i] = 0, a[dep] = 0;
	}
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	T = read();
	while (T--) {
		n = read();
		tot = 1;
		memset(deg, 0, sizeof(deg));
		memset(head, 0, sizeof(head));
		memset(vis, 0, sizeof(vis));
		for (int i = 1; i <= n; i++) {
			int x = read();
			num[x] = i;
		}
		for (int i = 1; i < n; i++) {
			int x = read(), y = read();
			add(x, y), add(y, x);
			deg[x]++, deg[y]++;
			if (deg[x] > 2 || deg[y] > 2) lian = false;
			if (deg[x] == n - 1) juhua = true, roo = x;
			if (deg[y] == n - 1) juhua = true, roo = y;
		}
		if (lian && n > 10) {
			for (int i = 1; i <= n; i++) {
				if (deg[i] == 1) {
					nod[1].id = i, nod[1].val = num[i];
					pos[i] = 1;
					vis[1] = 1; break;
				}
			}
			for (int i = 1; i <= n - 1; i++) {
				for (int j = head[nod[i].id]; j; j = edge[j].next) {
					int y = edge[j].v;
					if (!vis[y]) {
						vis[y] = 1;
						nod[i + 1].id = y, nod[i + 1].val = num[y];
						pos[y] = i + 1;
						break;
					}
				}
			}
			for (int i = 1; i <= n; i++) {
				memset(vis, 0, sizeof(vis));
				minn = 1 << 30;
				find_min(i);
				int x = minpos;
				while (x != pos[i]) {
					int nxt;
					if (x > pos[i]) nxt = x - 1;
					else nxt = x + 1;
					swap(nod[x].val, nod[nxt].val);
					del[nod[x].id][nod[nxt].id] = del[nod[nxt].id][nod[x].id] = 1;
					x = nxt;
				}
			}
			sort(nod + 1, nod + n + 1, cmp);
			for (int i = 1; i <= n; i++)
				printf("%d ", nod[i].id);
			printf("\n");
		} else {
			if (n > 10 && juhua) {
				for (int i = 1; i <= n; i++) printf("%d ", i);
				printf("\n");
			} else {
				fir = 1;
				dfs(1);
				for (int i = 1; i <= n; i++) printf("%d ", ans[i]);
				printf("\n");
			}
		}
	}
	return 0;
}

