#include <iostream>
#include <cstring>
using namespace std;
typedef long long ll;

int a[2019], d[2019];
int pa[2019], mp[2019];
bool vis[2019];

void init()
{
	for (int i=1; i<2019; i++) pa[i]=i;
}
int fnd(int x)
{
	if (pa[x]==x) return x;
	return pa[x]=fnd(pa[x]);
}
void unite(int x, int y)
{
	x=fnd(x); y=fnd(y);
	pa[x]=y;
}

int main()
{
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int t; cin>>t;
	while(t--)
	{
		init();
		memset(d, 0, sizeof(d));
		int n; cin>>n;
		for (int i=1; i<=n; i++) 
		{
			cin>>a[i];	mp[a[i]]=i;
		}
		for (int i=1; i<n; i++)
		{
			int x, y; cin>>x>>y;
			d[x]++; d[y]++;
		}
		
		int check=0;
		for (int i=1; i<=n; i++)
		{
			if (d[i]==n-1) check=1;
		}
		if (check)
		{
			memset(vis, 0, sizeof(vis));
			for (int i=1; i<=n; i++)
			{
				for (int j=1; j<=n; j++)
				{
					if (!vis[j]&&(i==n || fnd(j)!=fnd(mp[i])))
					{
						vis[j]=1;
						cout << j << ' ';
						unite(j, mp[i]);
						break;
					}
				}
			}
		}
		cout << endl;
	}
}
