#include <iostream>
#include <cstdio>

using namespace std;

unsigned long long pow_2_ull(unsigned long long n) {
	unsigned long long result = 1;
	while (n > 0) {
		result <<= 1;
		n --;
	}
	return result;
}

void solve(unsigned long long n, unsigned long long k) {
	if (n <= 0) return;
	unsigned long long tmp = pow_2_ull(n - 1);
	if (k < tmp) {
		cout << '0';
		solve(n - 1, k);
	} else {
		cout << '1';
		solve(n - 1, tmp - (k - tmp) - 1);
	}
}

int main() {
	
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);
	
	unsigned long long n, k;
	cin >> n >> k;
	
	solve(n, k);
	
	return 0;
	
}
