#include<bits/stdc++.h>
using namespace std;
const int N = 2000 + 10;
const int INF = 1e9;

int T, n, w[N], v[N];
struct Edge { int x, y; } e[N];
int a[N], ans[N];
bool vis[N], flag;


void check(){
	for(int i = 1; i < n; ++ i){
		int x = e[a[i]].x, y = e[a[i]].y;
		swap(v[x], v[y]);
	}
	for(int i = 1; i <= n; ++ i){
		w[v[i]] = i;
	}
	for(int i = 1; i <= n; ++ i){
		if(w[i] < ans[i]){
			for(int j = 1; j <= n; ++ j)
				ans[j] = w[j];
			break;
		}
		if(w[i] > ans[i]) break;
	}
	for(int i = n - 1; i >= 1; -- i){
		int x = e[a[i]].x, y = e[a[i]].y;
		swap(v[x], v[y]);
	}
}
void dfs(int step){
	if(step == n){
		check();
		return;
	}
	for(int i = 1; i < n; ++ i){
		if(!vis[i]){
			vis[i] = true;
			a[step] = i;
			dfs(step + 1);
			vis[i] = false;
		}
	}
}
void solve1(){
	for(int i = 1; i <= n; ++ i) ans[i] = INF;
	dfs(1);
	for(int i = 1; i <= n; ++ i) printf("%d ", ans[i]);
	printf("\n");
}

#define lson (x << 1)
#define rson (x << 1 | 1)
int data[N << 2];
void update(int x){
	data[x] = min(data[lson], data[rson]);
}
void build(int x, int l, int r){
	if(l == r){
		data[x] = v[l];
		return;
	}
	int mid = (l + r) >> 1;
	build(lson, l, mid);
	build(rson, mid + 1, r);
	update(x);
	return;
}
void modify(int x, int l, int r, int POS){
	if(l == r){
		data[x] = v[l];
		return;
	}
	int mid = (l + r) >> 1;
	if(POS <= mid) modify(lson, l, mid, POS);
	else modify(rson, mid + 1, r, POS);
	update(x);
	return;
}
int query(int x, int l, int r, int L, int R){
	if(L <= l && r <= R){
		return data[x];
	}
	int mid = (l + r) >> 1;
	int minx = INF;
	if(L <= mid) minx = min(minx, query(lson, l, mid, L, R));
	if(R > mid) minx = min(minx, query(rson, mid + 1, r, L, R));
	return minx;
}
void solve2(){
	build(1, 1, n);
	int pos = 1;
	while(pos < n){
		int p = query(1, 1, n, pos, n);
		int dd = w[p];
		for(int i = dd - 1; i >= pos; -- i){
			int x = e[a[i]].x, y = e[a[i]].y;
			swap(v[x], v[y]);
		}
		if(dd == pos) pos = dd + 1;
		else modify(1, 1, n, dd), pos = dd;
//		puts("1");
	}
	for(int i = 1; i <= n; ++ i){
		w[v[i]] = i;
	}
	for(int i = 1; i <= n; ++ i) printf("%d ", w[i]);
	printf("\n");
}

void solve3(){
	for(int i = 1; i <= n; ++ i) printf("%d ", i);
	printf("\n");
}

int main()
{
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	scanf("%d", &T);
	while(T --){
		flag = true;
		scanf("%d", &n);
		for(int i = 1; i <= n; ++ i){
			scanf("%d", &w[i]);
			v[w[i]] = i;
		}
		for(int i = 1, a, b; i < n; ++ i){
			scanf("%d%d", &e[i].x, &e[i].y);
			if(e[i].y != e[i].x + 1){
				flag = false;
			}
		}
		if(n <= 10) solve1();
		else if(flag) solve2();
		else solve3();
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
