#include<bits/stdc++.h>
using namespace std;
const int MAXN = 4e3 + 5;
template <typename T> void read(T &x) {
	x = 0; int f = 1;
	char ch = getchar();
	for (; !isdigit(ch); ch = getchar()) if (ch == '-') f = -f;
	for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
	x *= f;
}
int n;
namespace force {
	int x[MAXN], y[MAXN], a[MAXN];
	bool vis[MAXN]; int res[MAXN], v[MAXN];
	void dfs(int pos) {
		if (pos == n) {
			static int tmp[MAXN], tres[MAXN];
			for (int i = 1; i <= n; i++)
				tmp[i] = v[i];
			for (int i = 1; i <= n - 1; i++)
				swap(tmp[x[a[i]]], tmp[y[a[i]]]);
			for (int i = 1; i <= n; i++)
				tres[tmp[i]] = i;
			bool flg = true;
			for (int i = 1; i <= n; i++) {
				if (tres[i] < res[i]) break;
				if (tres[i] > res[i]) {
					flg = false;
					break;
				}
			}
			if (flg) {
				for (int i = 1; i <= n; i++)
					res[i] = tres[i];
			}
			return;
		}
		for (int i = 1; i <= n - 1; i++)
			if (!vis[i]) {
				vis[i] = true;
				a[pos] = i;
				dfs(pos + 1);
				vis[i] = false;
			}
	}
	void work() {
		res[1] = n + 1;
		for (int i = 1; i <= n; i++) {
			int x; read(x);
			v[x] = i;
		}
		for (int i = 1; i <= n - 1; i++)
			read(x[i]), read(y[i]);
		dfs(1);
		for (int i = 1; i <= n; i++)
			printf("%d ", res[i]);
		printf("\n");
	}
}
bool vis[MAXN];
int tot, p[MAXN], v[MAXN], ans[MAXN];
vector <int> a[MAXN], stk, bak;
pair <int, int> e[MAXN];
void dfs(int pos, int fa, int goal) {
	stk.push_back(pos);
	if (pos == goal) bak = stk;
	for (unsigned i = 0; i < a[pos].size(); i++)
		if (a[pos][i] != fa) dfs(a[pos][i], pos, goal);
	stk.pop_back();
}
void efs(int pos, int fa) {
	p[++tot] = pos;
	for (unsigned i = 0; i < a[pos].size(); i++)
		if (a[pos][i] != fa && !vis[a[pos][i]]) {
			e[tot] = make_pair(a[pos][i], pos);
			efs(a[pos][i], pos);
		}
}
void solve(int l, int r) {
	if (l == r) {
		ans[v[p[l]]] = p[l];
		return;
	}
	for (int i = l; i <= r; i++) {
		a[p[i]].clear();
		vis[p[i]] = false;
	}
	for (int i = l; i <= r - 1; i++) {
		a[e[i].first].push_back(e[i].second);
		a[e[i].second].push_back(e[i].first);
	}
	int s = 0, t = 0;
	for (int i = l; i <= r; i++)
		if (s == 0 || v[p[i]] < v[s]) s = p[i];
	for (int i = l; i <= r; i++)
		if (p[i] != s && (t == 0 || p[i] < t)) t = p[i];
	ans[v[s]] = t;
	dfs(s, 0, t), tot = l - 1;
	vector <pair <int, int> > nxt;
	for (unsigned i = 0; i < bak.size(); i++)
		vis[bak[i]] = true;
	for (int i = bak.size() - 1; i >= 1; i--) {
		pair <int, int> cur;
		cur.first = tot + 1;
		efs(bak[i], 0);
		cur.second = tot;
		nxt.push_back(cur);
		for (int j = cur.first; j <= cur.second; j++) {
			if (p[j] == bak[i]) p[j] = bak[i - 1];
			if (e[j].first == bak[i]) e[j].first = bak[i - 1];
			if (e[j].second == bak[i]) e[j].second = bak[i - 1];
		}
	}
	for (unsigned i = 0; i < bak.size() - 1; i++)
		v[bak[i]] = v[bak[i + 1]];
	for (unsigned i = 0; i < a[s].size(); i++)
		if (!vis[a[s][i]]) {
			e[tot] = make_pair(s, a[s][i]);
			efs(a[s][i], 0);
		}
	nxt[nxt.size() - 1].second = tot;
	assert(tot <= r);
	for (unsigned i = 0; i < nxt.size(); i++)
		solve(nxt[i].first, nxt[i].second);
}
int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int T; read(T);
	while (T--) {
		read(n);
		if (n <= 10) {
			force :: work();
			continue;
		}
		for (int i = 1; i <= n; i++) {
			int x; read(x);
			v[x] = p[i] = i;
		}
		for (int i = 1; i <= n - 1; i++)
			read(e[i].first), read(e[i].second);
		solve(1, n);
		for (int i = 1; i <= n; i++)
			printf("%d ", ans[i]);
		printf("\n");
	}
	return 0;
}
