#include <bits/stdc++.h>
#define ll long long
using namespace std;
template <typename T> void chkmax(T &x, T y) {x = x > y ? x : y;}
template <typename T> void chkmin(T &x, T y) {x = x < y ? x : y;}
template <typename T> void read(T &x) {
	x = 0; int f = 1; char c = getchar();
	while (!isdigit(c)) {if (c == '-') f = -1; c = getchar();}
	while (isdigit(c)) x = x * 10 + c - '0', c = getchar(); x *= f;
}
typedef pair <int, int> pr;
const int N = 1010;
int n, cnt, v[N], s[N], head[N];
struct Edge {int next, num;} e[N * 3];
void add(int x, int y) {e[++cnt] = (Edge) {head[x], y}, head[x] = cnt;}
namespace bf {
	const static int N = 20;
	int a[N], b[N], v[N], p[N], tx[N], ty[N], ans[N];
	void solve() {
		for (int i = 1, x; i <= n; i++) read(x), v[x] = i;
		for (int i = 1; i < n; i++) read(tx[i]), read(ty[i]);
		for (int i = 1; i < n; i++) p[i] = i;
		for (int i = 1; i <= n; i++) ans[i] = n;
		do {
			for (int i = 1; i <= n; i++) a[i] = v[i];
			for (int i = 1; i < n; i++) swap(a[tx[p[i]]], a[ty[p[i]]]);
			for (int i = 1; i <= n; i++) b[a[i]] = i;
			bool fl = true;
			for (int i = 1; i <= n; i++)
				if (b[i] != ans[i]) {fl = b[i] < ans[i]; break;}
			if (fl)
				for (int i = 1; i <= n; i++) ans[i] = b[i];
		} while (next_permutation(p + 1, p + n));
		for (int i = 1; i <= n; i++) cout << ans[i] << ' '; cout << '\n';
	}
}
namespace subtask1 {
	int len, a[N], id[N], ps[N], ans[N], used[N][N];
	bool check() {
		for (int i = 1; i <= n; i++) if (s[i] > 2) return false;
		return true;
	}
	void dfs(int x, int fa) {
		a[++len] = x, id[x] = len;
		for (int p = head[x]; p; p = e[p].next)
			if (e[p].num ^ fa) dfs(e[p].num, x);
	}
	void solve() {
		int rt;
		for (int i = 1; i <= n; i++)
			if (s[i] == 1) {rt = i; break;}
		for (int i = 1; i <= n; i++) for (int j = 1; j <= n; j++) used[i][j] = 0;
		len = 0, dfs(rt, 0);
		for (int i = 1; i <= n; i++) ps[v[i]] = i;
		for (int i = 1; i <= n; i++) {
			int p = id[ps[i]], tx = p - 1; pr l = make_pair(INT_MAX, p), r = make_pair(INT_MAX, p);
			while (tx && !used[a[tx]][a[tx + 1]]) chkmin(l, pr(a[tx], tx)), tx--; tx = p + 1;
			while (tx <= n && !used[a[tx]][a[tx - 1]]) chkmin(r, pr(a[tx], tx)), tx++;
			if (l.first == INT_MAX && r.first == INT_MAX) {ans[i] = a[p]; continue;}
			if (l < r) {
				int tp = l.second;
				if (tp == 1 || used[a[tp - 1]][a[tp]]) {
					for (int j = p; j > tp; j--) used[a[j]][a[j - 1]] = used[a[j - 1]][a[j]] = 1, v[a[j]] = v[a[j - 1]];
					v[a[tp]] = i, ans[i] = a[tp]; for (int j = 1; j <= n; j++) ps[v[j]] = j;
					continue;
				}
				used[a[tp - 1]][a[tp]] = used[a[tp]][a[tp - 1]] = 1, swap(v[a[tp - 1]], v[a[tp]]);
				for (int j = p; j > tp; j--) used[a[j]][a[j - 1]] = used[a[j - 1]][a[j]] = 1, v[a[j]] = v[a[j - 1]];
				v[a[tp]] = i, ans[i] = a[tp];
				for (int j = 1; j <= n; j++) ps[v[j]] = j;
			} else {
				int tp = r.second;
				if (tp == n || used[a[tp + 1]][a[tp]]) {
					for (int j = p; j < tp; j++) used[a[j]][a[j + 1]] = used[a[j + 1]][a[j]] = 1, v[a[j]] = v[a[j + 1]];
					v[a[tp]] = i, ans[i] = a[tp]; for (int j = 1; j <= n; j++) ps[v[j]] = j;
					continue;
				}
				used[a[tp + 1]][a[tp]] = used[a[tp]][a[tp + 1]] = 1, swap(v[a[tp + 1]], v[a[tp]]);
				for (int j = p; j < tp; j++) used[a[j]][a[j + 1]] = used[a[j + 1]][a[j]] = 1, v[a[j]] = v[a[j + 1]];
				v[a[tp]] = i, ans[i] = a[tp];
				for (int j = 1; j <= n; j++) ps[v[j]] = j;
			}
		}
		for (int i = 1; i <= n; i++) cout << ans[i] << ' '; cout << '\n';
	}
}
void solve() {
	read(n), cnt = 0;
	memset(head, 0, sizeof(head)), memset(s, 0, sizeof(s)), memset(e, 0, sizeof(e));
	if (n <= 10) return bf::solve(), void();
	for (int i = 1, x; i <= n; i++) read(x), v[x] = i;
	for (int i = 1; i < n; i++) {
		int x, y; read(x), read(y);
		add(x, y), add(y, x), s[x]++, s[y]++;
	}
	if (subtask1::check()) subtask1::solve();
}
int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int T; read(T);
	while (T--) solve();
	return 0;
}
