#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
template <typename T> inline void read(T &x)
{
	int f = 1; x = 0; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}
const int N = 5e5 + 5;
int head[N], ver[N], Next[N], tot;
inline void add(int u, int v)
{
	ver[++tot] = v;
	Next[tot] = head[u];
	head[u] = tot;
}
int n;
bool op[N];
namespace solver1
{
	const int M = 2e3 + 5;
	int ans[M];
	inline bool check(vector <int> now)
	{
		reverse(now.begin(), now.end());
		stack <int> s;
		for (int i = 0; i < now.size(); i++)
		{
			if (now[i] == 0) s.push(0);
			else if (s.empty()) return 0;
			else s.pop();
		}
		if (!s.empty()) return 0;
		return 1;
	}
	inline int calc(vector <int> bra)
	{
		int ret = 0;
		vector <int> now; now.clear();
		for (int i = bra.size() - 1; i >= 0; i--)
		{
			now.push_back(bra[i]);
			ret += check(now);
		}
		return ret;
	}
	inline void dfs(int x, int fa, vector <int> bra)
	{
		ans[x] = ans[fa];
		bra.push_back(op[x]);
		
		ans[x] += calc(bra);
		for (int i = head[x]; i; i = Next[i])
		{
			int v = ver[i];
			if (v == fa) continue;
			dfs(v, x, bra);
		} 
	}
	inline void solve()
	{
		vector <int> vec; vec.clear();
		dfs(1, 0, vec);
		ll ret = 0;
		for (int i = 1; i <= n; i++) ret = ret ^ (i * ans[i]);
		printf("%lld\n", ret);
	}
}
namespace solver2
{
	const int M = 2e3 + 5;
	int ans[M];
	inline int calc(vector <int> bra)
	{
		int ret = 0;
		stack <int> s;
		reverse(bra.begin(), bra.end());
		for (int i = 0; i < bra.size(); i++) bra[i] ^= 1;

		for (int i = 0; i < bra.size(); i++)
		{
			if (bra[i] == 0) s.push(0);
			else if (s.empty()) break;
			else s.pop();
			
			if (s.empty()) ret++;
		}
		return ret;
	}
	inline void dfs(int x, int fa, vector <int> bra)
	{
		ans[x] = ans[fa];
		bra.push_back(op[x]);
		
		ans[x] += calc(bra);
		for (int i = head[x]; i; i = Next[i])
		{
			int v = ver[i];
			if (v == fa) continue;
			dfs(v, x, bra);
		} 
	}
	inline void solve()
	{
		vector <int> vec; vec.clear();
		dfs(1, 0, vec);
		ll ret = 0;
		for (int i = 1; i <= n; i++) ret = ret ^ (i * ans[i]);
		printf("%lld\n", ret);
	}
}
int main(){
	freopen ("brackets.in", "r", stdin);
	freopen ("brackets.out", "w", stdout);
	read(n);
	for (int i = 1; i <= n; i++)
	{
		char c = getchar();
		if (c == '(') op[i] = 0;
		else op[i] = 1;
	}
	for (int i = 2; i <= n; i++)
	{
		int fa;
		read(fa);
		add(fa, i);
	}
	if (n <= 2e2) solver1::solve();
	else if (n <= 2e3) solver2::solve();
  return 0;
}
