#include<bits/stdc++.h>
using namespace std;
template <typename T> inline void read(T &x)
{
	int f = 1; x = 0; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}
const int N = 2e3 + 5;
struct info { int u, v; } E[N];
int n, val[N], p[N], nowval[N], pos[N];
namespace solver1
{
	vector <int> ans, now;
	inline int calc()
	{
		for (int i = 1; i <= n; i++) nowval[i] = val[i];
	
		for (int i = 1; i < n; i++) swap(nowval[E[p[i]].u], nowval[E[p[i]].v]);
	
		for (int i = 1; i <= n; i++) pos[nowval[i]] = i;
	
		now.clear();
		for (int i = 1; i <= n; i++) now.push_back(pos[i]);
	
		for (int i = 0; i < n; i++)
		if (now[i] != ans[i])
		{
			if (now[i] > ans[i]) return n - i;
			return -1;
		}
		return 0;
	}
	inline void BackFire()
	{
		for (int i = 1; i < n; i ++) p[i] = i;
		double T = 2500;
	
		while (T > 1e-14)
		{
			int x, y;
			do
			{
				x = rand() % (n - 1) + 1;
				y = rand() % (n - 1) + 1;
			} while (x == y); 
		
			swap(p[x], p[y]);
			int nowans = calc();
			if (nowans <= 0) ans = now;
			else if (exp(-nowans * 1.0 / 100000 / T) * RAND_MAX < rand()) swap(p[x], p[y]);
		
			T *= 0.98;
		}
	}
	
	inline void solve()
	{
		ans.clear();
		for (int i = 1; i <= n; i++) ans.push_back(n + 1), p[i] = i;
		double t = clock();
		while (clock() - t <= 0.14 * CLOCKS_PER_SEC) BackFire();
	
		for (int i = 0; i < n - 1; i++) printf("%d ", ans[i]);
		printf("%d\n", ans[n - 1]);
	}
}
inline void doit()
{
	read(n);
	for (int i = 1; i <= n; i++)
	{
		int x; read(x);
		val[x] = i;
	}
	for (int i = 1; i < n; i++) { read(E[i].u); read(E[i].v); }
	
	solver1::solve();
}
int main(){
	freopen ("tree.in", "r", stdin);
	freopen ("tree.out", "w", stdout);
	srand(time(0));
	int T;
	read(T);
	while (T--) doit();
  return 0;
}
