#include <bits/stdc++.h>
using namespace std;

typedef long long LL;
typedef pair<int, int> P;
const int N = 1000010;
int n, top;
LL ans[N], cnt[N];
int fa[N], a[N], s[N], stk[N];
string st;
vector<int> E[N / 2];

template <typename T> void read(T &a) {
	a = 0; char c = getchar(); int f = 1;
	while (!isdigit(c)) { if (c == '-') f = -1; c = getchar(); }
	while (isdigit(c)) { a = a * 10 + c - '0'; c = getchar(); }
	a *= f;
}

void dfs(int u) {
	ans[u] = ans[fa[u]];
	s[u] = s[fa[u]] + a[u];
	vector<P> t; t.clear();
	bool fg = 0;
	while (top && s[u] < stk[top]) {
		t.push_back(P(stk[top], cnt[top]));
		--top;
	}
	if (top && s[u] == stk[top]) {
		ans[u] += cnt[top];
		++cnt[top];
		fg = 1;
	}
	else {
		stk[++top] = s[u], cnt[top] = 1;
	}
	for (int i=0;i<E[u].size();++i) dfs(E[u][i]);
	if (fg) --cnt[top]; else --top;
	for (int i=0;i<t.size();++i) {
		++top;
		stk[top] = t[i].first, cnt[top] = t[i].second;
	}
	t.clear();
}

int main() {
	freopen("brackets.in", "r", stdin); freopen("brackets.out", "w", stdout);
	read(n); cin >> st;
	for (int i=1;i<=n;++i) {
		if (st[i - 1] == '(') a[i] = 1;
		else a[i] = -1;
	}
	for (int i=2;i<=n;++i) {
		read(fa[i]);
		E[fa[i]].push_back(i);
	}
	stk[top = 1] = 0;
	cnt[top] = 1;
	dfs(1);
	LL ret = 0;
	for (int i=1;i<=n;++i) ret ^= ((LL)i * (LL)ans[i]);
	cout << ret << endl;
	return 0;
}

