#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
const int maxn=500005;
int n;
long long ans=0;
int eid=0;
int l[maxn],r[maxn],p[maxn];
long long k[maxn];
char s[maxn];
struct edge
{
	int v,next;
}E[maxn];
void insert(int u,int v)
{
	E[eid].v=v;
	E[eid].next=p[u];
	p[u]=eid++;
}
void dfs(int u,int fa)
{
	if(l[u])
	{
		k[u]=k[fa];
		l[u]+=l[fa];
		r[u]+=r[fa];
	}
	else if(r[u])
	{
		if(l[fa]>=r[u]+r[fa])
		{
			k[u]=k[fa]+1;
			r[u]+=r[fa];
			l[u]+=l[fa];
		}	
		else
		{
			k[u]=k[fa];
			l[u]=0;
			r[u]=0;
		}	
	}
	ans=ans^(u*k[u]);
	for(int i=p[u];i!=-1;i=E[i].next)
	{
		int v=E[i].v;
		dfs(v,u);
	}
}
int main()
{
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d",&n);
	scanf("%s",s+1);
	memset(p,-1,sizeof(p));
	for(int i=2;i<=n;i++)
	{
		int u;
		scanf("%d",&u);
		insert(u,i);
	}
	for(int i=1;i<=n;i++)
	{
		if(s[i]=='(')
		{
			l[i]++;
		}
		else
		{
			r[i]++;
		}
	}
	dfs(1,0);
	printf("%lld\n",ans);
	return 0;
}
