#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
const int maxn=2005;
int num[maxn],vis[maxn],f[maxn],p[maxn];
int t,n,eid,flag,eoq=0;
struct edge
{
	int v,next,len;
}E[2*maxn];
void init()
{
	memset(vis,1,sizeof(vis));
	eid=0;
	memset(p,-1,sizeof(p));
}
void insert(int u,int v)
{
	E[eid].len=1;
	E[eid].v=v;
	E[eid].next=p[u];
	p[u]=eid++;
}
void dfs(int u,int fa)
{
	for(int i=p[u];i!=-1;i=E[i].next)
	{
		if(E[i].len!=-1&&E[i].v!=fa)
		{
			if(f[E[i].v]<flag)
			{
				flag=f[E[i].v];
			}
			dfs(E[i].v,u);
		}
	}	
}
void find(int u,int fa)
{
	for(int i=p[u];i!=-1;i=E[i].next)
	{
		if(E[i].len!=-1&&E[i].v!=fa)
		{
			if(f[E[i].v]==flag)
			{
				eoq=1;
				E[i].len=E[i^1].len=-1;
				swap(f[E[i].v],f[u]);
				return;
			}
			dfs(E[i].v,u);
		}
		if(eoq)
		{
			swap(f[E[i].v],f[u]);
			E[i].len=E[i^1].len=-1;
			return;
		}
	}
}
int main()
{
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	scanf("%d",&t);
	while(t--)
	{
		init();
		scanf("%d",&n);
		for(int i=1;i<=n;i++)
		{
			scanf("%d",&num[i]);
			f[num[i]]=i;
		}
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			insert(u,v);
			insert(v,u);
		}
		for(int i=1;i<=n;i++)
		{
			eoq=0;
			flag=0x3f3f3f;
			dfs(i,0);
			find(i,0);
		}
		for(int i=1;i<=n;i++)
		{
			printf("%d ",f[i]);
		}
		printf("\n");
	}
	return 0;
}
