#include <cstdio>
typedef unsigned long long uint64;

uint64 n, k;

void read(uint64 &x) {
	x = 0;
	char ch = getchar();
	while (ch < '0' || ch > '9')
		ch = getchar();
	while (ch >= '0' && ch <= '9')
		x = 1LL * x * 10 + ch - '0', ch = getchar();
}

void dfs(uint64 dep, uint64 pos) {
	if (dep == 1) {
		if (pos == 0)
			putchar('0');
		else
			putchar('1');
		return;
	}
	uint64 mid = (1LL << (dep - 1)) - 1;
	if (pos <= mid) {
		putchar('0');
		dfs(dep - 1, pos);
	} else {
		putchar('1');
		uint64 npos = (1LL << dep) - 1 - pos;
		dfs(dep - 1, npos);
	}
}

int main() {
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);
	read(n), read(k);
	dfs(n, k);
	return 0;
}
