#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int,int>
#define PB push_back
#define MP make_pair
#define ull unsigned long long ull

struct BigInt
{
	int v[100];
	BigInt()
	{
		memset(v,0,sizeof(v));
	}
	BigInt(unsigned long long tmp)
	{
		memset(v,0,sizeof(v));
		int q=0;
		while(tmp)
		{
			v[q] = tmp%2;
			tmp/=2;
			q++;
		}
	}
	void Pow(int x)
	{
		memset(v,0,sizeof(v));
		v[x] = 1;
	}
	void PowMinu1(int x)
	{
		memset(v,0,sizeof(v));
		for(int i=0;i<x;i++) v[x] = 1;
	}
	inline bool Bigger(BigInt & other)
	{
		for(int i=66;i>=0;i--)
		{
			if(v[i] > other.v[i]) return 1;
			else if(v[i] < other.v[i]) return 0;
		}
		return 0;
	}
}k,pw=BigInt();

BigInt Plus(BigInt x,BigInt y)
{
	BigInt res = BigInt();
	int nxt = 0;
	for(int i=0;i<=66;i++){
		res.v[i] = (x.v[i] | y.v[i]) | nxt;
		nxt = x.v[i] & y.v[i];
	}
	return res;
}

unsigned long long K;
int n;
int ans[100];

inline void solve95()
{
	BigInt one = BigInt();
//	one.v[0] =1;
	BigInt BK = BigInt(K);
	k = Plus(BK,one);
	int period = 2;
	pw.v[0] = k.v[0];
	pw.v[1] = k.v[1];
	BigInt cmp = BigInt();
	BigInt cmp2 = BigInt();
	BigInt tmp = BigInt();
	BigInt cmpPw = BigInt();
	for(int i=1;i<=n;i++) {
		cmp.PowMinu1(period -2);
		tmp.Pow(period-1);
		cmp2 = Plus(cmp ,tmp);
		cmpPw = BigInt();
		cmpPw = Plus(pw,BigInt(1));
		if(!pw.Bigger(cmp2) && pw.Bigger(cmp)) ans[i] = 1;
		else ans[i] = 0;
		
		pw.v[period] = k.v[period];
		period ++;
		
	}
}

int main()
{
	freopen("code.in","r",stdin);
	freopen("code.out","w",stdout);
	cin>>n>>K;
	solve95();
	for(int i=n;i>=1;i--) cout<<ans[i];
	return 0;
}
