#include<cstdio>
#include<vector>
#include<set>
#include<stack>
using namespace std;
const int MAXN = 5e5 + 10;

int n, fa[MAXN];
vector<int>g[MAXN];
char c[MAXN];

long long ans = 0ll;

stack<int>sta;
int wc[MAXN] = {0};

void dfs(int u, int nw) { // nw:ǰһĴ 
	if(c[u] == '(') {
		ans ^= ((long long)u) * ((long long)nw);
		sta.push(u);
		for(int i = 0; i < (int)g[u].size(); ++i)
			dfs(g[u][i], nw);
		sta.pop();
	} else {
		if(sta.empty()) {
			ans ^= ((long long)u) * ((long long)nw);
			for(int i = 0; i < (int)g[u].size(); ++i)
				dfs(g[u][i], nw);
			return;
		}
		int l = sta.top();
		sta.pop();
		wc[u] = wc[fa[l]] + 1;
		int now = nw + wc[u];
		ans ^= ((long long)u) * ((long long)now);
		for(int i = 0; i < (int)g[u].size(); ++i)
			dfs(g[u][i], now);
		sta.push(l);
	}
}

int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	scanf("%d\n", &n);
	for(int i = 1; i <= n; ++i) {
		c[i] = getchar();
	}
	for(int i = 2; i <= n; ++i) {
		scanf("%d", &fa[i]);
		g[fa[i]].push_back(i);
	}
	dfs(1, 0);
	printf("%lld", ans);
	return 0;
}

