#include<algorithm>
#include<vector>
#include<cstdio>
#include<iostream>
using namespace std;
typedef long long int ll;
const int maxn=1E6+5;
const int base=500000;
int n;
int size,head[maxn];
int val[maxn];
ll ans;
struct edge
{
	int to,next;
}E[maxn];
vector<int>where[maxn];
inline void add(int u,int v)
{
	E[++size].to=v;
	E[size].next=head[u];
	head[u]=size;
}
inline int calc(int x)
{
	if(where[x+1].empty())
		return where[x].size();
	else
	{
		int pos=where[x+1][where[x+1].size()-1];
		pos=upper_bound(where[x].begin(),where[x].end(),pos)-where[x].begin();
		return where[x].size()-pos;
	}
	return -1;
}
void dfs(int u,int len,int sum,ll now)
{
	sum+=val[u];
	int y=calc(sum+base);
	now+=calc(sum+base);
	ans=ans^((ll)(u)*(ll)(now));
	where[sum+base].push_back(len);
	for(int i=head[u];i;i=E[i].next)
	{
		int v=E[i].to;
		dfs(v,len+1,sum,now);
	}
	where[sum+base].pop_back();
}
int main()
{
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	ios::sync_with_stdio(false);
	cin>>n;
	for(int i=1;i<=n;++i)
	{
		char ch;
		cin>>ch;
		if(ch=='(')
			val[i]=-1;
		else
			val[i]=1;
	}
	for(int i=2;i<=n;++i)
	{
		int x;
		cin>>x;
		add(x,i);
	}
	where[0+base].push_back(0);
	dfs(1,1,0,0);
	cout<<ans<<endl;
	return 0;
}

