#include<bits/stdc++.h>

using namespace std;

typedef long long LL;

const int N = 5e5 + 10;

struct Edge {
	int to , nxt;
} E[N];

int n , tp , tot;
char s[N];
int st[N] , opt[N] , head[N] , fa[N] , instack[N] , bck[N];
LL f[N] , g[N];

template <typename T> inline void chkmax(T &x , T y) { x = max(x , y); }
template <typename T> inline void chkmin(T &x , T y) { x = min(x , y); }
template <typename T> inline void read(T &x) {
	T f = 1; x = 0;
	char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -f;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + c - '0';
	x *= f;
}

#define LEFT_BRACKET -1
#define RIGHT_BRACKET 1

inline void addedge(int u , int v) {
	E[++tot] = (Edge){v , head[u]};
	head[u] = tot;
}

int stk[N] , vis[N];

inline void solve(int fst) {
	int Top = 0;
	stk[Top = 1] = fst;
	while (Top) {
		int u = stk[Top];
		if (!vis[u]) {
			vis[u] = true;
			if (tp >= 1 && opt[u] == RIGHT_BRACKET && opt[st[tp]] == LEFT_BRACKET) {
				bck[u] = st[tp--];
				instack[bck[u]] = false;
				f[u] = f[fa[bck[u]]] + 1;
				g[u] = g[fa[u]] + f[u];
			} else {
				f[u] = 0;	
				g[u] = g[fa[u]];
				st[++tp] = u;
				instack[u] = true;
			}
		}
		if (!head[u]) {
			if (instack[u]) {
				while (tp >= 1 && st[tp] != u) instack[st[tp--]] = false;
				instack[st[tp--]] = false;
			}
			if (bck[u]) {
				st[++tp] = bck[u];
				instack[bck[u]] = true;
			}
			--Top;
			continue;
		}
		if (head[u]) {
			stk[++Top] = E[head[u]].to;
			head[u] = E[head[u]].nxt;
		}
	}
	return;
}

int main() {
	
	#ifndef evenbao
	freopen("brackets.in" , "r" , stdin);
	freopen("brackets.out" , "w" , stdout);
	#endif
	
	scanf("%d%s" , &n , s + 1);
	for (int i = 1; i <= n; ++i)
		opt[i] = s[i] == '(' ? LEFT_BRACKET : RIGHT_BRACKET;
	for (int i = 2; i <= n; ++i) {
		read(fa[i]);
		addedge(fa[i] , i);
	}
	solve(1);
	LL ans = 0;
	for (int i = 1; i <= n; ++i)
		ans ^= (LL)i * g[i];
	printf("%lld\n" , ans);
	
	return 0;
}


