#include<bits/stdc++.h>

using namespace std;

typedef long long LL;

const int N = 2010;

int n;
int a[N] , b[N] , x[N] , y[N] , deg[N];
set< int > E[N];

template <typename T> inline void chkmax(T &x , T y) { x = max(x , y); }
template <typename T> inline void chkmin(T &x , T y) { x = min(x , y); }
template <typename T> inline void read(T &x) {
	T f = 1; x = 0;
	char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -f;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + c - '0';
	x *= f;
}

namespace solver1 {
	int cnt , mn , rt;
	int seq[N] , dep[N] , vis[N];
	inline void DFS(int u , int fa) {
		seq[++cnt] = u;
		dep[u] = dep[fa] + 1;
		for (set< int > :: iterator it = E[u].begin(); it != E[u].end(); ++it)
			if ((*it) != fa) DFS(*it , u);
	}
	inline void work(int u , int lim) {
		vis[u] = true;
		if (u < mn) mn = u;
		for (set< int > :: iterator it = E[u].begin(); it != E[u].end(); ++it)
			if (!vis[*it] && b[*it] >= lim) work(*it , lim);
	}
	inline void solve() {
		for (int i = 1; i <= n; ++i)
			if ((int)E[i].size() == 1) rt = i;	
		dep[rt] = 1;
		DFS(rt , 0);
		for (int i = 1; i <= n; ++i) {
			int now = a[i]; mn = now;
			work(now , i);
			memset(vis , 0 , sizeof(vis));
			if (mn == now) continue;
			if (dep[mn] > dep[now]) {
				for (int j = dep[mn]; j > dep[now]; --j) {
					E[seq[j]].erase(E[seq[j]].find(seq[j - 1]));
					E[seq[j - 1]].erase(E[seq[j - 1]].find(seq[j]));
				    swap(b[seq[j]] , b[seq[j - 1]]);
				    swap(a[b[seq[j]]] , a[b[seq[j - 1]]]);
				}
			} else {
				for (int j = dep[mn]; j < dep[now]; ++j) {
					E[seq[j]].erase(E[seq[j]].find(seq[j + 1]));
					E[seq[j + 1]].erase(E[seq[j + 1]].find(seq[j]));
				    swap(b[seq[j]] , b[seq[j + 1]]);
				    swap(a[b[seq[j]]] , a[b[seq[j + 1]]]);
				}
			}
		}
		for (int i = 1; i <= n; ++i)
			if (i == 1) printf("%d" , a[i]);
			else printf(" %d" , a[i]);
		printf("\n");
	}
} ;

namespace solver2 {
	int p[N] , ta[N] , tb[N] , ans[N];
	inline bool check() {
		for (int i = 1; i <= n; ++i) {
			if (a[i] < ans[i]) return true;
			if (a[i] > ans[i]) return false;
		}
		return true;
	}
	inline void solve() {
		for (int i = 1; i <= n - 1; ++i) 
			p[i] = i;
		for (int i = 1; i <= n; ++i) {
			ta[i] = a[i];
			tb[i] = b[i];
		}
		bool flag = false;
		do {
		//	p[1]=1; p[2]=4;p[3]=3;p[4]=2;
			for (int i = 1; i <= n; ++i) {
				a[i] = ta[i];
				b[i] = tb[i];
			}
			for (int i = 1; i <= n - 1; ++i) {
				swap(b[x[p[i]]] , b[y[p[i]]]);
				swap(a[b[x[p[i]]]] , a[b[y[p[i]]]]);
			}
			if (!flag) {
				flag = true;
				for (int i = 1; i <= n; ++i) ans[i] = a[i];
			} else {
				if (check()) {
					for (int i = 1; i <= n; ++i)
						ans[i] = a[i];
				}
			}
		} while (next_permutation(p + 1 , p + n));
		for (int i = 1; i <= n; ++i)
			if (i == 1) printf("%d" , ans[i]);
			else printf(" %d" , ans[i]);
		printf("\n");
	}
} ;

int main() {
	
	freopen("tree.in" , "r" , stdin);
	freopen("tree.out" , "w" , stdout);
	
	int T;
	read(T);
	while (T--) {
		read(n);
		for (int i = 1; i <= n; ++i) {
			read(a[i]);
			b[a[i]] = i;
		}
		for (int i = 1; i <= n; ++i) {
			E[i].clear();
			deg[i] = 0;
		}
		for (int i = 1; i < n; ++i) {
			read(x[i]); read(y[i]);
			E[x[i]].insert(y[i]);
			E[y[i]].insert(x[i]);
			++deg[x[i]]; ++deg[y[i]];
		}
		int d1 = 0; bool d2 = true;
		for (int i = 1; i <= n; ++i) {
			d1 += (deg[i] == 1);
			d2 &= (deg[i] <= 2);
		}
		if (n <= 10) {
			solver2 :: solve();
			continue;
		}
		if (d1 == 2 && d2) {
			solver1 :: solve();
			continue;
		} 
		solver2 :: solve();
	}
	
	return 0;
}


