#include<iostream>
#include<cstdio>
#include<vector>
#define ll long long int 
using namespace std;

const int maxn = 2005;
ll ans, n, fa[maxn];
char t[maxn];

struct atree {
	ll num[maxn];
	ll lowbit(ll x) {
		return x&(-x);
	}
	void add(ll x, ll t) {
		if(x > n) return;
		num[x]=max(num[x], t);
		add(x+lowbit(x), t);
		return;
	}
	ll count(ll x) {
		if(x < 1) return 0;
		return max( num[x], count(x-lowbit(x)) );
	}
} TT;

int tn[maxn];

struct atree {
	ll tm, st[maxn], to[maxn], nx[maxn], inn[maxn], last[maxn], ansk[maxn], it[maxn];
	void adde(ll u, ll v) {
		tm++; nx[tm]=st[u]; st[u]=tm; to[tm]=v;
	}
	void dpp(ll x) {
		if(t[x-1] == '(') {
			sum[x]=sum[fa[x]]+1;
		}
		else {
			sum[x]=sum[fa[x]]-1;
		}
		int i;
		for(i=st[x]; i != 0; i=nx[i]) dpp(to[i]);
	}
	void count(ll x) {
		tn[x]=tn[fa[x]]+1;
		if(last[sum[x]+n] != 0 && sum[x]-TT.count(fa[last[sum[x]+n]], tn[x]-1) <= 0) {
			ansk[x]=ansk[last[sum[x]+n]]+1;
		}
		int i, t;
		t=last[sum[x]+n];
		last[sum[x]+n]=x;
		T.add(tn[x], -sum[x]);
		for(i=st[x]; i != 0; i=nx[i]) 
			count(to[i]);
		T.add(tn[x], sum[x]);
		last[sum[x]+n]=t;
	}
	void cc(ll x) {
		ansk[x]+=ansk[fa[x]];
		int i;
		for(i=st[x]; i != 0; i=nx[i]) cc(to[i]);
		ans=ans^(ansk[x]*x)
	}
} T;

int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	ll i;
	scanf("%lld", &n);
	scanf("%s", t);
	for(i=2; i <= n; i++) {
		scanf("%lld", &fa[i]);
		T.adde(fa[i], i);
	}
	T.dpp(1);
	T.count(1);
	T.cc(1);
	printf("%lld\n", ans);
	return 0;
}
