#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <ctime>
#include <map>

#define submit

using std::cin;
using std::cout;
using std::endl;

template <typename T>
void read(T& x)
{
    x = 0;
    char c = getchar();
    for (; !isdigit(c); c = getchar());
    for (; isdigit(c); x = x * 10 + (c ^ 48), c = getchar());
}

struct Edge
{
    int v, nxt;
    
    Edge(int v = 0, int nxt = 0): v(v), nxt(nxt) { }
};

int n, cntEdge, top;
int a[500010], head[500010], fa[500010], stack[500010], match[500010]; // s[i] == '(' : a[i] = 0
long long ans = 0; 
long long f[500010], g[500010];
std::string s;
Edge edge[1000010];

void addEdge(int u, int v)
{
    edge[++cntEdge] = Edge(v, head[u]); head[u] = cntEdge;
    //edge[++cntEdge] = Edge(u, head[v]); head[v] = cntEdge;
}

void dfs(int x)
{
    int popEd = 0;
    if (a[x] == 0) // '('
    {
        stack[++top] = x;
    }
    else // ')'
    {
        if (top)
        {
            popEd = 1;
            match[x] = stack[top--];
            g[x] = g[fa[match[x]]] + 1;
        }
        else
        {
            
        }
    }
    f[x] = f[fa[x]] + g[x];
    for (int i = head[x]; i; i = edge[i].nxt)
    {
        int v = edge[i].v;
        dfs(v);
    }
    if (a[x] && popEd)
        stack[++top] = match[x];
    else if (a[x] == 0)
        --top;
}

int main()
{
#ifdef submit
    freopen("brackets.in", "r", stdin);
    freopen("brackets.out", "w", stdout);    
#endif
    read(n);
    cin >> s;
    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = s[i] == ')';
    }
    for (int i = 2; i <= n; ++i)
    {
        read(fa[i]);
        addEdge(fa[i], i);
    }
    
    dfs(1);
    
    for (long long i = 1; i <= n; ++i)
    {
         ans ^= i * f[i];
    }
    
    cout << ans << endl;
    
    return 0;
}
