#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <ctime>
#include <map>

#define submit

using std::cin;
using std::cout;
using std::endl;

template <typename T>
void read(T& x)
{
    x = 0;
    char c = getchar();
    for (; !isdigit(c); c = getchar());
    for (; isdigit(c); x = x * 10 + (c ^ 48), c = getchar());
}

unsigned long long n, k;
int ans[10010];

int getBIT(unsigned long long x)
{
    int r = 0;
    while (x)
    {
        ++r;
        x >>= 1;
    }
    return r;
}

int main()
{
#ifdef submit
    freopen("code.in", "r", stdin);
    freopen("code.out", "w", stdout);
#endif
    read(n); read(k);
    if (n <= 62)
    {
        for (unsigned long long i = 0; i < n; ++i)
        {
            unsigned long long mod = 1ull << (i + 2), cur = 1ull << i;
            if (k % mod < cur || k % mod >= mod - cur)
                ans[i] = 0;
            else
                ans[i] = 1;
        }
    }
    else
    {
        for (unsigned long long i = 0; i < 62; ++i)
        {
            unsigned long long mod = 1ull << (i + 2), cur = 1ull << i;
            if (k % mod < cur || k % mod >= mod - cur)
                ans[i] = 0;
            else
                ans[i] = 1;
        }
        if (n == 63)
        {
            unsigned long long t = 1ull << 62;
            if (k < t || k >= 3ull * t)
                ans[62] = 1;
            else
                ans[62] = 0;
        }
        else
        {
            unsigned long long t = 1ull << 62;
            if (k < t || k >= 3ull * t)
                ans[62] = 0;
            else
                ans[62] = 1;
            t = 1ull << 63;
            if (k < t)
                ans[63] = 0;
            else
                ans[63] = 1;
        }
    }
    
    for (int i = n - 1; ~i; --i)
    {
        cout << ans[i];
    }
    
    cout << endl;
    
    return 0;
}
