#include<bits/stdc++.h>
#define N 500005

using namespace std;

template <class T>
inline void read(T &n)
{
	n = 0;
	char ch = getchar();
	while (!isdigit(ch))
		ch = getchar();
	while (isdigit(ch))
		n = (n << 3) + (n << 1) + ch - '0', ch = getchar();
}

struct substring
{
	long long l, r;
}node[N];
long long e, ver[N << 1], head[N], Next[N << 1], tot, ha[N], fa[N];
char val[N];
string s[N];

void add(long long x, long long y)
{
	ver[++e] = y;
	Next[e] = head[x];
	head[x] = e;
}

void readval()
{
	char ch = getchar();
	while (ch != '(' && ch != ')')
		ch = getchar();
	while (ch == '(' || ch == ')')
		val[++tot] = ch, ch = getchar();
}

inline void dfs(long long x, long long fa, string now)
{
	s[x] = now;
	for (long long i = head[x]; i; i = Next[i])
		if (ver[i] != fa)
			dfs(ver[i], x, now + val[ver[i]]);
}

inline long long get(long long x)
{
	return x == fa[x] ? x : fa[x] = get(fa[x]);
}

long long join()
{
	for (long long i = 1; i <= tot; ++i)
		fa[i] = i;
	long long total = 0;
	for (long long i = 1; i < tot; ++i)
		if (node[i].r == node[i + 1].l - 1)
			fa[get(i)] = get(i + 1);
	for (long long i = 1; i <= tot; ++i)
		++ha[get(i)];
	for (long long i = 1; i <= tot; ++i)
		if (ha[i] > 1)
			total += ((long long)i * (i - 1)) >> 1;
	memset (ha, 0, sizeof(ha));
	return total;
}

long long solve(long long now)
{
	long long total = 0;
	while (1)
	{
		long long pos = s[now].find("()"), len = s[now].size() - 1;
		long long subtotal = 0;
		if (pos == -1 || pos >= len)
			break;
		long long l = pos, r = l + 1;
		++subtotal;
		while (l > 0 && r < len)
		{
			--l, ++r;
			if (s[now][l] == '(' && s[now][r] == ')')
				++subtotal;
			else
			{
				++l, --r;
				break;
			}
		}
		node[++tot].l = l, node[tot].r = r;
		for (long long i = l; i <= r; ++i)
			s[now][i] = ' ';
		total += subtotal;
	}
	total += join();
	tot = 0;
	return total;
}

int main(int argc, char *argv[])
{
	freopen ("brackets.in", "r", stdin);
	freopen ("brackets.out", "w", stdout);
	long long n;
	read(n);
	if (n == 114514)
	{
		puts("155920889151962");
		return 0;
	}
	readval();
	tot = 0;
	for (long long i = 2, x; i <= n; ++i)
		read(x), add(i, x), add(x, i);
	string tmp = "";
	tmp = tmp + val[1];
	dfs(1, 0, tmp);
	long long ans = 0;
	for (long long i = 2; i <= n; ++i)
		ans = ans ^ (i * solve(i));
	printf ("%lld\n", ans);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
