#include <bits/stdc++.h>

using namespace std;

#define redirect(name) (					\
		freopen(name ".in", "r", stdin),    \
		freopen(name ".out", "w", stdout)   \
	)

struct DpState {
	int nCount, nAvailBrackets;
	multiset<int> sCurLayer;
};

int n;
char str[500000 + 2];
int fathers[500000 + 2];

DpState dp[500000 + 2];

unsigned long long getsum(unsigned long long nIn) {
	return ( nIn * (nIn + 1) ) / 2;
}

void CopyDpState(DpState &des, const DpState &src) {
	des.nCount = src.nCount;
	des.nAvailBrackets = src.nAvailBrackets;
	for (multiset<int>::iterator it = src.sCurLayer.begin(); it != src.sCurLayer.end(); it++)
		des.sCurLayer.insert(*it);
}

void solve(int nIn) {
	DpState stateTemp;
	
	if (dp[nIn].nCount != 0) {
ReturnNow:
		//printf("[%5d: { %d, %d }]\n", nIn, dp[nIn].nCount, dp[nIn].nAvailBrackets);
		//return dp[nIn];
		return;
	}
	
	if (nIn == 0) {
		dp[nIn].nCount = 0;
		dp[nIn].nAvailBrackets = 0;
		goto ReturnNow;
	}
	
	//stateTemp = solve(fathers[nIn]);
	solve(fathers[nIn]); 
	stateTemp = dp[fathers[nIn]];
	//CopyDpState(stateTemp, dp[fathers[nIn]]);
	if (str[nIn] == '(') {
		//printf("[Entering Layer %d: %d]\n", stateTemp.nAvailBrackets, (int)stateTemp.sCurLayer.count(stateTemp.nAvailBrackets));
		stateTemp.sCurLayer.insert(stateTemp.nAvailBrackets);
		stateTemp.nAvailBrackets++;
		dp[nIn] = stateTemp;
		
		//if (str[nIn - 1] == ')')
	}
	else {	// str[nIn] == ')'
		if (stateTemp.nAvailBrackets > 0) {
			int nCurCount = stateTemp.sCurLayer.count(stateTemp.nAvailBrackets);
			//printf("[Leaving Layer %d: %d]\n", stateTemp.nAvailBrackets, nCurCount);
			if (nCurCount > 0)  {
				stateTemp.nCount += getsum(nCurCount - 1);
				stateTemp.sCurLayer.erase(stateTemp.nAvailBrackets);
				//printf("{ * %d, %llu }\n", nCurCount, getsum(nCurCount - 1));
				//cout << "[ * " << nCurCount << ", " << getsum(3) << " *]" << endl;
			}
			//stateTemp.nCount += getsum(max((int)stateTemp.sCurLayer.count(stateTemp.nAvailBrackets) - 1, 0));
			//printf("{ * %d, %d }\n", stateTemp.sCurLayer.count(stateTemp.nAvailBrackets), getsum(max((int)stateTemp.sCurLayer.count(stateTemp.nAvailBrackets) - 1, 0)));
			//stateTemp.sCurLayer.erase(stateTemp.nAvailBrackets);
			stateTemp.nAvailBrackets--;
			stateTemp.nCount++;
		}
		dp[nIn] = stateTemp;
		//CopyDpState(dp[nIn], stateTemp);
	}
	
	goto ReturnNow;
}

void WalkBraces(int nIn) {
	if (nIn != 1)
		WalkBraces(fathers[nIn]);
	printf("%c", str[nIn]);
}

void MAIN(void) {
	unsigned long long nAns;
	
	str[0] = '*';
	//memset(dp, -1, sizeof dp);
	scanf("%d%s", &n, &str[1]);
	fathers[1] = 0;		// Root has no father
	for (int i = 2; i <= n; i++) {
		int a;
		scanf("%d", &a);
		fathers[i] = a;
	}
	
	nAns = 0;
	for (int i = 1; i <= n; i++) {
	//for (int i = 35; i <= 35; i++) {
		int nCurCount;
		//printf("[%5d: \"", i);
		//WalkBraces(i);
		//printf("\" ]\n");
		solve(i);
		nCurCount = dp[i].nCount;
		//for (int j = dp[i].sCurLayer.count(dp[i].nAvailBrackets); j >= 0; j--)
		//	nCurCount += getsum(dp[i].sCurLayer.count(ji].nAvailBrackets) - 1);
		nCurCount += getsum(dp[i].sCurLayer.count(dp[i].nAvailBrackets) - 1);
		nAns ^= (unsigned long long)i * nCurCount;
		//printf("[Record %5d: { %d, %d }]\n", i, dp[i].nCount, nCurCount);
	}
	
	cout << nAns;
}

int main(void) {
#if 1
	redirect("brackets");
#endif
	MAIN();
	return 0;
}


