#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
vector<int> mp[500001];
char ch[500002];
int dep[500001],lps[1+500001*21],sl[1+500001*21],sr[1+500001*21],chv[500001],nodes;
vector<pair<int,pair<int,int> > > qs[500001];
int nnd(int cp)
{
	int ret=nodes++;
	if (cp!=-1)
	{
		lps[ret]=lps[cp];
		sl[ret]=sl[cp];
		sr[ret]=sr[cp];
	}
	else
		lps[ret]=sl[ret]=sr[ret]=-1;
	return ret;
}
int querylps(int id,int il,int ir,int l,int r)
{
	if (il>=l&&ir<=r)
		return lps[id];
	if (r<=il||l>=ir)
		return -1;
	int mid=(il+ir)>>1,ret=-1;
	if (sl[id]!=-1)
		ret=max(ret,querylps(sl[id],il,mid,l,r));
	if (sr[id]!=-1)
		ret=max(ret,querylps(sr[id],mid,ir,l,r));
	return ret;
}
int setlps(int id,int il,int ir,int pos,int val)
{
	int nid=nnd(id);
	if (ir-il==1)
	{
		lps[nid]=max(lps[nid],val);
		return nid;
	}
	int mid=(il+ir)>>1;
	if (pos<mid)
		sl[nid]=setlps(sl[nid],il,mid,pos,val);
	else
		sr[nid]=setlps(sr[nid],mid,ir,pos,val);
	lps[nid]=max(sl[nid]==-1?-1:lps[sl[nid]],sr[nid]==-1?-1:lps[sr[nid]]);
	return nid;
}
void dfs(int u,int curd,int w,int rt)
{
	dep[u]=curd;
	chv[curd]=u;
	int lstpos=querylps(rt,0,1048576,0,500000+w);
	if (lstpos!=-1)
	{
		lstpos=chv[lstpos];
		qs[lstpos].push_back(make_pair(w,make_pair(u,-1)));
	}
	qs[u].push_back(make_pair(w,make_pair(u,1)));
	rt=setlps(rt,0,1048576,500000+w,curd);
	for (size_t i=0;i<mp[u].size();++i)
	{
		int v=mp[u][i];
		dfs(v,curd+1,w+(ch[v]=='('?1:-1),rt);
	}
}
int nw[1000001],ending[500001];
void calcending(int u,int w)
{
	++nw[500000+w];
	for (size_t i=0;i<qs[u].size();++i)
	{
		pair<int,pair<int,int> > curq=qs[u][i];
		ending[curq.second.first]+=nw[500000+curq.first]*curq.second.second;
	}
	for (size_t i=0;i<mp[u].size();++i)
	{
		int v=mp[u][i];
		calcending(v,w+(ch[v]=='('?1:-1));
	}
	--nw[500000+w];
}
long long ans[500001];
void calcsum(int u,int p)
{
	ans[u]=ans[p]+ending[u];
	for (size_t i=0;i<mp[u].size();++i)
	{
		int v=mp[u][i];
		calcsum(v,u);
	}
}
int main()
{
	int n;
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d%s",&n,ch+1);
	for (int i=2;i<=n;++i)
	{
		int p;
		scanf("%d",&p);
		mp[p].push_back(i);
	}
	nodes=1;
	lps[0]=sl[0]=sr[0]=-1;
	int rt=0;
	rt=setlps(rt,0,1048576,500000,0);
	dfs(1,1,ch[1]=='('?1:-1,rt);
	++nw[500000+0];
	for (size_t i=0;i<qs[0].size();++i)
	{
		pair<int,pair<int,int> > curq=qs[0][i];
		ending[curq.second.first]+=nw[500000+curq.first]*curq.second.second;
	}
	calcending(1,ch[1]=='('?1:-1);
	--nw[500000+0];
	for (int i=1;i<=n;++i)
		--ending[i];
	calcsum(1,0);
	long long xorans=0;
	for (int i=1;i<=n;++i)
		xorans^=ans[i]*i;
	printf("%lld\n",xorans);
	return 0;
}
