#include <stdio.h>
#include <vector>
using namespace std;
vector<int> mp[2001];
int deg[2001],val[2001],pos[2001];
bool used[2001],start[2001];
int par[2001];
int fnd(int k)
{
	return par[k]==k?k:par[k]=fnd(par[k]);
}
int main()
{
	int T;
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	scanf("%d",&T);
	while (T--)
	{
		int n;
		scanf("%d",&n);
		for (int i=1;i<=n;++i)
		{
			mp[i].clear();
			deg[i]=0;
			val[i]=0;
			used[i]=false;
			start[i]=true;
			par[i]=i;
		}
		for (int i=1;i<=n;++i)
		{
			scanf("%d",pos+i);
			val[pos[i]]=i;
		}
		bool flow=false;
		for (int i=1;i<n;++i)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			mp[u].push_back(v);
			mp[v].push_back(u);
			++deg[u];
			++deg[v];
		}
		for (int i=1;i<=n;++i)
			if (deg[i]==n-1)
				flow=true;
		if (flow)
		{
			for (int i=1;i<=n;++i)
				for (int np=1;np<=n;++np)
					if (!used[np]&&(i==n||fnd(pos[i])!=fnd(np)))
					{
						printf("%d ",np);
						used[np]=true;
						par[fnd(pos[i])]=fnd(np);
						break;
					}
			printf("\n");
		}
	}
	return 0;
}
