#include<iostream>
#include<vector>

using namespace std;
int n;
int tree[100001];
int size = 0;
int subTree[100001];
int subSize = 0;
int total = 0;

vector<int> G[100001];
int visited[100001];

bool check(int l, int r) {
	int sum = 0;
	for (int i = l;i <= r;i++) {
		sum += subTree[i];
	}
	return (sum == 0 && subTree[l] == -1);
}

int getSub() {
	int sum = 0; 
	for (int l = 0;l < subSize;l++) {
		for (int r = l;r < subSize;r++) {
			if (check(l, r) == true) {
				sum++;
			}
		}
	}
	return sum;
}

void dfs(int x) {
	if (visited[x] == 0) {
		visited[x] = 1;
		total ^= (getSub() * x);
	}
	for (unsigned int i = 0;i < G[x].size();i++) {
		subTree[subSize++] = tree[G[x][i]];
		dfs(G[x][i]);
		subSize--;
	}
}

int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	scanf("%d", &n);
	string str;
	cin >> str;
	for (int i = 0;i < n;i++) {
		if (str[i] == '(') {
			tree[size++] = -1;
		} else if (str[i] == ')') {
			tree[size++] = 1;
		}
	}
	int temp;
	for (int i = 2;i <= n;i++) {
		scanf("%d", &temp);
		G[temp].push_back(i);
	}
	subTree[subSize++] = 1;
	dfs(1);
	cout << total;
	return 0;
}

