#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int MAXN=2005;
struct EDGE{int nxt,to;}edge[MAXN];
int head[MAXN],tot;
inline void add_edge(int u,int v){edge[++tot].nxt=head[u];edge[tot].to=v;head[u]=tot;}
int n,a[MAXN],loc[MAXN],fa[MAXN],dep[MAXN],sz[MAXN],son[MAXN];
void dfs1(int u){
	sz[u]=1;dep[u]=dep[fa[u]]+1;
	for(int i=head[u];i;i=edge[i].nxt){
		int v=edge[i].to;
		if(v==fa[u])continue;
		fa[v]=u;
		dfs1(v);
		sz[u]+=sz[v];
		if(sz[v]>sz[son[u]])son[u]=v;
	}
}
int top[MAXN],dfn[MAXN],cnt;
void dfs2(int u,int t){
	top[u]=t;
	dfn[u]=++cnt;
	if(son[u])dfs2(son[u],t);
	for(int i=head[u];i;i=edge[i].nxt){
		int v=edge[i].to;
		if(v==fa[u]||v==son[u])continue;
		dfs2(v,v);
	}
}
bool used[MAXN];
int s[MAXN<<2];
void build(int p,int l,int r){
	if(l==r){
		if(l!=1)s[p]=1;
		return;
	}
	int mid=(l+r)>>1;
	build(p<<1,l,mid);
	build(p<<1|1,mid+1,r);
	s[p]=s[p<<1]+s[p<<1|1];
}
int query(int p,int l,int r,int ql,int qr){
	if(ql<=l&&qr>=r)return s[p];
	int mid=(l+r)>>1,res=0;
	if(ql<=mid)res=query(p<<1,l,mid,ql,qr);
	if(qr>mid)res+=query(p<<1|1,mid+1,r,ql,qr);
	return res;
}
void modify(int p,int l,int r,int pos){
	if(l==r){s[p]=0;return;}
	int mid=(l+r)>>1;
	if(pos<=mid)modify(p<<1,l,mid,pos);
	else modify(p<<1|1,mid+1,r,pos);
	s[p]=s[p<<1]+s[p<<1|1];
}
bool ck(int x,int v){
	int u=loc[x];
	int uu=u,vv=v,t=0;
	while(top[u]!=top[v]){
		if(dep[top[u]]<dep[top[v]])swap(u,v);
		t+=query(1,1,n,dfn[top[u]],dfn[u]);
		u=fa[top[u]];
	}
	if(u!=v){
		if(dfn[u]>dfn[v])swap(u,v);
		t+=query(1,1,n,dfn[u]+1,dfn[v]);
	}
	if(dep[uu]+dep[vv]-2*dep[u]!=t)return 0;
	return u;
}
int sta[MAXN];
void mo(int x,int v,int l){
	int u=loc[x],tt=0;
	for(int i=head[v];i;i=edge[i].nxt){
		int t=edge[i].to;
		if(t==fa[v]||!query(1,1,n,dfn[t],dfn[t]))continue;
		swap(a[v],a[t]);
		loc[a[v]]=v;loc[a[t]]=t;
		modify(1,1,n,dfn[t]);
	}
	for(int t=u;t!=l;t=fa[t]){
		swap(a[t],a[fa[t]]);
		loc[a[t]]=t;
		loc[a[fa[t]]]=fa[t];
		modify(1,1,n,dfn[t]);
	}
	tt=0;
	for(int t=v;t!=l;t=fa[t]){
		sta[++tt]=t;
	}
	for(int i=tt;i>=1;--i){
		int t=sta[i];
		swap(a[t],a[fa[t]]);
		loc[a[t]]=t;
		loc[a[fa[t]]]=fa[t];
		modify(1,1,n,dfn[t]);
	}
}
int tloc[11],ta[11],p[11];
bool vis[11];
bool cck(int x,int u,int v){
	memset(vis,0,sizeof(vis));
	for(int i=u;i!=1;i=fa[i])vis[i]=1;
	int lca=0;
	for(int i=v;i!=1;i=fa[i])if(vis[i]){
		lca=i;break;
	}
	for(int i=u;i!=lca;i=fa[i]){
		if(ta[i]<x||ta[fa[i]]<x)return 0;
		if(used[i])return 0;
	}
	for(int i=v;i!=lca;i=fa[i]){
		if(ta[i]<x||ta[fa[i]]<x)return 0;
		if(used[i])return 0;
	}
	return 1;
}
void mmo(int u,int v){
	memset(vis,0,sizeof(vis));
	for(int i=u;i!=1;i=fa[i])vis[i]=1;
	int lca=0;
	for(int i=v;i!=1;i=fa[i])if(vis[i]){
		lca=i;break;
	}
	for(int i=u;i!=lca;i=fa[i]){
		used[i]=1;
		swap(ta[i],ta[fa[i]]);
		tloc[ta[i]]=i;
		tloc[ta[fa[i]]]=fa[i];
	}
	for(int i=v;i!=lca;i=fa[i]){
		used[i]=1;
		swap(ta[i],ta[fa[i]]);
		tloc[ta[i]]=i;
		tloc[ta[fa[i]]]=fa[i];
	}
}
int main(){
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	int Testcases;scanf("%d",&Testcases);while(Testcases--){
		scanf("%d",&n);
		for(int i=1;i<=n;++i)scanf("%d",loc+i),a[loc[i]]=i,head[i]=0,son[i]=0,p[i]=i;
		for(int i=1,u,v;i<n;++i)scanf("%d%d",&u,&v),add_edge(u,v),add_edge(v,u);
		fa[1]=0;
		dfs1(1);
		cnt=0;
		dfs2(1,1);
		build(1,1,n);
		for(int i=1;i<=n;++i){
			int p=0;
			for(int j=1;j<=n;++j){
				if(used[j])continue;
				int l=ck(i,j);
				if(l){
					used[j]=1;
					p=j;
					mo(i,j,l);
					break;
				}
			}
			printf("%d ",p);
		}
		puts("");
	}
	return 0;
}
