#include <bits/stdc++.h>
#define _rep(i, x, y) for(int i = x; i <= y; i++)
#define _per(i, x, y) for(int i = x; i >= y; i--)
#define LL long long
#define LD long double
#define ULL unsigned long long
using namespace std;
template <typename T>
inline void read(T &x) {
	x = 0; T f = (T) 1;
	char c = getchar();
	for(; !isdigit(c); c = getchar()) {
		if(c == '-') f = -f;
	}
	for(; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	x *= f;
}
template <typename T>
inline void write(T x) {
	if(x < 0) {x = -x; putchar('-');}
	if(x > 9) write(x / 10);
	putchar(x % 10 + '0');
}
template <typename T>
inline void writesp(T x, char sp = '\n') {
	write(x); putchar(sp);
}
void file(string name) {
	freopen((name + ".in").c_str(), "r", stdin);
	freopen((name + ".out").c_str(), "w", stdout);
}
const int maxN = 5e5 + 5;
int n;
bool sub = 1;
char bracket[maxN];
vector<int> son[maxN];
int lb[maxN], rb[maxN], cnt[maxN], lastr[maxN];
int blk[maxN];
bool check(string s) {
	int l = 0;
	_rep(i, 0, s.size() - 1) {
		if(s[i] == '(') l++;
		else {
			if(l <= 0) return false;
			l--;
		}
	}
	return !l;
}
int ans = 0;
int kkk[9];
void brute(string s, int dep) {
	if(dep > n) {
		int k = check(s);
		kkk[s.size()] += k;
		//if(k) cout << s << endl;
		return;
	}
	s.push_back(bracket[dep]);
	brute(s, dep + 1);
	s.erase(s.end() - 1);
	brute(s, dep + 1);
}
void dfs(int root, int l, int r, int lr) {
	lb[root] = l + (bracket[root] == '(');
	rb[root] = r + (bracket[root] == ')');
	lastr[root] = lr;
	if(!son[root].size()) return;
	if(bracket[root] == ')') lr = root;
 	int len = son[root].size();
	_rep(i, 0, len - 1) {
		dfs(son[root][i], lb[root], rb[root], lr);
	}
}
LL fac[maxN];
void work(int root, int fa) {
	if(bracket[root] == '(') {
		cnt[root] = cnt[fa];
		if(son[root].size() == 0) return;
		_rep(i, 0, son[root].size() - 1) {
			work(son[root][i], fa);
		}
	} else {
		cnt[root] = cnt[fa] + lb[root];
		int yyakioi = root;
		while(yyakioi > 1) {
			yyakioi = lastr[yyakioi];
			cnt[root] += (lb[root] - lb[yyakioi]) * cnt[yyakioi];
		}
	//	cnt[root] += lb[root];
		if(son[root].size() == 0) return;
		_rep(i, 0, son[root].size() - 1) {
			work(son[root][i], fa);
		}
	}
}
int main() {
	file("brackets");
	read(n);
	scanf("%s", bracket + 1);
//	brute("", 1);
//	writesp(ans);
	_rep(i, 2, n) {
		int x; read(x);
		sub = sub & (x == i - 1);
		son[x].push_back(i);
	}
	if(bracket[1] == '(') dfs(1, 1, 0, 0);
	else dfs(1, 0, 1, 0);
	if(n <= 8) {
		brute("", 1);
		LL ans = 0;
		_rep(i, 1, n) {
			ans = ans ^ (i * kkk[i]);	
		}
		writesp(ans);
	} else if(n <= 2000 && sub) {
		int bl = 1;
		_rep(i, 1, n) {
			if(bracket[i - 1] == ')' && bracket[i] == '(') bl++;
			blk[i] = bl;
		}
		_rep(i, 1, bl) {
			_rep(j, i, bl) {
				ans += lb[i] * rb[i];
			}
		}
	} else {
		work(1, 0);
		LL ans = 0;
		_rep(i, 1, n) {
		//	cout << cnt[i] << " ";
			ans = ans ^ (i * cnt[i]);	
		}
		writesp(ans);
	}
//	dfs(1);
	return 0;
}

