#include<cstring>
#include<cstdio>
#include<vector>

const int
	MAXN = 5010;
	
int
	T,n,x,y;

int
	u[MAXN],v[MAXN],num[MAXN];

bool
	vis[MAXN];
	
std :: vector <int>
	ans;

int
	read(){
		int x = 0,c = 0;
		while(c < '0' || c > '9')
			c = getchar();
		while(c >= '0' && c <= '9')
			x = x * 10 + c - '0',
				c = getchar();
		return
			x;
	}
	
void
	work(){
		std :: vector <int>
			tmp;
		tmp.resize(n);
		for(register int i = 1;i <= n;i++)
			tmp[num[i] - 1] = i;
		if (ans.empty() || ans > tmp)
			ans = tmp;
	}

void
	dfs(int dep,int maxdep,int steps){
		if (dep > maxdep){
			work();
		}else{
			int tmp;
			for(register int i = 1;i <= steps;i++)
				if (!vis[i]){
					vis[i] = true;
					tmp = num[u[i]];
					num[u[i]] = num[v[i]];
					num[v[i]] = tmp;
					dfs(dep + 1,maxdep,steps);
					tmp = num[u[i]];
					num[u[i]] = num[v[i]];
					num[v[i]] = tmp;
					vis[i] = false;
				}
		}
	}

int
	main(){
  		freopen("tree.in","r",stdin);
  		freopen("tree.out","w",stdout);
		T = read();
		while(T--){
			ans.clear();
			n = read();
			for(register int i = 1;i <= n;i++)
				num[read()] = i;
			for(register int i = 1;i < n;i++){
				u[i] = read();
				v[i] = read();
			}
			dfs(1,n - 1,n - 1);
			for(register int i = 0;i < n;i++)
				printf("%d ",ans[i]);
			putchar('\n');
		}
		return
			0;
	}
