#include <bits/stdc++.h>
#define pb push_back
#define fi first
#define se second
#define pii pair<int, int>
typedef unsigned long long ULL;
typedef long long LL;
const int MAXN = 1000000;
const int P = 2333;
using namespace std;

inline int read() {
  int x = 0, w = 1; char c = getchar();
  while (!isdigit(c)) {
    if (c == '-') w = -1;
    c = getchar();
  }
  while (isdigit(c)) {
    x = (x << 1) + (x << 3) + (c ^ 48);
    c = getchar();
  }
  return x * w;
}

void enableFileIO() {
  freopen("brackets.in", "r", stdin);
  freopen("brackets.out", "w", stdout);
}

map < ULL, int > mp;
char c[MAXN + 5];
LL ans, s[MAXN + 5];

namespace tree {
const int MAXM = 2 * MAXN;
struct Edge {
  int to, nxt;
  Edge() {}
  Edge(int _to, int _nxt): to(_to), nxt(_nxt) {}
} edge[MAXM + 5];

int tot, head[MAXN + 5];
void init() {
  tot = 0, memset(head, -1, sizeof(head));
}
void addEdge(int u, int v) {
  edge[tot] = Edge(v, head[u]), head[u] = tot++;
  edge[tot] = Edge(u, head[v]), head[v] = tot++;
}

ULL hsh[MAXN + 5];
int top;
char sta[MAXN + 5];

bool mat(char a, char b) {
  if (a == ')' && b == '(') return true;
  return false;
}

ULL gethsh(char c) {
  if (top) {
    hsh[top] = hsh[top - 1] * P + c;
    return hsh[top];
  } else {
    return hsh[top];
  }
}

void dfs(int u, int fa) {
  int pre = top;
  if (top && mat(c[u], sta[top])) {
    --top;
  } else {
    sta[++top] = c[u];
  }
  ULL h = 0;
  if (top) h = gethsh(sta[top]);
  if (c[u] == ')') {
    s[u] = s[fa] + mp[h];
  } else {
    s[u] = s[fa];
  }
  ++mp[h];
  
  for (int i = head[u]; ~i; i = edge[i].nxt) {
    int v = edge[i].to; if (v == fa) continue;
    dfs(v, u);
  }

  top = pre;
  --mp[h];
}

}

int n;

namespace task2 {

map < ULL, LL > mp;
ULL sta[MAXN + 5], hsh[MAXN + 5];
int top;
LL s[MAXN + 5];

bool mat(char a, char b) {
  if (a == ')' && b == '(') return true;
  return false;
}
ULL gethsh(char c) {
  if (top) {
    hsh[top] = hsh[top - 1] * P + c;
    return hsh[top];
  } else {
    return hsh[top];
  }
}

void solve() {
  ++mp[0]; top = 0;
  for (int i = 1; i <= n; ++i) {
    if (top && mat(c[i], sta[top])) {
      --top;
    } else {
      sta[++top] = c[i];
    }
    ULL h = gethsh(sta[top]);
    if (c[i] == ')') {
      s[i] = s[i - 1] + mp[h];
    } else {
      s[i] = s[i - 1];
    }
    ++mp[h];
  }

  LL ans = 0;
  for (int i = 1; i <= n; ++i) {
    ans ^= s[i] * i;
  }
  printf("%lld\n", ans);
}

}

bool isSubtask2;

void init() {
  enableFileIO();
  
  tree::init();
  n = read();
  for (int i = 1; i <= n; ++i) {
    c[i] = getchar();
    while (c[i] != '(' && c[i] != ')') c[i] = getchar();
  }
  
  isSubtask2 = true;
  for (int i = 2; i <= n; ++i) {
    int fa = read();
    if (fa != i - 1) {
      isSubtask2 = false;
    }
    tree::addEdge(fa, i);
  }
}

stack < int > tmp; 

int main() {
  init();
  
  if (isSubtask2) {
    task2::solve();
  } else {
    ++mp[0];
    tree::dfs(1, 0);
    for (int i = 1; i <= n; ++i) ans ^= s[i] * i;
    printf("%lld\n", ans);
  }
  return 0;
}
