#include <bits/stdc++.h>
#define pb push_back
#define fi first
#define se second
#define pii pair<int, int>
#define mp make_pair
typedef long long LL;
const int MAXN = 2000;
using namespace std;

inline int read() {
  int x = 0, w = 1; char c = getchar();
  while (!isdigit(c)) {
    if (c == '-') w = -1;
    c = getchar();
  }
  while (isdigit(c)) {
    x = (x << 1) + (x << 3) + (c ^ 48);
    c = getchar();
  }
  return x * w;
}

void enableFileIO() {
  freopen("tree.in", "r", stdin);
  freopen("tree.out", "w", stdout);
}

namespace tree {
const int MAXM = 2 * MAXN;
struct Edge {
  int to, nxt;
  Edge() {}
  Edge(int _to, int _nxt): to(_to), nxt(_nxt) {}
} edge[MAXM + 5];

int tot, head[MAXN + 5];
void init() {
  tot = 0, memset(head, -1, sizeof(head));
}
void addEdge(int u, int v) {
  edge[tot] = Edge(v, head[u]), head[u] = tot++;
  edge[tot] = Edge(u, head[v]), head[v] = tot++;
}

}

int n, m, a[MAXN + 5];
pii e[MAXN + 5];

void init() {
  n = read();
  for (int i = 1; i <= n; ++i) a[i] = read();
  for (int i = 1; i < n; ++i) {
    int u = read(), v = read();
    e[i] = mp(u, v);
  }
  m = n - 1;
}

namespace task1 {
  
int b[MAXN + 5], res[MAXN + 5], rk[MAXN + 5];
int tmp[MAXN + 5];

bool chk() {
  for (int i = 1; i <= n; ++i) {
    if (rk[i] != res[i]) {
      if (rk[i] < res[i]) {
        return true;
      } else {
        return false;
      }
    }
  }
  return false;
}
void solve() {
  memset(res, 0x3f, sizeof(res));
  for (int i = 1; i <= m; ++i) b[i] = i; 
  
  do {
    for (int i = 1; i <= n; ++i) tmp[i] = a[i];
    for (int i = 1; i <= m; ++i) {
      swap(tmp[e[b[i]].fi], tmp[e[b[i]].se]);
    }
    for (int i = 1; i <= n; ++i) {
      rk[tmp[i]] = i;
    }
    if (chk()) {
      for (int i = 1; i <= n; ++i) res[i] = rk[i];
    }
  } while (next_permutation(b + 1, b + 1 + m));
  
  for (int i = 1; i <= n; ++i) printf("%d ", res[i]);
  puts("");
}

}

int rk[MAXN + 5];

int main() {
  enableFileIO();
  int t = read();
  
  while (t--) {
    init();
    
    if (n <= 10) {
      task1::solve();
    } else {
      for (int i = n; i > 1; --i) swap(a[i], a[i - 1]);
      for (int i = 1; i <= n; ++i) rk[a[i]] = i;
      for (int i = 1; i <= n; ++i) printf("%d ", rk[i]);
      puts("");
    }
  }
  
  return 0;
}

