#include<bits/stdc++.h>
using namespace std;
typedef long long LL;
const int INF=0x3f3f3f3f,MAXN=4005,MAXM=4005;
int head[MAXN],sz=1,nxt[MAXM],to[MAXM],st[MAXM],ed[MAXM];
inline void add(int x,int y) {
	nxt[++sz]=head[x];
	head[x]=sz;
	to[sz]=y;
}
int N,Ca,pv[MAXN],pos[MAXN],in[MAXN],R,maxi;
/*brute-force*/
int ans[MAXN],tp;
inline void bf() {
	int per[20],tmpv[20],tmps[20];
	for(int i=1; i<N; i++) {
		per[i]=i;
	}
	memset(ans,0x3f,sizeof(ans));
	do {
		memcpy(tmpv,pv,sizeof(tmpv));
		memcpy(tmps,pos,sizeof(tmps));
		for(int i=1; i<N; i++) {
			int ii=per[i];
			int u=st[ii],v=ed[ii];
			swap(tmpv[u],tmpv[v]);
			swap(tmps[tmpv[u]],tmps[tmpv[v]]);
		}
		for(int i=1; i<=N; i++) {
			if(tmps[i]>ans[i]) {
				break;
			}
			if(tmps[i]<ans[i]) {
				for(int j=1; j<=N; j++) {
					ans[j]=tmps[j];
				}
				break;
			}
		}
	} while(next_permutation(per+1,per+N));
	for(int i=1; i<=N; i++) {
		printf("%d ",ans[i]);
	}
	puts("");
}
/*chain*/
bool used[MAXM];
int le[MAXN],ri[MAXN];
inline void chan() {
	memset(used,0,sizeof(used));
	int cur=R;
	while(1) {
		for(int i=head[cur]; i; i=nxt[i]) {
			if(!ri[to[i]]) {
				ri[cur]=to[i];
			} else {
				le[cur]=to[i];
			}
		}
		if(!ri[cur]) {
			break;
		}
	}
	for(int i=1; i<=N; i++) {
		int cp=pos[i],minv=INF,mini=0,flag=0;
		for(int j=le[cp]; j; j=le[j]) {
			if(j<minv) {
				minv=j;
				flag=-1;
			}
		}
		for(int j=ri[cp]; j; j=ri[j]) {
			if(j<minv) {
				minv=j;
				flag=1;
			}
		}
		if(flag==0) {
			continue;
		}
		if(flag==-1) {
			for(int j=cp,u=cp; j&&j!=minv; j=le[j]) {
				int v=le[j];
				swap(pv[u],pv[v]);
				swap(pos[pv[u]],pos[pv[v]]);
				u=v;
			}
		}
		if(flag==1) {
			for(int j=cp,u=cp; j&&j!=minv; j=ri[j]) {
				int v=ri[j];
				swap(pv[u],pv[v]);
				swap(pos[pv[u]],pos[pv[v]]);
				u=v;
			}
		}
	}
	for(int i=1; i<=N; i++) {
		printf("%d ",pos[i]);
	}
	puts("");
}
int pre[MAXN];
inline int dfs1(int x,int fa){
	int minv=INF;
	for(int i=head[x];i;i=nxt[i]){
		if(to[i]==fa||used[i]){
			continue;
		}
		int ii=dfs1(to[i],x);
		if(ii<minv){
			pre[x]=to[i];
			minv=ii;
		}
	}
	return minv;
}
inline void dfs2(int x,int fa){
	for(int i=head[x];i;i=nxt[i]){
		if(to[i]==fa){
			continue;
		}
		if(to[i]==pre[x]){
			used[i]=used[i^1]=1;
			swap(pv[x],pv[to[i]]);
			swap(pos[pv[x]],pos[pv[to[i]]]);
			dfs2(to[i],x);
			return;
		}
	}
}
inline void gr(){
	memset(used,0,sizeof(used));
	for(int i=1;i<=N;i++){
		int cp=pos[i];
		dfs1(cp,cp);
		dfs2(cp,cp);
	}
	for(int i=1;i<=N;i++){
		printf("%d ",pos[i]);
	}
	puts("");
}
inline void init() {
	scanf("%d",&N);
	memset(head,0,sizeof(head));
	memset(in,0,sizeof(in));
	sz=1;
	R=0;
	int mini=INF,maxi=0,r1=0,r2=0;
	for(int i=1; i<=N; i++) {
		scanf("%d",pos+i);
		pv[pos[i]]=i;
	}
	for(int i=1; i<N; i++) {
		int u,v;
		scanf("%d%d",&u,&v);
		add(u,v);
		add(v,u);
		st[i]=u;
		ed[i]=v;
		in[u]++;
		in[v]++;
		if(in[u]<mini) {
			mini=in[u];
			r1=u;
		}
		if(in[v]<mini) {
			mini=in[v];
			r1=v;
		}
		if(in[u]>maxi) {
			maxi=in[u];
			r2=u;
		}
		if(in[v]>maxi) {
			maxi=in[v];
			r2=v;
		}
	}
	if(N<=10) {
		bf();
	} else {
		gr();
	}
}
int T;
int main() {
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	scanf("%d",&T);
	while(T--) {
		init();
	}
	return 0;
}

