#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
typedef long long ll;
const int MAXN = 1000005;
struct Edge{
  int to,next;
}e[MAXN];
int fa[MAXN],head[MAXN],n,cnt;
char s[MAXN];
ll tot=0;
ll ans[MAXN];
inline void insert(int u,int v)
{
  e[++cnt].to=v,e[cnt].next=head[u],head[u]=cnt;
}
struct Seg{
  int v,sum,last;
}a[MAXN];
int a_cnt;
void dfs(int x)
{
  ans[x]=ans[fa[x]];
  if(s[x]=='('){
    ++a_cnt;
    a[a_cnt]=(Seg){-1,0,a_cnt};
  }else{
    if(a[a_cnt].last){
      int t=a[a_cnt].last;
      int last=0,sum=1;
      last=a[t-1].last,sum+=a[t-1].sum;
      Seg now=(Seg){1,sum,last};
      ans[x]+=sum;
      a[++a_cnt]=now;
    }else{
      Seg now=(Seg){0,0,0};
      a[++a_cnt]=now;
    }
  }
  tot^=(ll)x*ans[x];
  for(int i=head[x];i;i=e[i].next){
    int v=e[i].to;
    dfs(v);
  }
  --a_cnt;
}
int main()
{
  freopen("brackets.in","r",stdin);
  freopen("brackets.out","w",stdout);
  scanf("%d",&n);
  scanf("%s",s+1);
  for(int i=2;i<=n;++i){
    scanf("%d",fa+i);
    insert(fa[i],i);
  }
  dfs(1);
  cout<<tot<<endl;
  return 0;
}
