#include <bits/stdc++.h>
using namespace std;
#define rep(i, n) for (int i = (0); i < (n); ++i)
#define rep1(i, n) for (int i = (1); i <= (n); ++i)
#define Rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define per(i, n) for (int i = ((n) - 1); i >= (0); --i)
#define per1(i, n) for (int i = (n); i >= (1); --i)
#define Per(i, a, b) for (int i = (a); i >= (b); --i)
#define fillset(a, val) memset(a, val, sizeof(a))
#define SZ(s) ((int)s.size())
#define All(a) a.begin(), a.end()
#define MP make_pair
#define pb push_back
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<int, ll> pil;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;
const int inf = 0x3f3f3f3f;
const ll lnf = 0x3f3f3f3f3f3f3f3f;

const int Maxn = 500005;
int n, par[Maxn];
char str[Maxn];
vector<int> g[Maxn];
ll ans[Maxn], xorans;

namespace solution1 {

int sum[Maxn], cnt[Maxn];

inline ll get_nump(const string &s) {
  if (s == "") return 0;
  int n = SZ(s);
  fillset(sum, 0);
  rep1(i, n) {
    sum[i] = sum[i - 1];
    if (s[i - 1] == '(') sum[i]++;
    else sum[i]--;
  }
  fillset(cnt, 0);
  ll ans = 0;
  rep(i, n + 1) {
    cnt[sum[i] + 1] = 0;
    cnt[sum[i]]++;
    if (cnt[sum[i]] >= 2) ans += cnt[sum[i]] - 1;
  }
  return ans;
}
inline ll get_num(const char *s, int len) {
  string last;
  int cnt = 0;
  ll ans = 0;
  rep(i, len) {
    cnt += (s[i] == '(') - (s[i] == ')');
    if (cnt < 0) {
      ans += get_nump(last);
      last = "";
      cnt = 0;
    }
    else last += s[i];
  }
  ans += get_nump(last);
  return ans;
}

char st[Maxn];
int stlen;

void dfs(int u) {
  st[stlen++] = str[u];
  ans[u] = get_num(st, stlen);
  rep(i, SZ(g[u])) dfs(g[u][i]);
  stlen--;
}
int main() {
  stlen = 0, dfs(1);
  xorans = 0;
  rep1(i, n) xorans ^= (ans[i] * i);
  cout << xorans << endl;
}

}

namespace solution2 {

int sum[Maxn], cnt[Maxn];

inline void get_nump(const string &s, int lastpos) {
  if (s == "") return ;
  int n = SZ(s);
  fillset(sum, 0);
  rep1(i, n) {
    sum[i] = sum[i - 1];
    if (s[i - 1] == '(') sum[i]++;
    else sum[i]--;
  }
  fillset(cnt, 0);
  rep(i, n + 1) {
    cnt[sum[i] + 1] = 0;
    cnt[sum[i]]++;
    if (cnt[sum[i]] >= 2) ans[i + lastpos] += cnt[sum[i]] - 1;
  }
}
inline void get_num(const char *s, int len) {
  string last;
  int cnt = 0;
  ll ans = 0;
  int lastpos = 0;
  rep(i, len) {
    cnt += (s[i] == '(') - (s[i] == ')');
    if (cnt < 0) {
      get_nump(last, lastpos);
      last = "";
      cnt = 0;
      lastpos = i;
    }
    else last += s[i];
  }
  get_nump(last, lastpos);
}

int main() {
  fillset(ans, 0);
  get_num(str + 1, n);
  xorans = 0;
  rep1(i, n) {
    ans[i] += ans[i - 1];
    xorans ^= (ans[i] * i);
  }
  cout << xorans << endl;
}

}

namespace solution3 {

int sum[Maxn], cnt[Maxn], vis[Maxn], len;
void dfs(int u) {
  int val = sum[len] + (str[u] == '(') - (str[u] == ')');
  sum[++len] = val;
  if (sum[len] < 0) {
    vis[len] = true;
    sum[len] = 0;
  }
  else vis[len] = false;
  int orig;
  if (vis[len]) {
    orig = cnt[0];
    cnt[0] = 1;
  }
  else {
    orig = cnt[sum[len] + 1];
    cnt[sum[len] + 1] = 0;
    cnt[sum[len]]++;
    if (cnt[sum[len]] >= 2) ans[u] += cnt[sum[len]] - 1;
  }
  rep(i, SZ(g[u])) {
    int v = g[u][i];
    ans[v] += ans[u];
    dfs(v);
  }
  if (vis[len]) {
    cnt[0] = orig;
    vis[len] = false;
  }
  else {
    cnt[sum[len] + 1] = orig;
    cnt[sum[len]]--;
  }
  sum[len] = 0;
  --len;
}

int main() {
  fillset(ans, 0);
  xorans = 0;
  len = 0;
  cnt[0] = 1;
  dfs(1);
  rep1(i, n) xorans ^= (ans[i] * i);
  cout << xorans << endl;
}

}

int main() {
  freopen("brackets.in", "r", stdin);
  freopen("brackets.out", "w", stdout);
  scanf("%d", &n);
  scanf("%s", str + 1);
  bool flag = true;
  Rep(i, 2, n) {
    scanf("%d", par + i);
    flag &= (par[i] + 1 == i);
    g[par[i]].pb(i);
  }
  if (n <= 2000) {
    solution1::main();
    return 0;
  }
  if (flag) {
    solution2::main();
    return 0;
  }
  solution3::main();
  return 0;
}

