#include <cassert>
#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
using namespace std;

template<typename T> bool chmin(T &a, const T &b) {
	return b < a ? a = b, true : false;
}
template<typename T> bool chmax(T &a, const T &b) {
	return a < b ? a = b, true : false;
}

#ifdef DEBUG
#define display(x) cerr << #x << " = " << x << endl;
#define displaya(a, st, n)						\
	{cerr << #a << " = {";						\
	for(int qwq = (st); qwq <= (n); ++qwq) {	\
		if(qwq == (st)) cerr << a[qwq];			\
		else cerr << ", " << a[qwq];			\
	}											\
	cerr << "}\n";}
#define displayv(v) displaya(v, 0, (int)(v).size() - 1)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define display(x) {}
#define displaya(a, st, n) {}
#define displayv(v) {}
#define eprintf(...) do {} while(0);
#endif

int main() {
#ifndef LOCAL
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);
#endif
	int n;
	unsigned long long k;
	cin >> n >> k;
	while(n) {
		if(k < (1ull << (n - 1))) cout << '0';
		else {
			cout << '1';
			if(n == 64) k = (~0ull) - k;
			else if(n <= 63) k = ((1ull << n) - 1ull) - k;
			else assert(false);
		}
		n--;
	}
	cout << endl;
	return 0;
}

