#include<bits/stdc++.h>
using namespace std;

const int N=5e5+5;
const int INF=123456789;
char s[N];
int a[N],h[N],p[N],sk[N],ht;
long long tot[N];
int n;
long long ans;
vector<int> nei[N],lv[N*2];
int HT[N*2];

struct Tree{
	int left,right,val;
	Tree *left_child,*right_child;
	Tree(){};
}*rt;

void build(Tree *pos,int x,int y){
	pos->left=x;pos->right=y;pos->val=INF;
	if(x==y) return;
	int mid=(x+y)>>1;
	pos->left_child=new Tree();
	pos->right_child=new Tree();
	build(pos->left_child,x,mid);
	build(pos->right_child,mid+1,y);
}

void modify(Tree *pos,int x,int v){
	if(pos->left>=x&&pos->right<=x){
		pos->val=v;
		return;
	}
	if(pos->left>x||pos->right<x) return;
	modify(pos->left_child,x,v);
	modify(pos->right_child,x,v);
	pos->val=min(pos->left_child->val,pos->right_child->val);
}

int query(Tree *pos,int v){
	if(pos->val>=v) return (pos->left)-1;
	if(pos->left==pos->right) return pos->left;
	if(pos->right_child->val<v) return query(pos->right_child,v);
	return query(pos->left_child,v);
}

void dfs(int x){
	h[x]+=a[x];
	for(int i=0;i<nei[x].size();i++){
		int to=nei[x][i];
		h[to]=h[x];
		dfs(to);
	}
}

void cal(int x){
	sk[++ht]=h[x];
	if(a[x]==-1){
		for(int i=ht-1;i>0;i--){
			if(sk[i]<sk[ht]) break;
			if(sk[i]==sk[ht]) tot[x]++;
		}
	}
	for(int i=0;i<nei[x].size();i++) cal(nei[x][i]);
	ht--;
}

void CAL(int x){
	ht++;
	int hx=h[x]+N;
	modify(rt,ht,h[x]);
	if(HT[hx]==int(lv[hx].size())) lv[hx].push_back(ht);
	else lv[hx][HT[hx]]=ht;
	HT[hx]++;
	if(a[x]==-1){
		int sm=query(rt,h[x]);
		int l=0,r=HT[hx]-1;
		while(l<=r){
			int mid=(l+r)>>1;
			if(lv[hx][mid]>sm) r=mid-1;
			else l=mid+1;
		}
		r++;
		tot[x]=1ll*HT[hx]-1-r;
	}
	for(int i=0;i<nei[x].size();i++) CAL(nei[x][i]);
	modify(rt,ht,INF);
	ht--;
	HT[hx]--;
}

void fn(int x){
	ans^=1ll*x*tot[x];
	for(int i=0;i<nei[x].size();i++){
		int to=nei[x][i];
		tot[to]+=tot[x];
		fn(to);
	}
}

int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d%s",&n,s+1);
	for(int i=1;i<=n;i++) if(s[i]=='(') a[i]=1;else a[i]=-1;
	for(int i=2;i<=n;i++){
		scanf("%d",p+i);
		nei[p[i]].push_back(i);
	}
	dfs(1);
	if(n<=2000){
		sk[1]=0;
		ht=1;
		cal(1);
	}else{
		ht=0;
		rt=new Tree();
		build(rt,0,n);
		modify(rt,0,0);
		HT[N]++;
		lv[N].push_back(0);
		CAL(1);
	}
	fn(1);
	printf("%lld\n",ans);
	return 0;
}
