#include <bits/stdc++.h>
#define Maxn	5050
using namespace std;
template <typename tn> void read(tn &a){
	tn x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - 48;
	a = x * f;
}

struct Enode{ int u, v; } E[Maxn];
struct Edge{ int v, next; } edge[Maxn * 2];
int first[Maxn], val[Maxn], deg[Maxn], ans[Maxn], loc[Maxn];
bool del[Maxn * 2];
int n, Top = 1;

void Clear(){
	for (int i = 1; i <= n; i++)
		ans[i] = n - i + 1;
	memset(del, 0, sizeof del);
}

void addedge(int u, int v){
	edge[++Top] = (Edge) {v, first[u]};
	first[u] = Top;
	edge[++Top] = (Edge) {u, first[v]};
	first[v] = Top;
}

namespace BF{
	int b[Maxn], a[Maxn], c[Maxn];
	bool used[Maxn];
	void update(){
		for (int i = 1; i <= n; i++)
			b[i] = val[i];
		for (int i = 1; i < n; i++)
			swap(b[E[a[i]].u], b[E[a[i]].v]);
		for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			if (b[j] == i) c[i] = j;
		for (int i = 1; i <= n; i++){
			if (c[i] > ans[i]) break;
			if (c[i] < ans[i]){ for (int j = 1; j <= n; j++) ans[j] = c[j]; break; }
		}
	}
	void dfs(int dep){
		if (dep == n){ update(); return; }
		for (int i = 1; i < n; i++)
			if (!used[i]) used[i] = true, a[dep] = i, dfs(dep + 1), used[i] = false;
	}
};

namespace greedy{
	int stk[Maxn], stk2[Maxn], c2, Min, cstk;
	void fnd(int u, int fa){
		for (int i = first[u]; i; i = edge[i].next){
			int v = edge[i].v;
			if (v == fa || del[i]) continue;
			fnd(v, u), Min = min(Min, v);
		}
	}
	void dfs(int u, int fa){
		stk2[++c2] = u;
		if (u == Min){
			for (int i = 1; i <= cstk; i++)
				del[stk[i]] = del[stk[i] ^ 1] = true;
			for (int i = 2; i <= c2; i++){
				int x = stk2[i - 1], y = stk2[i];
				swap(val[x], val[y]);
				loc[val[x]] = x;
				loc[val[y]] = y;
			}
			c2--;
			return;
		}
		for (int i = first[u]; i; i = edge[i].next){
			int v = edge[i].v;
			if (v == fa || del[i]) continue;
			stk[++cstk] = i, dfs(v, u), cstk--;
		}
		c2--;
	}
	void solve(){
		for (int i = 1; i <= n; i++){
			Min = n + 1, fnd(loc[i], 0);
			ans[i] = (Min > n) ? loc[i] : Min;
			if (Min <= n) dfs(loc[i], 0);
		}
	}
}; 

void Solve(){
	if (n <= 10){ BF :: dfs(1); return; }
	greedy :: solve();
}

int main(){
	freopen("tree.in", "r", stdin); freopen("tree.out", "w", stdout);
	int T; read(T);
	while (T--){
		read(n), Clear();
		for (int i = 1; i <= n; i++)
			read(loc[i]), val[loc[i]] = i;
		for (int i = 1, u, v; i < n; i++){
			read(u), read(v), E[i] = (Enode) {u, v};
			deg[u]++, deg[v]++;
			addedge(u, v), addedge(v, u);
		}
		Solve();
		for (int i = 1; i <= n; i++)
			cout << ans[i] << (i == n ? '\n' : ' ');
	}
	return 0;
}

