#include<bits/stdc++.h>
using namespace std;

#define int long long

#define mid ((l+r)>>1)
#define ls (o<<1)
#define rs (o<<1|1)
#define lt ls,l,mid
#define rt rs,mid+1,r

const int maxn=500010;
const int T=250002;

int N;
string s;
int f[maxn];

bool Case0_f=true;

int sum[maxn];
int ans[maxn];

int tag[maxn<<2],data[maxn<<2],zerotag[maxn<<2];

inline void pushup(int o)
{
	data[o]=data[ls]+data[rs];
}

inline void pushdown(int o,int l,int r)
{
	if(zerotag[o])
	{
		data[ls]=0;
		data[rs]=0;
		tag[ls]=0;
		tag[rs]=0;
		zerotag[ls]=true;
		zerotag[rs]=true;
		zerotag[o]=false;
	}
	data[ls]+=tag[o]*(mid-l+1);
	data[rs]+=tag[o]*(r-mid);
	tag[ls]+=tag[o];
	tag[rs]+=tag[o];
	tag[o]=0;
}

int query(int o,int l,int r,int ql,int qr)
{
	if(l==r)
	{
		return data[o];
	}
	pushdown(o,l,r);
	if(ql<=l && r<=qr)
	{
		return data[o];
	}
	int res=0;
	if(ql<=mid)
	{
		res+=query(lt,ql,qr);
	}
	if(mid+1<=qr)
	{
		res+=query(rt,ql,qr);
	}
	return res;
}

void update(int o,int l,int r,int ul,int ur,int v)
{
	if(l==r)
	{
		data[o]+=v;
		return;
	}
	pushdown(o,l,r);
	if(ul<=l && r<=ur)
	{
		data[o]+=v*(r-l+1);
		return;
	}
	if(ul<=mid)
	{
		update(lt,ul,ur,v);
	}
	if(mid+1<=ur)
	{
		update(rt,ul,ur,v);
	}
	pushup(o);
}

void alc()
{
	zerotag[1]=true;
	data[1]=0;
	tag[1]=0;
}

vector<pair<int,int> > salc;
int spos;

int Case0()
{
	int maxsum=-1;
	for(int i=1;i<=N;i++)
	{
		if(s[i]=='(') sum[i]=sum[i-1]+1;
		else sum[i]=sum[i-1]-1;
		maxsum=max(maxsum,sum[i]);
	}
	maxsum+=T;
	while(maxsum&(maxsum-1)) maxsum++;
	
	int p1=1; 
	for(int i=1;i<=N;i++)
	{
		if(s[i]=='(')
		{
			sum[i-1]=0;
			p1=i;
			break;
		}
	}
	for(int i=p1;i<=N;i++)
	{
		if(s[i]=='(') sum[i]=sum[i-1]+1;
		else sum[i]=sum[i-1]-1;
		
		if(s[i]=='(' && sum[i]<=1)
		{
//			cout<<"St i="<<i<<" sum[i]="<<sum[i]<<endl;
			int j;
			for(j=i+1;j<=N;j++)
			{
				if(s[j]=='(') sum[j]=sum[j-1]+1;
				else sum[j]=sum[j-1]-1;
				
				if(s[j]==')' && sum[j]<sum[i]-1)
				{
//					cout<<"Pb j="<<j<<" sum[j]="<<sum[j]<<endl;
					salc.push_back(make_pair(j,true));
					sum[j]=0;
//					int k;
//					for(k=j+1;k<=N;k++)
//					{
//						if(s[k]==')' && sum[k]<sum[i]-1) salc.push_back(make_pair(k,false));
//						else break;
//					}
//					j=k-1;
				}
				else if(s[j]=='(') break;
			}
			i=j-1;
		}
	}
//	cout<<"salc[]=";
//	for(int i=0;i<salc.size();i++) cout<<salc[i].first<<" ";
//	cout<<endl;
	for(int i=1;i<=N;i++)
	{
		if(s[i]=='(') sum[i]=sum[i-1]+1;
		else sum[i]=sum[i-1]-1;
	}
	for(int i=1;i<=N;i++)
	{
		ans[i]=ans[i-1];
		
		if(spos<salc.size() && i==salc[spos].first)
		{
			if(salc[spos].second) alc();
			spos++;
			continue;
		}
		
		if(s[i]==')')
		{
//			cout<<"i="<<i<<" Query("<<sum[i]+1<<")=>"<<query(1,1,maxsum,sum[i]+1,sum[i]+1)<<endl; 
			ans[i]+=query(1,1,maxsum,sum[i]+1+T,sum[i]+1+T);
		}
		
		if(s[i]=='(')
		{
//			cout<<"i="<<i<<" Update("<<sum[i]<<") +1"<<endl;
			update(1,1,maxsum,sum[i]+T,sum[i]+T,1);
		}
	}
	int ANS=0;
	for(int i=1;i<=N;i++)
	{
		ANS=(ANS^(i*ans[i]));
	}
	
//	cout<<"InCase0 : ";
//	for(int i=1;i<=N;i++) cout<<ans[i]-ans[i-1]<<" ";
//	cout<<endl;
	
	return ANS;
}

vector<int> son[2010];
vector<int> v;

void go(int root)
{
	if(s[root]=='(') v.push_back(1);
	else v.push_back(-1);
	
	ans[root]=ans[f[root]];
	if(v[v.size()-1]==-1)
	{
		int nsum=0;
		for(int i=v.size()-1;i>=1;i--)
		{
			nsum+=v[i];
			if(nsum>0) break;
			if(nsum==0 && v[i]==1) ans[root]++;
		}
	}
	if(!son[root].empty())
	{
		for(int i=0;i<son[root].size();i++)
		{
			go(son[root][i]);
		}
	}
	v.pop_back();
}

int Case1()
{
	for(int i=2;i<=N;i++)
	{
		son[f[i]].push_back(i);
	}
	v.push_back(0);
	f[1]=0;
	ans[0]=0;
	go(1);
	
//	cout<<"InCase1 : ";
//	for(int i=1;i<=N;i++) cout<<ans[i]-ans[f[i]]<<" ";
//	cout<<endl;
	
	int ANS=0;
	for(int i=1;i<=N;i++)
	{
		ANS=(ANS^(i*ans[i]));
	}
	return ANS;
}

int Case2()
{
	
}

signed main()
{
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	ios::sync_with_stdio(false);
	
	cin>>N>>s;
	s="#"+s;
	for(int i=2;i<=N;i++)
	{
		cin>>f[i];
		if(f[i]!=i-1) Case0_f=false;
	}
	int ANS; 
	if(N<=2000)
	{
		ANS=Case1();
	}
	else if(Case0_f)
	{
		ANS=Case0();
	}
	else
	{
		ANS=Case2();
	}
	
	cout<<ANS<<endl;
	return 0;
}

