#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int MAXN = 5e5 + 10;
template <class T>
inline void _read(T &x)
{
	x = 0;
	char t = getchar();
	while (!isdigit(t) && t != '-') t = getchar();
	if (t == '-')
	{
		_read(x);
		x *= -1;
		return ;
	}
	while (isdigit(t))
	{
		x = x * 10 + t - '0';
		t = getchar();
	}
}
char s[MAXN];
int d[MAXN];
int fa[MAXN];
int n;
ll res = 0;
inline void work1()
{
	ll ans = 0;
	int ndep = 0;
	memset(d, 0, sizeof d);
	for (int i = 1; i <= n; ++i)
	{
		if (s[i] == '(') ++ndep;
		if (s[i] == ')')
		{
			--ndep;
			if (ndep < 0)
			{
				ndep = 0;
				d[0] = 0;
			}
			else
			{
				d[ndep]++;
				d[ndep + 1] = 0;
				ans += d[ndep];
			}
		}
		res ^= ans * i;
	}
	printf("%lld\n", res);
}
vector <int> G[MAXN];
inline void dfs(int x, int ndep, ll ans)
{
//	cout << "x : " << x << " ans : " << ans << " ndep : " << ndep << endl;
	res ^= ans * x;
	for (vector<int> ::iterator i = G[x].begin(); i != G[x].end(); ++i)
	{
		int u = (*i);
		if (s[u] == '(') dfs(u, ndep + 1, ans);
		else
		{
			if (ndep == 0)
			{
				int tmp = d[0];
				d[0] = 0;
				dfs(u, ndep, ans);
				d[0] = tmp;
			}
			else
			{
				++d[ndep];
				int tmp = d[ndep + 1];
				d[ndep + 1] = 0;
				dfs(u, ndep - 1, ans + d[ndep]);
				--d[ndep];
				d[ndep + 1] = tmp;
			}
		}
	}
}
inline void work2()
{
	memset(d, 0, sizeof d);
	dfs(1, s[1] == '(', 0);
	printf("%lld\n", res);
}
int main()
{
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	_read(n);
	scanf("%s", s + 1);
	bool flag = 1;
	for (int i = 2; i <= n; ++i)
	{
		_read(fa[i]);
		G[fa[i]].push_back(i);
		if (fa[i] != i - 1) flag = 0;
	}
	if (flag) work1();
	else work2();
	return 0;
}
