#include <iostream>
#include <cstdio>
#include <vector>
#include <fstream>
const int MAXN=500005;
using namespace std;
inline int read(){
	int f=1,ans=0;
	char x=getchar();
	while (x<'0'||x>'9'){if (x=='-') f=-1;x=getchar();}
	while (x>='0'&&x<='9'){ans=ans*10+x-'0';x=getchar();}
	return f*ans;
}

int n;
int fa[MAXN];
int a[MAXN];
bool is_l=true;

namespace solution1
{
	int cnt[MAXN];
	int ans=0;
	
	int main()
	{
		for (int i=2;i<=n;i++){
			int sum=0;
			cnt[i]=cnt[i-1];
			for (int j=i;j>=1;j--){
				sum+=a[j];
				if (sum>0) break;
				if (sum==0) cnt[i]++;
			}
			cout<<cnt[i]<<" ";
			ans^=cnt[i]*i;
		}
		cout<<ans<<endl;
		return 0;
	}
}

namespace solution2
{
	int cnt[MAXN];
	vector<int> son[MAXN];
	int ans=0;
	
	void dfs(int p){
		int sum=0;
		cnt[p]=cnt[fa[p]];
		if (a[p]==-1){
			int now=p;
			while (now!=0){
				sum+=a[now];
				if (sum>0) break;
				if (sum==0) cnt[p]++;
				now=fa[now];
			}
		}	
		ans^=p*cnt[p];
		
		for (int i=0;i<son[p].size();i++){
			int u=son[p][i];
			dfs(u);
		}
	}
	
	int main(){
		for (int i=2;i<=n;i++)
			son[fa[i]].push_back(i);
		dfs(1);
		cout<<ans<<endl;
	}
}



int main()

{
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	ios::sync_with_stdio(false);
	n=read();
	for (int i=1;i<=n;i++){
		char c=getchar();
		a[i]=(c==')')?-1:1;
	}
	
	for (int i=2;i<=n;i++){
		fa[i]=read();
		if (fa[i]!=i-1) is_l=false;
	}
	fa[1]=0;
	
	if (is_l&&n<=2000)
		solution1::main();
	else
		solution2::main();
	return 0;
}
/*
while (1) rp++;

*/
