#include <bits/stdc++.h>

using namespace std;

namespace LZZio {
	template <class T> inline void read(T &x) {
		T flg = 1; x = 0; char ch = getchar();
		for (; !isdigit(ch); ch = getchar()) if (ch == '-') flg = -1;
		for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
		x *= flg; return;
	}

	template <class T> inline void write(T x) {
		if (x < 0) putchar('-'), x = -x;
		if (x > 9) write(x / 10);
		putchar(x % 10 + '0');
	}

	template <class T> inline void writeln(T x, char c = '\n') { write(x), putchar(c); }
	template <class T> inline void chkmax(T &x, const T y) { x = x > y ? x : y; }
	template <class T> inline void chkmin(T &x, const T y) { x = x < y ? x : y; }

	#define Ms(arr, opt) memset(arr, opt, sizeof(arr))
	typedef long long ll;
	typedef unsigned long long ull;
} using namespace LZZio;

const int Maxn = 2005, Maxm = 4005;
int T, n, cnt = 0, p[Maxn], head[Maxn], ver[Maxm], nxt[Maxm];
inline void AddEdge(int u, int v) {
	ver[++cnt] = v, nxt[cnt] = head[u], head[u] = cnt;
	ver[++cnt] = u, nxt[cnt] = head[v], head[v] = cnt;
}

priority_queue <int, vector <int>, greater <int> > q1, q2;

inline void solve(int u, int fa) {int mi = INT_MAX, tmp = 0;while (!q1.empty()) q1.pop(); while (!q2.empty()) q2.pop(); q2.push(p[u]);
	for (int i = head[u]; i; i = nxt[i]) { if (ver[i] == fa) continue;
		solve(ver[i], u); 
		if (mi > p[ver[i]]) chkmin(mi, p[ver[i]]), tmp = ver[i], q1.push(ver[i]);   
		else q1.push(ver[i]); q2.push(p[ver[i]]);// if (ver[i] < u && p[ver[i]] > p[u])  
	} while (!q1.empty()) {
		if (p[q1.top() == 0 ? u : q1.top()] == q2.top()) {
			int tmp = q2.top(); q2.pop();
			p[q1.top() == 0 ? u : q1.top()] = q2.top(); q1.pop(), q2.pop();
			q2.push(tmp);
		} else {
			p[q1.top() == 0 ? u : q1.top()] = q2.top(); q1.pop(), q2.pop();
		}
	} if (tmp) p[u] = mi;
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	for (read(T); T; T--) {
		read(n); Ms(head, 0); cnt = 0;
		for (int i = 1; i <= n; i++) read(p[i]);
		for (int i = 1, u, v; i < n; i++)
			read(u), read(v), AddEdge(u, v);
		for (int i = 1; i < n; i++) writeln(i, ' '); writeln(n);
	}
	return 0;
}

