
#define _CRT_SECURE_NO_WARNINGS

#define N (2007)

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <utility>
#include <memory>
#include <iostream>
using namespace std;

int T;
int n;
int loc[N];
int used[N];
vector<int> v[N];
int fn[N];
int dep[N];
int dv[N];
int par[N];

void dfs(int xx)
{
	for(int i=0;i<(int)v[xx].size();i++)
	{
		if(!dv[v[xx][i]])
		{
			dv[v[xx][i]]=1;
			dep[v[xx][i]]=dep[xx]+1;
			par[v[xx][i]]=xx;
			dfs(v[xx][i]);
		}
	}
}

int main()
{
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	scanf("%d",&T);
	while(T--)
	{
		scanf("%d",&n);
		for(int i=0;i<n;i++)
		{
			scanf("%d",&loc[i]);
			loc[i]--;
			v[i].clear();
		}
		memset(fn,0,sizeof(fn));
		memset(used,0,sizeof(used));
		memset(dep,-1,sizeof(dep));
		memset(dv,0,sizeof(dv));
		memset(par,-1,sizeof(par));
		for(int i=0;i<n-1;i++)
		{
			int uu,vv;
			scanf("%d%d",&uu,&vv);
			uu--,vv--;
			v[uu].push_back(vv);
			v[vv].push_back(uu);
		}
		dv[0]=1;
		dep[0]=0;
		dfs(0);
		for(int num=0;num<n;num++)
		{
			for(int lc=0;lc<n;lc++)
			{
				if(used[lc])
				{
					continue;
				}
				int succ=1;
				
				if(loc[num]==lc)
				{
					succ=0;
					continue;
				}
				
				for(int prev=0;prev<num;prev++)
				{
					int AA=loc[prev],BB=fn[prev],CC=loc[num],DD=lc;
					break;
				}
				
				if(succ)
				{
					used[lc]=1;
					fn[num]=lc;
					break;
				}
			}
		}
		for(int i=0;i<n;i++)
		{
			printf("%d ",fn[i]+1);
		}
		printf("\n");
	}
	return 0;
}

