#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<queue>
#define rint register int
#define maxn 200500
#define inf 1<<30
#define ll long long
#define de(x) cout<<#x<<' '<<x<<'\n';
#define clear(a) memset(a,0,sizeof(a));
using namespace std;

int n,m;
int ans=0;
int dis[maxn];
int head[maxn],cnt=0;
bool vis[maxn];

struct EDGE{
	int next;
	int to;
	int w;
}e[maxn];
struct NODE{
	int u;
	int d;
	friend bool operator < (const NODE &a,const NODE &b){
		return a.d>b.d;
	}
};

inline void read(int &x){
	char ch=getchar();int f=1;x=0;
	while(!isdigit(ch) && ch^'-') ch=getchar();
	if(ch=='-') f=-1,ch=getchar();
	while(isdigit(ch)) x=x*10+ch-'0',ch=getchar();
	x*=f;
}

inline void add(int u,int v,int w){
	++cnt;
	e[cnt].next=head[u];
	e[cnt].to=v;
	e[cnt].w=w;
	head[u]=cnt;
}

void dijkstra(int sta){
	memset(dis,0x3f,sizeof(dis));
	priority_queue<NODE> q;
	dis[sta]=0; q.push((NODE){sta,0});
	while(!q.empty()){
		NODE frt=q.top(); q.pop();
		int u=frt.u,d=frt.d;
		if(dis[u]!=d) continue;
		for(rint i=head[u];i;i=e[i].next){
			int v=e[i].to;
			if(dis[v]>dis[u]+e[i].w){
				dis[v]=dis[u]+e[i].w;
				q.push((NODE){v,dis[v]});
			}
		}
	}
}

int fp(int a,int b){
	int res=1,pow=1;
	while(b){
		if(b&1) pow=pow*pow;
		res=res*pow;
		b>>=1;
	}
	return res;
}

int main(){
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	printf("I am an OIer\n");
	return 0;
}






