#include<iostream>
#include<cstdio>

typedef unsigned long long ull;

int len, k, n, now, lst, tp;
ull m;

inline ull ksm(ull x, int p) {
	ull ret = 1;
	for (; p; p >>= 1, x *= x) if (p & 1) ret *= x;
	return ret;
}

int main() {
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);
	std::cin >> n >> m; 
	if (!m) {
		for (int i = 1; i <= n; ++i) putchar('0');
		putchar('\n');
		return 0;
	}
	++m;
	len = n - 1;
	while (len >= 0) {
		if (lst == 1) now = 1 - now;
		if (m > ksm(2, len)) putchar(1 - now + 48), m -= ksm(2, len), lst = 1 - now;
		else putchar(now + 48), lst = now;
		--len;
	}
	putchar('\n');
	return 0;
}
