#include<cstdio>
#include<cstring>
#include<algorithm>
#define MaxM 4010
#define MaxN 2010

struct node {
	int idx, val;
	bool operator < (const node &rhs) const {
		return idx < rhs.idx;
	}
} a[MaxN], t[MaxN];
struct edge {int u, v;} e[MaxM];

int T, n, per[MaxN], x, y, ans[MaxN], head[MaxN], tot;
bool better;

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	scanf("%d", &T);
	for (; T; T--) {
		scanf("%d", &n);
		for (int i = 1; i <= n; ++i) scanf("%d", &a[i].val), a[i].idx = i;
		for (int i = 1; i < n; ++i) {
			per[i] = i;
			scanf("%d %d", &e[i].u, &e[i].v);
		}
		if (n <= 10) {
			memset(ans, 0x3f, sizeof ans);
			do {
				better = 0;
				for (int i = 1; i <= n; ++i) t[i] = a[i];
				for (int i = 1; i < n; ++i) std::swap(t[e[per[i]].u].idx, t[e[per[i]].v].idx);
				std::sort(t + 1, t + n + 1); 
				for (int i = 1; i <= n; ++i)
					if (t[i].val < ans[i]) {better = 1; break;}
					else if (t[i].val > ans[i]) break;
				if (better)
					for (int i = 1; i <= n; ++i) ans[i] = t[i].val;
			} while (std::next_permutation(per + 1, per + n));
			for (int i = 1; i < n; ++i) printf("%d ", ans[i]);
			printf("%d\n", ans[n]);
		}
	}
	return 0;
}
