#include <bits/stdc++.h>
using namespace std;
typedef long long lint;
typedef unsigned int uint;
typedef unsigned long long ulint;
typedef pair<int, int> pii;
typedef pair<lint, lint> pll;
#define endl '\n'
#define fst first
#define sed second
#define pb push_back
#define mp make_pair
#define SZ(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rep(it, ff, ee) for (int it = (ff); it <= (ee); ++it)
#define per(it, ff, ee) for (int it = (ff); it >= (ee); --it)
const int MAXN = 2020;
const int INF = 0x3f3f3f3f;
int pl[MAXN], n;
pii eg[233];
vector<int> edge[MAXN];
namespace BF {
	int ans[MAXN], res[MAXN], ep[MAXN], inp[MAXN];
	inline void check_ans() {
		rep (i, 1, n) {
			if (ans[i] < res[i]) return;
			else if (ans[i] > res[i]) {
				rep (j, 1, n) {
					ans[j] = res[j];
				}
				return;
			}
		}
	}
	inline void dfs(int las) {
		if (las == 0) {
			check_ans();
			return;
		}
		rep (i, 1, las) {
			swap(ep[i], ep[las]);
			int u = eg[ep[las]].fst;
			int v = eg[ep[las]].sed;
			swap(res[inp[u]], res[inp[v]]);
			swap(inp[u], inp[v]);
			dfs(las - 1);
			swap(inp[u], inp[v]);
			swap(res[inp[u]], res[inp[v]]);
			swap(ep[i], ep[las]);
		}
	}
	inline void solve() {
		if (n == 1) {
			printf("1\n");
			return;
		}
		rep (i, 1, n) {
			ans[i] = n - i + 1;
		}
		rep (i, 1, n) {
			res[i] = pl[i];
			inp[pl[i]] = i;
		}
		rep (i, 1, n - 1) {
			ep[i] = i;
		}
		dfs(n - 1);
		rep (i, 1, n) {
			printf("%d", ans[i]);
			printf(i != n ? " " : "\n");
		}
	}
}
inline int isLink() {
	int st = 0;
	rep (i, 1, n) {
		if (SZ(edge[i]) > 2) {
			return 0;
		} else if (SZ(edge[i]) == 1) {
			st = i;
		}
	}
	return st;
}
namespace Subtask2 {
	vector<int> order, fu;
	int id[MAXN], ep[MAXN], pr[MAXN], pp[MAXN];
	inline void dfs(int u, int p, int dep) {
		id[dep] = u;
		rep (i, 0, SZ(edge[u]) - 1) {
			int v = edge[u][i];
			if (v != p) dfs(v, u, dep + 1);
		}
	}
	inline void solve() {
		order.clear();
		int st = isLink();
		dfs(st, 0, 1);
		rep (i, 1, n) {
			ep[i] = 0;
			pr[id[i]] = i;
			pp[pl[i]] = i;
		}
		ep[0] = ep[n] = 1;
		rep (ID, 1, n) {
			int now = pl[ID];
		//	if (ID == 1) cerr << "Now = " << now << endl;
			int w = pr[now];
		//	if (ID == 1) cerr << "w = " << w << endl;
			int lm = INF, rm = INF;
			if (!ep[w]) rep (i, w + 1, n) { // find right min
				rm = min(rm, id[i]);
				if (ep[i] == 1) break;
			}
			if (!ep[w - 1]) per (i, w - 1, 1) { // find left min
				lm = min(lm, id[i]);
				if (ep[i - 1] == 1) break;
			}
		//	if (ID == 9) cerr << "pos9 = " << w << endl;
			//cerr << ID << " : " << lm << ' ' << rm << endl;
		//	if (ID == 1) cerr << "Rm = " << rm << ' ' << lm << endl;
			if (min(lm, rm) == INF) continue;
			else if (lm < rm) {
				int eps = pr[lm];
				/*if (ep[eps - 1] == 0) {
					ep[eps - 1] = 1;
					swap(pp[id[eps]], pp[id[eps - 1]]);
					swap(pl[pp[id[eps]]], pl[pp[id[eps - 1]]]);
				}*/
				per (i, w, eps + 1) {
					if (i == eps + 1) {
						ep[i - 1] = 1;
						order.pb(i - 1);
						break;
					}
					ep[i - 1] = 1;
					swap(pp[id[i]], pp[id[i - 1]]);
					swap(pl[pp[id[i]]], pl[pp[id[i - 1]]]);
				}
			} else {
				int eps = pr[rm];
				/*if (ep[eps] == 0) {
					ep[eps] = 1;
					swap(pp[id[eps]], pp[id[eps + 1]]);
					swap(pl[pp[id[eps]]], pl[pp[id[eps + 1]]]);
				}*/
				rep (i, w, eps - 1) {
					if (i == eps - 1) {
						ep[i] = 1;
						order.pb(i);
						break;
					}
					ep[i] = 1;
					swap(pp[id[i]], pp[id[i + 1]]);
					swap(pl[pp[id[i]]], pl[pp[id[i + 1]]]);
				}
			}
		}
		reverse(all(order));
		rep (i, 0, SZ(order) - 1) {
			int nm = order[i];
			swap(pp[id[nm]], pp[id[nm + 1]]);
			swap(pl[pp[id[nm]]], pl[pp[id[nm + 1]]]);
		}
		rep (i, 1, n) {
			printf("%d", pl[i]);
			printf(i != n ? " " : "\n");
		}
	}
}
inline void solve() {
	scanf("%d", &n);
	rep (i, 1, n) {
		edge[i].clear();
		scanf("%d", pl + i);
	}
	rep (i, 2, n) {
		int u, v;
		scanf("%d%d", &u, &v);
		edge[u].push_back(v);
		edge[v].push_back(u);
		if (n <= 10) {
			eg[i - 1].fst = u;
			eg[i - 1].sed = v;
		}
	}
	if (n <= 10) {
		BF :: solve();
//		Subtask2 :: solve();
		return;
	} else if (isLink()) {
		Subtask2 :: solve();
	} else {
		puts("-1");
	}
}
int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int T;
	scanf("%d", & T);
	while (T--) solve();
	return 0;
}
