#include<iostream>
#include<cstdio>
#include<cstdlib>
using namespace std;

const long MN=500001;

long n=0;
long fa[MN]={0},child[MN]={0},next[MN]={0},childcnt[MN]={0};
long cnt=0;	//How much of goodsub is used
long goodsub[MN*4]={0},shift=MN*2,blockedsub[MN];
long finalans=0,currsum=0;
	
bool tval[MN];

int fastin()
{
	char ch=getchar();
	int sum;
	while(ch<'0'||ch>'9')
	{
		ch=getchar();
	}
	while(ch>='0'&&ch<'9')
	{
		sum=sum*10+ch-'0';
		ch=getchar();
	}
	
	return sum;
}

void inline addside(long i,long father)
{
	fa[i]=father;
	childcnt[father]++;
	if(child[father]==0)
		child[father]=i;
	else
	{
		long temp=child[father];
		while(next[temp]!=0)
			temp=next[temp];
		next[temp]=i;
	}
	//next[i]=0;
}

void inline progress(long num)
{
	if(tval[num])
	{
		goodsub[shift]++;
		shift--;
	}
	else
	{
		blockedsub[num]=goodsub[shift];
		goodsub[shift]=0;
		shift++;
	}
	currsum+=goodsub[shift];
	finalans^=num*currsum;
}

void inline regress(long num)
{
	currsum-=goodsub[shift];
	if(tval[num])
	{
		shift++;
		goodsub[shift]--;
	}
	else
	{
		shift--;
		goodsub[shift]+=blockedsub[num];
	}
}

void bianlizishu(long num)
{
	long achild=child[num];
	while(achild!=0)
	{
		progress(achild);
		bianlizishu(achild);
		regress(achild);
		achild=next[achild];
	}
}

int main()
{
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	scanf("%d",&n);
	char b=getchar();
	while(b!='('&&b!=')')
		b=getchar();
	if(b=='(')	//The last bracket will be otherwise lost out.
		tval[1]=true;
	else if(b==')')
		tval[1]=false;
	cout<<1<<b;
	for(long i=2;i<=n;i++)
	{
		b=getchar();
		if(b=='(')
			tval[i]=true;
		else //if(b==')')
			tval[i]=false;
	}
	for(long i=2;i<=n;i++)
	{
		long father;
		scanf("%d",&father);
		addside(i,father);
	}
	progress(1);
	bianlizishu(1);
	printf("%d",finalans);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
