#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
/* CHAIN
int b[1005];
int c[1005];
int a[1005];
int f[1005];

int main() {
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		char d;
		cin >> d;
		if (d == '(') c[i] = 0;
		else c[i] = 1;
	}
	for (int i = 1; i <= n; ++i) {
		if (c[i] == 0) b[i] = i;
		else b[i] = b[b[i - 1] - 1];
		
		if (c[i] == 0) a[i] = 0;
		else {
			if (b[i - 1] == 0) a[i] = 0;
			else a[i] = 1 + a[b[i - 1] - 1];
		}
		f[i] = f[i - 1] + a[i];
	//	if (c[i] == 0) f[i] = f[i - 1];
	//	else f[i] = f[i - 1] + a[i];
	}
	for (int i = 1; i <= n; ++i) {
		cout << b[i] << ' ';
	}
	cout << endl;
	for (int i = 1; i <= n; ++i) {
		cout << a[i] << ' ';
	}
	cout << endl;
	for (int i = 1; i <= n; ++i)
		cout << f[i] << ' ';
	return 0;
}

*/
int n;

namespace PART2 {
	const int MAXN = 500010;
	struct Edge {
		int v, nxt;
	}edge[MAXN * 2];
	int head[MAXN], cnt;
	int fa[MAXN];
	int a[MAXN], b[MAXN], c[MAXN];
	ll f[MAXN];
	inline void AddEdge(int u, int v) {
		edge[++cnt].v = v;
		edge[cnt].nxt = head[u];
		head[u] = cnt;
	}
	void dfs(int u) {
		if (c[u] == 0) b[u] = u;
		else b[u] = b[fa[b[fa[u]]]];
		if (c[u] == 0) a[u] = 0;
		else {
			if (b[fa[u]] == 0) a[u] = 0;
			else a[u] = 1 + a[fa[b[fa[u]]]];
		}
		if (c[u] == 0) f[u] = f[fa[u]];
		else f[u] = a[u] + f[fa[u]];
		for (int i = head[u]; i; i = edge[i].nxt) {
			int v = edge[i].v;
			dfs(v);
		}
	}
	void solve() {
		getchar();
		for (int i = 1; i <= n; ++i) {
			char d = getchar();
			if (d == '(') c[i] = 0;
			else c[i] = 1;
		}
		for (int u = 2; u <= n; ++u) {
			int v;
			scanf("%d", &v);
			fa[u] = v;
			AddEdge(v, u);
		}
		dfs(1);
		ll ans = 0;
		for (int i = 1; i <= n; ++i) {
			ans ^= 1ll * i * f[i];
		}
		printf("%lld", ans);
	}
}
/*
7
()()())
1 2 3 3 5 6

*/
int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	scanf("%d", &n);
	PART2::solve();
	return 0;
}

