#include<iostream>
#include<cstdio>
#include<algorithm>
#include<queue>
#include<set>
#include<map>
#include<cmath>
#include<cstdlib>
using namespace std;

typedef long long ll;

const int MAXINT=2147483647;
const int INF=0x3f3f3f3f;
const ll INFLL=0x3f3f3f3f3f3f3f3f;
const double EPS=1e-6;
const int MAXN=70;

int read(){
	int s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

int readu(){
	int s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

ll readll(){
	ll s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

ll readull(){
	ll s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

unsigned long long n,k,now,pow2[MAXN];
bool rev;

void init(int maxn){
	pow2[0]=1;
	for (register int i=1;i<maxn;++i){
		pow2[i]=pow2[i-1]*2;
	}
	return;
}

int main(){
	freopen("code.in","r",stdin);
	freopen("code.out","w",stdout);
	cin>>n>>k;
	now=k;
	init(n);
	rev=0;
	now=k;
	for (register int i=n;i>=1;--i){
		if (rev){
			if (now<pow2[i-1]){
				rev=0;
				printf("1");
			}
			else{
				now-=pow2[i-1];
				printf("0");
			}
		}
		else{
			if (now<pow2[i-1]){
				printf("0");
			}
			else{
				rev=1;
				now-=pow2[i-1];
				printf("1");
			}
		}
	}
	return 0;
}

