#include<bits/stdc++.h>
#define ll long long
#define MAXN 500010
#define MAXLOG 20

using namespace std;

int n;
int f[MAXN][MAXLOG];
int a[MAXN];
int b[MAXN];
ll ans , lans;
ll s;

struct wzy{
	int t , nxt;
} edge[MAXN];
int Head[MAXN] , cnt;

template <typename T> inline void read(T &x) {
	x = 0; T f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}

template <typename T> inline void chkmax(T &x , T y) {x = x > y ? x : y; }
template <typename T> inline void chkmin(T &x , T y) {x = x < y ? x : y; }

template <typename T> inline void print(T x) {
	if (x > 9) print(x / 10);
	putchar(x % 10 + '0');
}
template <typename T> inline void write(T x) {
	if (x < 0) {x = -x; putchar('-'); }
	print(x);
	putchar('\n');
}

inline void file() {
	freopen("brackets.in" , "r" , stdin);
	freopen("brackets.out" , "w" , stdout);
}

inline void Addedge(int u , int v) {
	edge[++cnt].nxt = Head[u];
	edge[cnt].t = v;
	Head[u] = cnt;
}

inline void dfs1(int u , int fa) {
	f[u][0] = fa;
	for (int i = 1; i < MAXLOG; i++) {
		f[u][i] = f[f[u][i - 1]][i - 1];
	} 
	
	for (int i = Head[u]; i; i = edge[i].nxt) {
		int v = edge[i].t;
		dfs1(v , u);
	}
}

inline int chck(int u , int k) {
	for (int i = MAXLOG - 1; i >= 0; i--) {
		if (k >= (1 << i)) {
			u = f[u][i];
			k -= (1 << i);
		}
	}
	return u;
}

inline void dfs2(int u , int fa , int l , int r , int c) {
	if (a[u] == 1) {
		if (a[fa] == 1) {
			l++;
		}
		else {
			r = 0;
			l = 1;
		}
	}
	else {
		r++;
	}
	if (l > 0 && r > 0 && r <= l) {
		c = 1;
	}
	else c = 0;
	if (c == 1) c += b[chck(u , 2 * r)];
	b[u] = c;
	ans += c;
	lans ^= (u * ans);
	for (int i = Head[u]; i; i = edge[i].nxt) {
		int v = edge[i].t;
		dfs2(v , u , l , r , c);
	}
	ans -= c;
}

int main() {

	file();

	read(n);
	
	for (int i = 1; i <= n; i++) {
		char c = getchar();
		if (c == '(') a[i] = 1;
		else a[i] = 2;
	}
	
	for (int i = 2; i <= n; i++) {
		int v;
		read(v);
		Addedge(v , i);
	}
	dfs1(1 , 0); 
	dfs2(1 , 0 , 0 , 0 , 0);
	
	write(lans);

	return 0;

}

