#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cctype>
#include <vector>
using namespace std;

typedef long long ll;
const int maxn = 5e5 + 17;
int n, a[maxn], fa[maxn];
vector<int> sn[maxn];
char str[maxn];
int flg = 1;
ll ans;
ll cnt[maxn], sum[maxn], suml[maxn], sumr[maxn];

void fileio() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
}

void sp() {
	for(int l = 1; l <= n; l++) {
		suml[l - 1] = sumr[l - 1] = 0;
		for(int r = l; r <= n; r++) {
			suml[r] = suml[r - 1], sumr[r] = sumr[r - 1];
			if(a[r] == 0) suml[r]++;
			else sumr[r]++;
			if(sumr[r] > suml[r]) break;
			if(sumr[r] == suml[r]) cnt[r]++;
		}
	}
	for(int i = 1; i <= n; i++) sum[i] = sum[i - 1] + cnt[i];
//	for(int i = 1; i <= n; i++) cout << sum[i] << endl;
	for(int i = 1; i <= n; i++) ans ^= 1ll * i * sum[i];
}

int main() {
	fileio();
	scanf("%d", &n);
	scanf("%s", str + 1);
	for(int i = 1; i <= n; i++) {
		if(str[i] == '(') a[i] = 0;
		else if(str[i] == ')') a[i] = 1;
	}
	for(int i = 2; i <= n; i++) {
		scanf("%d", &fa[i]);
		sn[fa[i]].push_back(i);
		if(fa[i] != i - 1) flg = 0;
	}
	
	if(flg == 1 && n <= 2000) sp();
	printf("%lld\n", ans);
	return 0;
}

