#include <cstdio>
#include <climits>
using namespace std;

unsigned long long ans;
void solve(int n, unsigned long long i, unsigned long long nj){
	unsigned long long nnj = ((nj-1)>>1)+1;
	if(n == 64)
		nnj = 1ull<<63;
	if(n == 0) 
		return ;
//	cerr<<n<<" "<<i<<" "<<nj<<endl; 
	
	ans<<=1;
	if(i >= nnj){
		ans |= 1;
//		cerr<<">> "<<n-1<<" "<<nnj-(i-nnj)-1<<" "<<nnj<<endl; 
		solve(n-1, nnj-(i-nnj)-1, nnj);
	}else{
		solve(n-1, i, nnj);
	}
}

unsigned long long pow2(int k){
	unsigned long long a = 1;
	return a<<k;
}

int main(){
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);
	
	int n;
	unsigned long long k;
	scanf("%d%llu", &n, &k);
	unsigned long long p = pow2(n);
	solve(n, k, p);
	
	p = ((p-1)>>1)+1;
	if(n == 64)
		p = 1ull<<63;
	for(int i=0; i<n; i++){
		printf("%d", ((ans&p) == p)?1:0);
		p>>=1;
	}
	return 0;
}
