#include <iostream>
#include <cstdio>
#include <vector>
#define MAXN 100002

using namespace std;

int n;
bool data[MAXN];
int father[MAXN];
vector<int> children[MAXN];
char tmp_ch = '(';
long long ans = 0;
long long f[MAXN];

void dfs_find_substr(int i, int stack, int* rslt) {
	if (stack < 0) return;
	if (stack == 0) *rslt = *rslt + 1;
	
	if (i == 0) return;
	
	if (data[i] == true) {
		dfs_find_substr(father[i], stack + 1, rslt);
	} else {
		dfs_find_substr(father[i], stack - 1, rslt);
	}
}

void dfs(int i) {
	
	if (i == 1) f[i] = 0;
	else if (data[i] == false) f[i] = f[father[i]];
	else {
		int rslt = -1;
		dfs_find_substr(i, 0, &rslt);
		f[i] = f[father[i]] + rslt;
	}
	
	ans ^= i * f[i];
	
	for (vector<int>::iterator it = children[i].begin(); it != children[i].end(); ++ it) {
		dfs(*it);
	}
	
}

int main() {
	
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	
	cin >> n; 
	
	for (register int i = 1; i <= n; ++ i) {
		cin >> tmp_ch;
		if (tmp_ch == '(') data[i] = false;
		else if (tmp_ch == ')') data[i] = true;
	}
	
	for (register int i = 2; i <= n; ++ i) {
		cin >> father[i];
		children[father[i]].push_back(i);
	}
	
	dfs(1);
	
	cout << ans;
	
	return 0;
	
}
