#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <map>
#include <cstring>

using namespace std;

int n;
vector<pair<int, int> > borders;
string str;
string minstr;
bool vis[100002] = {false};

void dfs(int depth) {
	if (depth == n - 1) {
		if (str <= minstr) {
			minstr = str;
		}
	}
	for (int i = 0; i < borders.size(); ++ i) {
		if (!vis[i]) {
			vis[i] = true;
			swap(str[borders[i].first], str[borders[i].second]);
			dfs(depth + 1);
			swap(str[borders[i].first], str[borders[i].second]);
			vis[i] = false;
		}
	}
}

void solve() {
	
	cin >> n;
	
	borders.clear();
	
	str.clear();
	str.resize(n + 1);
	
	minstr.resize(n + 1);
	minstr[0] = 0;
	minstr[1] = 245;
		
	memset(vis, 0, sizeof(vis));
	
	str[0] = 0;
	
	for (int i = 1; i <= n; ++ i) {
		int num;
		cin >> num;
		str[i] = num;
	}
	
	for (int i = 1; i < n; ++ i) {
		int from, to;
		cin >> from >> to;
		borders.push_back(make_pair(from, to));
	}
	
	dfs(0);
	
	for (int i = 1; i < minstr.length(); ++ i) {
		cout << (int) minstr[i] << ' ';
	}
	
	cout << endl;
	
}

int main() {
	
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	
	int T; cin >> T;
	
	while (T --) {
		solve();
	}
	
	return 0;
	
} 
