#include <bits/stdc++.h>
using namespace std;

typedef pair<int,int> pii;
typedef long long ll;

template<class T>ostream& operator<<(ostream& out,vector<T> _v){for(int i=0;i<_v.size();++i)out<<_v[i]<<' ';return out;}
template<class T1,class T2>ostream& operator<<(ostream& out,pair<T1,T2> P){out<<P.first<<' '<<P.second;return out;}

const ll mod=1e9+7;
const int maxn=2005;

int n;
int a[maxn],b[maxn],c[maxn],d[maxn];
int stk[maxn],tp;
int res[maxn];
bool ok[maxn];
pii edge[maxn];
vector<int> G[maxn];

bool cmp(){
	for(int i=0;i<n;++i){
		if(res[i]!=d[i])return d[i]<res[i];
	}
	return false;
}

void solve1(){
	for(int i=0;i<n-1;++i)c[i]=i+1;
	for(int i=0;i<n;++i)res[i]=1e9;
	do{
		for(int i=0;i<n;++i)b[i]=a[i];
		for(int i=0;i<n-1;++i){
			int x=edge[c[i]-1].first,y=edge[c[i]-1].second;
			int tmp=b[x];
			b[x]=b[y];
			b[y]=tmp;
		}
		for(int i=0;i<n;++i){
			d[b[i]]=i+1;
		}
		for(int i=0;i<n;++i)cerr<<d[i]<<' ';
		cerr<<endl;
		if(cmp())for(int i=0;i<n;++i)res[i]=d[i];
	}while(next_permutation(c,c+n-1));
	for(int i=0;i<n;++i)printf("%d ",res[i]);
	puts("");
}

void dfs(int x,int p=-1){
	stk[tp++]=x;
	for(int i=0;i<G[x].size();++i){
		int v=G[x][i];
		if(v==p)continue;
		dfs(v,x);
	}
}

void solve2(){
	for(int i=0;i<n-1;++i)G[edge[i].first].push_back(edge[i].second),G[edge[i].second].push_back(edge[i].first);
	int start=-1,ed=-1;
	for(int i=0;i<n;++i){
		if(G[i].size()==1){
			if(start==-1)start=i;
			else ed=i;
		}
	}
	for(int i=0;i<n;++i){
		b[i]=a[stk[i]];
	}
	for(int i=0;i<n;++i){
		if(!((i>0&&ok[i-1])||(i<n-1&&!ok[i+1])))continue;
		int mni=-1;
		for(int j=i-1;j>=0;--j){
			if(!ok[j])break;
			if(mni==-1||b[j]<b[mni])mni=j;
		}
		for(int j=i;j<n-1;++j){
			if(!ok[j])break;
			if(mni==-1||b[j+1]<b[mni])mni=j+1;
		}
		if(mni==-1)continue;
		if(mni<i){
			for(int j=mni;j<i;++j){
				swap(b[j],b[j+1]);
				ok[j]=false;
			}
		}else{
			for(int j=i;j<mni;++j){
				swap(b[j],b[j+1]);
				ok[j]=false;
			}
		}
	}
	for(int i=0;i<n;++i){
		printf("%d ",b[i]);
	}
	puts("");
}

void MAIN(){
	cin>>n;
	for(int i=0;i<n;++i)cin>>a[i],a[i]--;
	for(int i=0;i<n-1;++i){
		int x,y;
		cin>>x>>y;
		--x,--y;
		edge[i]=pii(x,y);
	}
	if(n<=10)solve1();
	else solve2();
}

int main(){
//	freopen("tree2.out","w",stderr);
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	int T;
	cin>>T;
	while(T--){MAIN();}
	return 0;
}

// DETERMINATION -_-

