#include <cstdio>
typedef long long int extra;
const int SIZE = 500005;
struct edge
{
	int t, n;
	edge(int _t = 0, int _n = 0)
	{
		this -> t = _t, this -> n = _n;
	}
} e[SIZE];
struct element
{
	int p;
	char c;
	element(int _p = 0, char _c = ' ')
	{
		this -> p = _p, this -> c = _c;
	}
};
extra f[SIZE], tot[SIZE], ans;
int h[SIZE], fa[SIZE], cnt, top, n;
char c[SIZE];
element stk[SIZE];
inline void add_edge(const int &x, const int &y)
{
	e[++cnt] = edge(y, h[x]), h[x] = cnt;
}
void search(int x)
{
	for (int i = h[x]; i; i = e[i].n)
	{
		int y = e[i].t;
		if (c[y] == '(')
		{
			f[y] = 0;
			tot[y] = tot[x];
			stk[++top] = element(y, '(');
			search(y);
			top--;
		}
		else if (c[y] == ')')
		{
			if(top && stk[top].c == '(')
			{
				int p = stk[top].p, z = fa[p];
				f[y] = f[z] + 1;
				tot[y] = tot[x] + f[y];
				top--;
				search(y);
				stk[++top] = element(p, '(');
			}
			else
			{
				f[y] = 0;
				tot[y] = tot[x];
				stk[++top] = element(y, ')');
				search(y);
				top--;
			}
		}
	}
}
int main()
{
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	scanf("%d%s", &n, c + 1);
	f[1] = 0, add_edge(0, 1);
	for (int i = 2, x; i <= n; i++)
	{
		scanf("%d", &x);
		fa[i] = x;
		add_edge(x, i);
	}
	search(0);
	for (int i = 1; i <= n; i++) ans ^= ((extra)(i) * tot[i]);
	printf("%lld\n", ans);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
