#include<cstdio>
#include<cctype>
#include<cstring>
#include<vector>
#include<stack>
#include<map>
#include<algorithm>
template<typename tn> void fead(tn &n) {
	tn i = 1, f = 1, k = 0; char ch = getchar();
	while (!isdigit(ch)) {if (ch == '-') f = -1; ch = getchar();}
	while (isdigit(ch)) k = k * 10 + ch - '0', ch = getchar();
	if (ch == '.') {ch = getchar(); while (isdigit(ch)) i /= 10, k += i * (ch - '0'), ch = getchar();}
	n = k * f;
}
int n, fa[600010], st[600010], len[600010], depth[600010], rt[600010], all_sz = 0;
long long sum[600010], ans = 0;
char S[600010];
std::vector<int> son[600010];
std::stack<int> lb;
struct brackets{
	int len, l, r;
}tmpb;
struct Segment_tree{
	int lc, rc, l, r;
	brackets x;
}T[8000010];
int build(int l, int r) {
	int p = ++all_sz;
	T[p].l = l; T[p].r = r;
	if (T[p].l == T[p].r) return p;
	int mid = (l + r) >> 1;
	T[p].lc = build(l, mid);
	T[p].rc = build(mid + 1, r);
	return p;
}
brackets query(int p, int x) {
	if (T[p].l == T[p].r) return T[p].x;
	int mid = (T[p].l + T[p].r) >> 1;
	if (x <= mid) return query(T[p].lc, x);
	if (x > mid) return query(T[p].rc, x);
}
int modify(int p, int pos, brackets x) {
	int u = ++all_sz;
	T[u] = T[p];
	if (T[u].l == T[u].r) {
		T[u].x = x;
		return u;
	}
	int mid = (T[p].l + T[p].r) >> 1;
	if (pos <= mid) T[u].lc = modify(T[p].lc, pos, x);
	if (pos > mid) T[u].rc = modify(T[p].rc, pos, x);
	return u;
}
std::stack<brackets> rb;
void init(int u) {
	for (int i = 0; i < son[u].size(); i++) {
		depth[son[u][i]] = depth[u] + 1;
		init(son[u][i]);
	}
}
void work(int u) {
	int flag = -1;
	st[u] = st[fa[u]]; len[u] = len[fa[u]]; sum[u] = sum[fa[u]]; rt[u] = rt[fa[u]];
	if (S[u] == '(') lb.push(depth[u]);
	if (S[u] == ')') {
		if (lb.empty()) st[u] = depth[u];
		else {
			int tmp = 0;
			while (len[u] && query(rt[u], len[u]).l > lb.top() && query(rt[u], len[u]).l > st[u]) len[u]--;
			tmpb.len = 1; tmpb.l =  lb.top(); tmpb.r = depth[u];
			flag = lb.top();
			lb.pop();
			while (len[u] && query(rt[u], len[u]).r == tmpb.l - 1) {
				brackets tmpp = query(rt[u], len[u]);
				tmpb.len += tmpp.len;
				sum[u] -= (long long)(tmpp.len) * (tmpp.len + 1) / 2;
				tmpb.l = tmpp.l;
				len[u] --;
			}
			sum[u] += (long long)tmpb.len * (tmpb.len + 1LL) / 2LL;
			len[u]++;
			rt[u] = modify(rt[fa[u]], len[u], tmpb);
		}
	}
	for (int i = 0; i < son[u].size(); i++)
		work(son[u][i]);
	if (flag > 0) lb.push(flag);
	if (S[u] == '(') lb.pop();
}
int main() {
	freopen("brackets.in", "r", stdin);
	freopen("brackets.out", "w", stdout);
	fead(n);
	scanf("%s", S + 1);
	for (int i = 2; i <= n; i++) {
		fead(fa[i]);
		son[fa[i]].push_back(i);
	}
	depth[1] = 1;
	init(1);
	st[0] = 0; fa[1] = 0; len[0] = 0;
	rt[0] = build(1, n);
	work(1);
	for (int i = 1; i <= n; i++)
		ans ^= (long long) i * sum[i];
	printf("%lld\n", ans);
	return 0;
}
