#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int,int>
#define PB push_back
#define MP make_pair

const int MaxLog = 21;
const int Maxn = 500000;

struct Node
{
	int id;
	int dep;
	char c;
	Node()
	{
		id = dep = 0;
		c = 0;
	}
	Node(int _id,char _c)
	{
		id = _id;
		c = _c;
	}
}tr[Maxn + 5];

int n;
int fa[Maxn + 5][MaxLog + 1];
int dp[Maxn + 5],f[Maxn + 5],s[Maxn + 5];
vector<int> v[Maxn + 5];

void predfs(int x,int p)
{
	tr[x].dep = tr[p].dep + 1;
	for(int i=0;i<v[x].size();i++) {
		predfs(v[x][i],x);
	}
}

int par(int x,int tarDep) {
	if(tarDep > tr[x].dep) return -1;
	for(int i=MaxLog;i>=0;i--) {
		if(tr[fa[x][i]].dep >= tarDep) {
			x = fa[x][i];
		}
	}
	return x;
}

void calc_par()
{
	for(int i=1;i<=MaxLog;i++) {
		for(int j=1;j<=n;j++) {
			fa[j][i] = fa[fa[j][i-1]][i-1];
		}
	}
}

void dfs(int x,int p)
{
	if(tr[x].c == '(') {
		f[x] = 0;
		dp[x] = dp[p];
		s[x] = 0;
	} else {
		if((tr[p].dep == f[p])) {
			f[x] = 0;
			dp[x] = dp[p];
			s[x] = 0;
		} else if(tr[par(x,tr[x].dep-1-f[p])].c == ')'){
			f[x] = 0;
			dp[x] = dp[p];
			s[x] = 0;
		} else {
			int pre = par(x,tr[x].dep-2-f[p]);
			f[x] = f[pre] + f[p] + 2;
			s[x] = 1 + s[pre];
			dp[x] = dp[p] + s[x];
		}
	}
	for(int i=0;i<v[x].size();i++) {
		dfs(v[x][i],x);
	}
}

long long ans =0;

int main()
{
	ios::sync_with_stdio(false);
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	cin>>n;
	char buffer;
	for(int i=1;i<=n;i++) {
		cin>>buffer;
		tr[i] = Node(i,buffer);
	}
	for(int i=2;i<=n;i++) 
	{
		cin>>fa[i][0];
		v[fa[i][0]].push_back(i);
	}
	predfs(1,0);
	calc_par();
	dfs(1,0);
//	for(int i=1;i<=n;i++) 
//	{
//		cout<<"i:"<<i<<"  "<<"dp: "<<dp[i]<<" "<<f[i]<<endl;
//	}
	for(int i=1;i<=n;i++) {
		ans = ans ^ (1ll * i * dp[i]);
	}
	cout<<ans<<endl;
	return 0;
}
