#include<cstdio>
#include<vector>
#include<algorithm> 
#include<string>
#include<iostream>
using namespace std;
int n;

namespace solve1 {
	void solve() {
		//next_permutation
		vector<int>opt;
		int edge[2005][2];
		vector<pair<int, int> >abase;
		string ans = "";
		abase.resize(n + 1);
		for(int i = 1; i <= n; ++i) {
			int r;
			scanf("%d", &r);
			abase[r] = make_pair(i, r);
			opt.push_back(i);
		}
		opt.pop_back();
		for(int i = 1; i < n; ++i) {
			scanf("%d %d", &edge[i][0], &edge[i][1]);
		}
		do {
			vector<pair<int, int> >a = abase;
			for(int i = 0; i < (int)opt.size(); ++i) {
				swap(a[edge[opt[i]][0]].first, a[edge[opt[i]][1]].first);
			}
			sort(a.begin() + 1, a.end());
			string tmp = "";
			for(int i = 1; i <= n; ++i)
				tmp += (char)a[i].second;
			if(ans == "") ans = tmp;
			else ans = min(ans, tmp); 
		} while(next_permutation(opt.begin(), opt.end()));
		for(int i = 0; i < n; ++i)
			printf("%d ", ans[i]);
		printf("\n");
	}
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);
	int T;
	scanf("%d", &T);
	for(; T--;) {
		scanf("%d", &n);
		if(n <= 10) {
			solve1::solve();
			continue;
		}
		vector<int>fxxk;
		for(int i = 1; i <= n; ++i) {
			fxxk.push_back(i);
		}
		random_shuffle(fxxk.begin(), fxxk.end());
		for(int i = 0; i < n; ++i)
			printf("%d ", fxxk[i]);
		printf("\n");
	}
	return 0;
}

