#include<iostream>
#include<cstring>
#include<string>
#include<cstdio>
#include<fstream>
#include<stack>
#include<algorithm>
#define N 5000000
using namespace std;
int n;
string a[N];
int head[N],cnt;
long long num[N];
struct tnode{
	int v,next;
}edge[N];
bool vis[N];
long long ans = 0;
void add(int u,int v){
	edge[++cnt].v=v;
	edge[cnt].next=head[u],head[u]=cnt;
}
bool check(int l , int r , string s){
	stack<int>q;
	for (int i = l ; i <= r ; ++ i){
		if(s[i] =='(') {
			q.push(1);
		}
		if(s[i] == ')'){
			if(!q.size()) return false;
			else q.pop() ;
		}
	}
	if(q.size()) return false;
	else return true;
}
int work(string s){
	int l = 0 , r = s.size() - 1;
	long long total = 0;
	for (int i = 0 ; i <= r ; ++ i)
	   for (int j = i ; j <= r ; ++ j){
	   	  if (check(i,j,s)) total ++;
	   }
	return total;
}
void dfs(int x,string now){
	vis[x] = 1;
	 num[x] = work(now);
	for (int i = head[x] ; i ; i =edge[i].next){
		int y=edge[i].v;
		if(!vis[y]){
			vis[y] = 1;
			dfs(y,now+a[y]) ;
		}
	}
}
int main(){
	freopen("brackets.in","r",stdin);
	freopen("brackets.out","w",stdout);
	cin >> n;
	for (int i = 1;  i <= n ; ++ i){
		char c;
		cin >> c;
		a[i] +=c;
	}
	for (int i = 1; i <= n - 1 ; ++ i){
		int x;
		cin >> x;
		add(i + 1,x);
		add(x,i + 1);
	}
		vis[1] = 1;
		dfs(1,a[1]);
		ans = 1*num[1];
	for (int i = 2; i <=n ; ++ i){
		ans = ans xor (i*num[i]);
	}
	cout << ans <<endl;
	return 0;
}
