#include<iostream>
#include<cstring>
#include<cstdio>
#include<fstream>
#include<stack>
#include<algorithm>
#define N 50000
using namespace std;
int t,n;
int num[N];
int use[N];
bool vis[2001][2001];
int mapn[2001][2001];
int ans[20001];
void clear(){
	memset(num,0,sizeof(num));
	memset(vis,0,sizeof(vis));
	memset(use,0,sizeof(use));
	memset(mapn,0,sizeof(mapn));
	memset(ans,0,sizeof(ans));
}
bool compare(){
	if(ans[1] == 0) return true;
	for (int i = 1 ; i <= n ; ++ i){
		if(ans[i] == use[i]) continue;
		if(ans[i] > use[i]) return true;
		if(ans[i] < use[i]) return false;
	}
	return false;
}
void dfs(int sum){
	if (sum == n - 1){
		if(compare()){
			for (int i =1 ;  i <= n ; i ++)
				ans[i] = use[i];
		}
		return ;
	}
	for (int i = 1 ; i <= n;  i ++){
		for(int j = i + 1; j <= n ; j ++){
			if(!vis[i][j]&&mapn[i][j]&&mapn[j][i]&&!vis[j][i]);
			vis[i][j] = 1,vis[j][i] = 1;
			swap(use[i],use[j]);
			dfs(sum + 1);
			swap(use[i],use[j]);
			vis[i][j] = 0; vis[j][i] = 0;
		}
	}
}
int main(){
	freopen("tree.in","r",stdin);
	freopen("tree.out","w",stdout);
	scanf("%d",&t);
	while(t--){
		clear();
		scanf("%d",&n);
		for (int i = 1 ; i <= n ; ++ i){
		   scanf("%d",&num[i]);
		   use[i] = num[i];
		}
		for (int i = 1 ; i <= n - 1 ; ++ i){
			int a,b;
			scanf("%d%d",&a,&b);
			mapn[a][b] = mapn[b][a] = 1;
		}
		for (int i = 1; i <= n ; ++i){
			for (int j = i + 1; j <= n ;++ j){
				memset(vis,0,sizeof(vis));
				vis[i][j] = 1;
				vis[j][i] = 1;
				for (int k = 1 ;k<= n ; ++ k) use[k] = num[k];	
				swap(use[i],use[j]);
				dfs(1);
			}
		}
		for (int i =1 ; i <= n ; ++ i)
		   cout << ans[i] <<" ";
		cout <<endl;
	}
	return 0;
}
/*
1
5
2 1 3 5 4
1 3
1 4
2 4
4 5
*/
